package com.jiaoyinbrother.monkeyking.activity

import android.content.Intent
import android.os.CountDownTimer
import android.text.TextUtils
import android.view.KeyEvent
import android.view.View
import android.view.View.OnClickListener
import com.jiaoyinbrother.monkeyking.CarEntity
import com.jiaoyinbrother.monkeyking.R
import com.jiaoyinbrother.monkeyking.util.SharedPreferencesUtil
import com.jiaoyinbrother.monkeyking.util.Util
import com.jybrother.sineo.library.base.BaseActivity
import com.jybrother.sineo.library.bean.AdInfoResult
import com.jybrother.sineo.library.bean.AdinfoBean
import com.jybrother.sineo.library.bean.WebViewConfigEntity
import com.jybrother.sineo.library.util.LogUtil
import kotlinx.android.synthetic.main.activity_adv.*

class ADActivity : BaseActivity(), OnClickListener {

//    private var mCountdownTv: TextView? = null
    private lateinit var mCountDownTimer: MyCountDownTimer;

    private var mPrev: Int = 0
    private val mContext = this

    override fun getLayoutId(): Int {
        return R.layout.activity_adv
    }


    override fun initView() {
//        mCountdownTv = findViewById(R.id.tv_countdown) as TextView

    }

    override fun initToolBar() {

    }

    override fun initListeners() {
        //        TODO 修改为按键
        //        mGoToLogin.setOnClickListener(this);
        bg_ad.setOnClickListener(this)
        tv_countdown.setOnClickListener(this)

    }

    private var mAdinfoBean: AdinfoBean? = null

    override fun initData() {
        //        mBgImg.setBackgroundResource(R.mipmap.splash_bg2);
        mAdinfoBean = Util.jsonToEntity(SharedPreferencesUtil.getInstance().adInfo, AdinfoBean::class.java) as AdinfoBean
        if (!TextUtils.isEmpty(mAdinfoBean?.pic)){
            bg_ad.setImageURI(mAdinfoBean?.pic)
        }
        mCountDownTimer = MyCountDownTimer(4999, 1000)
        mCountDownTimer.start()
    }

    private fun startMainActivity() {
        val intent = Intent(this@ADActivity, MonkeyMainActivity::class.java)
        startActivity(intent)
        finish()
    }

    override fun onClick(v: View?) {
        when(v?.id){
            R.id.bg_ad -> startAdH5()
            R.id.tv_countdown -> {
                mCountDownTimer.cancel()
                startMainActivity()
            }
        }

    }

    private fun startAdH5() {
        val webViewConfigEntity = WebViewConfigEntity()
        webViewConfigEntity.title = mAdinfoBean?.title
        webViewConfigEntity.url = mAdinfoBean?.url
        webViewConfigEntity.isNeedProgressBar = true

        startActivity(Intent(mContext, MonkeyMainActivity::class.java))
        val intent = Intent(mContext, GeneralWebViewActivity::class.java)
        intent.putExtra(CarEntity.FEATURE_ITEM, webViewConfigEntity)
        startActivity(intent)
        finish()
    }


    override fun onDestroy() {

        try {
            mCountDownTimer!!.cancel()
        } catch (e: Exception) {

        }

        super.onDestroy()
    }

    override fun onKeyDown(keyCode: Int, event: KeyEvent): Boolean {
        return false
    }

    private inner class MyCountDownTimer
    /**
     * @param millisInFuture    表示以毫秒为单位 倒计时的总数 例如 millisInFuture=1000 表示1秒
     * @param countDownInterval 表示 间隔 多少微秒 调用一次 onTick 方法 例如: countDownInterval =1000 ;
     * 表示每1000毫秒调用一次onTick()
     */
    (millisInFuture: Long, countDownInterval: Long) : CountDownTimer(millisInFuture, countDownInterval) {
        init {
            mPrev = 3
        }

        override fun onFinish() {
            tv_countdown.text = "正在跳转"
            startMainActivity()
        }

        override fun onTick(millisUntilFinished: Long) {
            val now = millisUntilFinished.toInt() / 1000
            if (now < mPrev) {
                mPrev = now
                tv_countdown.text = "跳过   " + now
            }
        }
    }
}
