package com.jiaoyinbrother.monkeyking.activity

import android.content.Intent
import android.graphics.drawable.ColorDrawable
import android.view.View
import android.view.ViewGroup
import android.webkit.URLUtil
import android.widget.PopupWindow
import com.camnter.easyrecyclerview.holder.EasyRecyclerViewHolder
import com.jiaoyinbrother.monkeyking.CarEntity
import com.jiaoyinbrother.monkeyking.R
import com.jiaoyinbrother.monkeyking.adapter.ActivitiesDiscountAdapter
import com.jiaoyinbrother.monkeyking.network.AppSetting
import com.jybrother.sineo.library.base.BaseActivity
import com.jybrother.sineo.library.bean.ActivitiesDiscountBean
import com.jybrother.sineo.library.bean.PromotionActivityBean
import com.jybrother.sineo.library.bean.WebViewConfigEntity
import com.jybrother.sineo.library.util.ConstantsUtil
import com.jybrother.sineo.library.util.LogUtil
import com.jybrother.sineo.library.util.UrlUtil
import com.jybrother.sineo.library.widget.ActivitiesDiscountDialog
import kotlinx.android.synthetic.main.activity_activities_discount.*

/**
 * Created by zhangbo on 2018/3/6.
 */
class ActivitiesDiscountActivity : BaseActivity(), EasyRecyclerViewHolder.OnItemClickListener {
    var dialog : ActivitiesDiscountDialog ?= null
    var list = ArrayList<ActivitiesDiscountBean>()
    var selectId : String ?= null
    override fun onItemClick(convertView: View?, position: Int) {
        if (position > 0){
            if (list[position].id != null){
                dialog?.show()
                dialog?.setContent(list[position].html, list[position].id)
            }else{
                showToast("活动优惠异常")
            }
        }else{
            val intent = Intent()
            intent.putExtra("activity_id", "")
            setResult(ConstantsUtil.CHOOSE_DISCOUNT, intent)
            finish()
        }
    }

    var adapter = ActivitiesDiscountAdapter(this)
    override fun getLayoutId(): Int {
        return R.layout.activity_activities_discount
    }

    override fun initView() {
        dialog = ActivitiesDiscountDialog(this,R.style.CheckVersionDialog)
    }

    override fun initToolBar() {
        mainTitle.text = "使用活动优惠"
        subTitle.text = "活动说明"
    }

    override fun initListeners() {
        adapter.setOnItemClickListener(this)
        dialog?.setListener(object :ActivitiesDiscountDialog.OnClickListener{
            override fun onOkClick(id :String) {
                val intent = Intent()
                intent.putExtra("activity_id", id)
                setResult(ConstantsUtil.CHOOSE_DISCOUNT, intent)
                finish()
            }

        })
        subTitle.setOnClickListener {
            useRules()
        }
    }

    override fun initData() {
        list = intent.getSerializableExtra("list") as ArrayList<ActivitiesDiscountBean>
        selectId = intent.getStringExtra("select")

        var item0 = ActivitiesDiscountBean()
        list.add(0,item0)
        LogUtil.e("list-->"+list.size)
        adapter.list = list
        activities_discount_recycler.adapter = adapter

        for (i in list.indices){
            if (list[i].id.equals(selectId)){
                adapter.setCheckedPosition(i)
                break
            }else{
                adapter.setCheckedPosition(0)
            }
        }


    }



    /**
     * use the rules H5
     * */
    private fun useRules() {
        val webViewConfigEntity = WebViewConfigEntity()
        webViewConfigEntity.title = "使用规则"
        webViewConfigEntity.url = AppSetting.getText_url() + UrlUtil.ACTIVITY_DISCOUNT_URL
        webViewConfigEntity.isNeedProgressBar = true
        webViewConfigEntity.isNeedShareButton = false
        webViewConfigEntity.imageUrl = ""
        webViewConfigEntity.description = ""

        val intent = Intent(this, GeneralWebViewActivity::class.java)
        intent.putExtra(CarEntity.FEATURE_ITEM, webViewConfigEntity)
        startActivity(intent)
    }

}