package com.jiaoyinbrother.monkeyking.activity

import android.content.Intent
import android.net.Uri
import android.view.View
import com.jiaoyinbrother.monkeyking.Constants
import com.jiaoyinbrother.monkeyking.R
import com.jiaoyinbrother.monkeyking.util.DialogUtil
import com.jybrother.sineo.library.base.BaseActivity
import com.jybrother.sineo.library.bean.OrderDetailResult
import com.jybrother.sineo.library.util.ConstantsUtil
import kotlinx.android.synthetic.main.activity_audit_result.*

/**
 * by Soda on 2018/2/1.
 */
class AuditResultActivity : BaseActivity() {

    private var status: Int? = null
    private var orderResult: OrderDetailResult? = null

    override fun getLayoutId(): Int {

        orderResult = intent?.getSerializableExtra("OrderResult") as OrderDetailResult
        status = orderResult?.return_car_image?.status_code//.getReturn_car_image().getStatus_code()= intent?.getIntExtra("AuditCode", 0)
        return R.layout.activity_audit_result
    }

    override fun initView() {
    }

    override fun initToolBar() {
        mainTitle.text = "审核结果"
    }

    override fun initListeners() {
    }

    override fun initData() {
        when (status) {
            0 -> {
                // 认证失败
                resultDataView.setEmptyData(R.mipmap.icon_xiaobai_re_authentication, "未通过审核", "很抱歉，您的照片未通过审核，您可在订单详情页中重新编辑并上传照片~", "")
                resultDataView.setPositiveButton("重新上传", View.OnClickListener {
                    val intent = Intent(this, TakingPicturesActivity::class.java)
                    intent.putExtra(Constants.FLAG_TAKING_PIC, TakingPicturesActivity.FLAG_RETURN_PIC)
                    intent.putExtra(Constants.KEY_ORDER_DETAIL, orderResult)
//                    intent.putExtra("isRemake", 1)// 1代表重拍 0代表正常
                    startActivity(intent)
                    finish()
                })
                resultDataView.setNegativeButton("联系客服", View.OnClickListener {
                    val intent = Intent(Intent.ACTION_CALL, Uri.parse("tel:" + DialogUtil.SERVICE_PHONE))
                    startActivity(intent)
                })
            }
            1 -> {
                // 认证通过
                resultDataView.setEmptyData(R.mipmap.icon_xiaobai_success, "通过审核", "让您久等了，您的照片已通过审核，您可在订单详情页中查看~", "")
                resultDataView.setNegativeButton("查看订单", View.OnClickListener { onBackPressed() })
            }
        }
    }

    override fun onBackPressed() {
        val intent = Intent(this@AuditResultActivity, OrderDetailActivity::class.java)
        intent.putExtra(ConstantsUtil.ORDER_ID, orderResult?.orderid)
        intent.flags = Intent.FLAG_ACTIVITY_CLEAR_TOP
        intent.addFlags(Intent.FLAG_ACTIVITY_SINGLE_TOP)
        startActivity(intent)
        super.onBackPressed()
    }

}