package com.jiaoyinbrother.monkeyking.activity

import android.annotation.SuppressLint
import android.content.Intent
import android.graphics.Color
import android.os.Bundle
import android.support.v4.content.ContextCompat
import android.text.*
import android.text.method.LinkMovementMethod
import android.text.style.ClickableSpan
import android.text.style.ForegroundColorSpan
import android.text.style.RelativeSizeSpan
import android.text.style.StrikethroughSpan
import android.util.DisplayMetrics
import android.view.View
import android.widget.CompoundButton
import android.widget.TextView
import com.baidu.mapapi.model.LatLng
import com.baidu.mapapi.utils.DistanceUtil
import com.jiaoyinbrother.monkeyking.CarEntity
import com.jiaoyinbrother.monkeyking.Constants
import com.jiaoyinbrother.monkeyking.R
import com.jiaoyinbrother.monkeyking.bean.*
import com.jiaoyinbrother.monkeyking.util.DialogUtil
import com.jiaoyinbrother.monkeyking.util.JsonConvertUtil
import com.jiaoyinbrother.monkeyking.util.SharedPreferencesUtil
import com.jiaoyinbrother.monkeyking.util.Util
import com.jiaoyinbrother.monkeyking.view.IOSdialog.IOSAlertDialog
import com.jiaoyinbrother.monkeyking.view.OptionalServiceView
import com.jybrother.sineo.library.base.BaseActivity
import com.jybrother.sineo.library.bean.*
import com.jybrother.sineo.library.presenter.CalcPresenterImpl
import com.jybrother.sineo.library.presenter.SubmitOrderPresenterImpl
import com.jybrother.sineo.library.util.*
import com.jybrother.sineo.library.view.GeneralViewInterface
import kotlinx.android.synthetic.main.activity_book.*
import kotlinx.android.synthetic.main.view_book_discount.*
import kotlinx.android.synthetic.main.view_book_time.*
import java.text.DecimalFormat
import java.util.*
import kotlin.collections.ArrayList

@SuppressLint("SetTextI18n")
class BookActivity : BaseActivity() {

    private var mDisplayMetrics: DisplayMetrics? = null
    private val df = DecimalFormat("0.0")
    private val spUtil = SharedPreferencesUtil.getInstance()
    private var mCarDetailResult: CarDetailResult? = null
    private var mCarDetailResultForH5: CarDetailResultForH5? = null
    private var mCalcResult: CalcResult? = null
    private var mCarSearchBean: CarSearchBean? = null
    private var takeSiteBean: SiteBean2? = null
    private var returnSiteBean: SiteBean2? = null

    //    private var isFirst = true
    private var isFromH5 = false
    private var requesting = false
    private var canBook: Boolean = false
    private var isNotRunCalc = false
    private var fromGiveCar: Boolean = false
    private var fromGetCar: Boolean = false
    private var isGiveCarOut = false
    private var isGetCarOut = false
    private var showNightService = true

    private var startTime: String? = null
    private var endTime: String? = null
    private var returnSiteCity: String? = null
    private var takeSiteName: String? = null
    private var returnSiteName: String? = null
    private var giveCarPoi: String? = null
    private var getCarPoi: String? = null
    private var giveServiceCharge: String? = null// 送车上门服务费
    private var getServiceCharge: String? = null// 上门取车服务费
    private var getCarMile: String? = null
    private var giveCarMile: String? = null
    private var planId: String? = null
    private var activityId: String? = null

    private var userGiveLat: Double? = 0.0
    private var userGiveLng: Double? = 0.0
    private var userGetLat: Double? = 0.0
    private var userGetLng: Double? = 0.0
    private var mWkUseSelectAmount: Int = -1
    private var mSelectedCoupounAmount: Int = 0

    private var viewHolderList = ArrayList<OptionalServiceView.ViewHolder>()
    private var insuranceIdList = ArrayList<String>()
    private var paramsViewHolderList = ArrayList<OptionalServiceView.ViewHolder>()
    private var chooseCouponsIds = ArrayList<String>()
    private var userSwitch = ArrayList<String>(Arrays.asList(ACTIVITY, COUPON))

    private var avaiActivitiesList = ArrayList<ActivitiesDiscountBean>()
    private var wkCoinprompt: String? = null
    private var wkCoinAvai: Int? = null

    companion object {
        private const val ACTIVITY = "ACTIVITY"
        private const val COUPON = "COUPON"
    }

    private fun getIntentData() {
        val intent = intent
        if (intent.hasExtra(CarEntity.BOOK_CARID)) {
            val json = SharedPreferencesUtil.getInstance().getString(SharedPreferencesUtil.CAR_DETAIL_JSON)
            val mCarDetailJsonBean = Util.jsonToEntity(json, CarDetailJsonBean::class.java) as CarDetailJsonBean
            initCarDetail(mCarDetailJsonBean.carDetail)
        } else if (intent.hasExtra(CarEntity.BOOK_ACTIVITY_CONFIG)) {
            isFromH5 = true
            mCarDetailResultForH5 = intent?.extras?.get(CarEntity.BOOK_ACTIVITY_CONFIG) as CarDetailResultForH5
            initCarDetail(mCarDetailResultForH5?.carDic)
        }
    }

    override fun onNewIntent(intent: Intent?) {
        super.onNewIntent(intent)
        if (intent?.getStringExtra("onNewIntent") == "onNewIntent") {
            resultReturnSite()
        }
    }

    private fun initCarDetail(result: CarDetailResult?) {
        if (result == null)
            return
        mCarDetailResult = result
        LogUtil.e("H5  Site = " + result.site?.toString())
        LogUtil.e("H5  Site = " + result.return_site?.toString())
        takeSiteBean = result.site
        returnSiteBean = takeSiteBean
        spUtil.setFloat(SharedPreferencesUtil.BASIC_INSURANCE_KEY, result.pays?.basic_insurance
                ?: 0.0f)
        spUtil.setFloat(SharedPreferencesUtil.ADDITIONAL_INSURANCE_KEY, result.pays?.additional_insurance
                ?: 0.0f)
        spUtil.setFloat(SharedPreferencesUtil.HOUR_INSURANCE_KEY, result.pays?.hour_insurance
                ?: 0.0f)
    }

    override fun getLayoutId(): Int {
        getIntentData()
        return R.layout.activity_book
    }

    override fun initView() {
        couldOrderAdd(false)
    }

    override fun initToolBar() {
        mainTitle.text = "提交订单"
        subTitle.text = "预订须知"
    }

    override fun initListeners() {
        giveCarButton.setOnCheckedChangeListener(MyListener())//送车上门
        getCarButton.setOnCheckedChangeListener(MyListener())// 上门去车
        takeCarAddress.setOnClickListener(MyListener())
        returnCarAddress.setOnClickListener(MyListener())
        discountLayout.setOnClickListener(MyListener())// 活动优惠列表
        wkCoinButton.setOnClickListener(MyListener())// 悟空币开关
        wkCoinButton.setOnCheckedChangeListener(MyListener())
        switchSiteLayout.setOnClickListener(MyListener())// 还车网点更改
        ivQuestion.setOnClickListener(MyListener())// 优惠折扣
        couponLayout.setOnClickListener(MyListener())// 选择优惠券
//        agreementLayout.setOnClickListener(MyListener())// 用车协议勾选
        cbAgreement.setOnClickListener(MyListener())// 用车协议勾选
        seeAgreement.setOnClickListener(MyListener())// 查看用车协议
        costDetailLayout.setOnClickListener(MyListener())//费用明细
        submitBook.setOnClickListener(MyListener())// 提交订单
        customerService.setOnClickListener(MyListener())// 联系客服
        optionalServiceView.setOnCalcListener { calcResult() }
        subTitle.setOnClickListener(MyListener())
    }

    @Suppress("DEPRECATION")
    override fun initData() {
        wkCoinButton.isChecked = true
        mDisplayMetrics = DisplayMetrics()
        windowManager.defaultDisplay.getMetrics(mDisplayMetrics)
        val sp = SpannableString("总计\n(含保险)")
        sp.setSpan(RelativeSizeSpan(0.7f), sp.length - 5, sp.length, Spannable.SPAN_INCLUSIVE_EXCLUSIVE)
        sp.setSpan(ForegroundColorSpan(ContextCompat.getColor(this, R.color.color_6)),
                sp.length - 5, sp.length, Spannable.SPAN_EXCLUSIVE_EXCLUSIVE)
        amountTitle.text = sp
        // 初始化页面数据
        setInfo()
        // 计算接口
        calcResult()
    }

    private val promptText1 = "温馨提示：取车时需冻结车辆押金"
    private val promptText2 = "元，还车时需冻结违章押金"
    private val promptText3 = "元。"

    private fun setInfo() {
        val json = SharedPreferencesUtil.getInstance().homePageScreen
        mCarSearchBean = Util.jsonToEntity(json, CarSearchBean::class.java) as CarSearchBean
        LogUtil.e("initData， json = $json")
        LogUtil.e("initData， mCarSearchBean = " + mCarSearchBean?.toString())
        canBook = true
//        mTvDeposit.text = "温馨提示：取车时需缴纳车辆押金" + mCarDetailResult?.pays?.car_deposit?.toInt() + "元，还车时需缴纳违章押金" +
//                mCarDetailResult?.pays?.illegal_deposit?.toInt() + "元。"
        mTvDeposit.text = promptText1 + mCarDetailResult?.pays?.car_deposit?.toInt() + promptText2 + mCarDetailResult?.pays?.illegal_deposit?.toInt() + promptText3

        carImg.setImageURI(mCarDetailResult?.pics?.pic1)
        carName.text = mCarDetailResult?.car_type_name
        carSynopsis.text = carSynopsisInfo(mCarDetailResult?.basics)
        // 取还车时间 /* 时间，地址，是否可订车，H5,和navtive不同 */
        startTime = if (isFromH5) mCarDetailResultForH5?.startTime else nativeStartTime(mCarSearchBean?.startTime)
        endTime = if (isFromH5) mCarDetailResultForH5?.endTime else nativeEndTime(startTime, mCarSearchBean?.endTime)
        takeCarTime.text = DateTimeUtil.getDate(startTime) + " " + DateTimeUtil.getTime(startTime)
        returnCarTime.text = DateTimeUtil.getDate(endTime) + " " + DateTimeUtil.getTime(endTime)
        // 取还车网点｜地址
        takeSiteName = if (isFromH5) h5TakeSite() else nativeTakeSite()
        returnSiteName = if (isFromH5) h5ReturnSite() else nativeReturnSite()
        takeCarAddress.text = takeSiteName
        returnCarAddress.text = returnSiteName
        // 取还车营业时间
        takeSiteInfo.text = "请在" + takeSiteBean?.from_time + " - " + takeSiteBean?.to_time + "内取车"
        returnSiteInfo.text = "请在" + returnSiteBean?.from_time + " - " + returnSiteBean?.to_time + "内还车"
        giveCarLayout.visibility = if (takeSiteBean?.radius != 0 && mCarSearchBean?.isDifferentCity == false) View.VISIBLE else View.INVISIBLE
        getCarLayout.visibility = if (takeSiteBean?.radius != 0 && mCarSearchBean?.isDifferentCity == false) View.VISIBLE else View.INVISIBLE
        // 可选服务
        viewHolderList = optionalServiceView.setOptionalService(mCarDetailResult?.optional_service,
                scrollView, bottomLayout) as ArrayList<OptionalServiceView.ViewHolder>
    }

    private fun nativeStartTime(st: String?): String { // 取车时间
        return if (!TextUtils.isEmpty(st)) st.toString() else DateTimeUtil.getStartTime()
    }

    private fun nativeEndTime(st: String?, et: String?): String { // 还车时间
        return if (!TextUtils.isEmpty(et)) et.toString() else DateTimeUtil.getEndTime(st)
    }

    private fun h5TakeSite(): String { // H5取车网点
        return mCarDetailResult?.site?.city + " - " + mCarDetailResult?.site?.name
    }

    private fun h5ReturnSite(): String {// H5还车网点
        returnSiteCity = mCarDetailResult?.return_site?.city
        return mCarDetailResult?.return_site?.city + " - " + mCarDetailResult?.return_site?.name
    }

    private fun nativeTakeSite(): String {// 取车网点
        return takeSiteBean?.city + " - " + takeSiteBean?.name
    }

    private fun nativeReturnSite(): String { // 还车网点
        val siteName: String
        val siteCity: String
        if (mCarSearchBean != null && mCarSearchBean?.isDifferentCity == true) {
            if (!TextUtils.isEmpty(mCarSearchBean?.returnCity)) {
                siteCity = mCarSearchBean?.returnCity ?: ""
                siteName = "请选择"
                canBook = false
                isNotRunCalc = true
                IOSAlertDialog(this).builder().setTitle("温馨提示").setMsg("为了方便我们为您服务，请选择异地还车的网点", true)
                        .setPositiveButton("确定") {
                            switchSite()
                        }.show()
            } else {
                siteCity = takeSiteBean?.city ?: ""
                siteName = takeSiteBean?.name ?: ""
            }
        } else {
            siteCity = takeSiteBean?.city ?: ""
            siteName = takeSiteBean?.name ?: ""
        }

        LogUtil.e("canBook = $canBook")
        couldOrderAdd(canBook)
        returnSiteCity = siteCity
        return "$siteCity - $siteName"
    }

    inner class MyListener : View.OnClickListener, CompoundButton.OnCheckedChangeListener {

        override fun onCheckedChanged(buttonView: CompoundButton?, isChecked: Boolean) {
            if (Util.isNoNetwork(this@BookActivity)) {
                when (buttonView?.id) {
                    R.id.giveCarButton -> giveCarButton.isChecked = !isChecked
                    R.id.getCarButton -> getCarButton.isChecked = !isChecked
                    R.id.wkCoinButton -> wkCoinButton.isChecked = !isChecked
                }
                return
            }

            when (buttonView?.id) {
                R.id.giveCarButton -> giveCarInfo(isChecked)
                R.id.getCarButton -> getCarInfo(isChecked)
            }
        }

        override fun onClick(v: View?) {
            if (Util.isNoNetwork(this@BookActivity))
                return
            when (v?.id) {
                R.id.switchSiteLayout -> switchSite()
                R.id.takeCarAddress -> {
                    StatisticsUtil.onEvent(this@BookActivity, ConstantsUtil.BOOK_CAR_TAKE_CAR, "")
                    if (giveCarButton.isChecked) {
                        fromGiveCar = true
                        setGiveCarAddress()
                    }
                }
                R.id.returnCarAddress -> {
                    StatisticsUtil.onEvent(this@BookActivity, ConstantsUtil.BOOK_CAR_SEND_CAR, "")
                    if (getCarButton.isChecked) {
                        fromGetCar = true
                        setGetCarAddress()
                    }
                }
                R.id.customerService -> {
                    StatisticsUtil.onEvent(this@BookActivity, ConstantsUtil.BOOK_CAR_CUSTOMER_SERVICE, "TO DO")
                    Util.contactService(this@BookActivity)
                }
                R.id.ivQuestion -> {
                    StatisticsUtil.onEvent(this@BookActivity, ConstantsUtil.BOOK_CAR_DISCOUNT, "TO DO")
                    Util.discountNotice(this@BookActivity)
                }
                R.id.seeAgreement -> Util.carAgreementNotice(this@BookActivity)
                R.id.cbAgreement -> couldOrderAdd(cbAgreement.isChecked)
                R.id.costDetailLayout -> costDetailInfo()
                R.id.submitBook -> {
                    StatisticsUtil.onEvent(this@BookActivity, ConstantsUtil.BOOK_CAR_SUBMIT_ORDER, "TO DO")
                    onBook()
                }
                R.id.couponLayout -> getCouponInfo()
                R.id.discountLayout -> discountList()
                R.id.wkCoinButton -> wkCoinInfo()
                R.id.subTitle -> {
                    StatisticsUtil.onEvent(this@BookActivity, ConstantsUtil.BOOK_CAR_NOTICE, "TO DO")
                    Util.bookNotice(this@BookActivity)
                }
            }
        }
    }

    private fun wkCoinInfo() {
        StatisticsUtil.onEvent(this@BookActivity, ConstantsUtil.BOOK_CAR_WKCOIN, "TO DO")
        if (wkCoinAvai == 0) {
            wkCoinButton.isChecked = false
        } else {
            if (TextUtils.isEmpty(wkCoinprompt)) {
                calcResult()
            } else {
                showToast(wkCoinprompt)
            }
        }
    }

    private fun getCouponInfo() {
        StatisticsUtil.onEvent(this@BookActivity, ConstantsUtil.BOOK_CAR_COUPON, "TO DO")
        if (mCalcResult != null && mCalcResult?.avai_coupons?.size ?: 0 > 0) {
            val intent = Intent(this@BookActivity, CouponsManageActivity::class.java)
            intent.putExtra(ConstantsUtil.BUNDLE_EXTRA_KEY, "Book")
            intent.putExtra("CouponsList", mCalcResult?.avai_coupons)
            if (chooseCouponsIds.size > 0) {
                intent.putExtra("defSelectedCoupon", chooseCouponsIds)
            }
            startActivityForResult(intent, ConstantsUtil.CHOOSE_COUPONS)
        }
    }

    private fun switchSite() {
        StatisticsUtil.onEvent(this@BookActivity, ConstantsUtil.BOOK_CAR_CHANGE_RETURN_SITE, "TO DO")
        val intent = Intent(this@BookActivity, SiteListActivity::class.java)
        intent.putExtra("SiteDetailFromType", SiteDetailActivity.TYPE_FROM_BOOK)
        intent.putExtra(Constants.ENTRY_TYPE, SiteListActivity.TYPE_SITE_SWITCH)
        intent.putExtra("take_site_id", takeSiteBean?.siteid)
        intent.putExtra("return_city", returnSiteCity)
        startActivityForResult(intent, Constants.ADDRESS_RESULT)
    }

    fun toServiceOption(v: View) {// 可选服务
        LogUtil.e("OnClick" + v.id)
        StatisticsUtil.onEvent(this@BookActivity, ConstantsUtil.BOOK_CAR_CHOOSE_SERVICE, "TO DO")
        Util.optionServiceNotice(this@BookActivity)
    }

    private fun discountList() {
//        calcResult()
        //活动优惠页面
        val intent = Intent(this@BookActivity, ActivitiesDiscountActivity::class.java)
        if (avaiActivitiesList.size > 0) {
            intent.putExtra("list", avaiActivitiesList)
            intent.putExtra("select", activityId)
//        startActivity(ActivitiesDiscountActivity::class.java)
//        startActivity(intent)

            startActivityForResult(intent, ConstantsUtil.CHOOSE_DISCOUNT)
        }
    }

    private fun costDetailInfo() {
        StatisticsUtil.onEvent(this@BookActivity, ConstantsUtil.BOOK_CAR_ORDER_BILL, "TO DO")
        val intent = Intent(this@BookActivity, CostActivity::class.java)
        intent.putExtra(CarEntity.EXTRA_BUNDLE_KEY, "bookDetailCost")
        intent.putExtra("calc", mCalcResult)
        intent.putExtra("startTime", startTime)
        intent.putExtra("endTime", endTime)
        LogUtil.e("---------------------------" + mCarDetailResult?.prices?.hour)
        intent.putExtra("hourPrice", mCarDetailResult?.prices?.hour.toString())
        intent.putExtra("dayPrice", mCarDetailResult?.prices?.day.toString())
        startActivity(intent)
    }

    private fun giveCarInfo(isChecked: Boolean) {
        StatisticsUtil.onEvent(this, ConstantsUtil.BOOK_CAR_SEND_TAKE_CAR, "TO DO")
        if (isChecked) {
            fromGiveCar = false
            setGiveCarAddress()
        } else {
            takeCarAddress.background = null
            takeCarAddress.setPadding(0, 0, 0, 0)
            takeCarAddress.text = if (!TextUtils.isEmpty(takeSiteName)) takeSiteName else "没有网点信息"
            takeSiteInfo.text = "请在" + takeSiteBean?.from_time + " - " + takeSiteBean?.to_time + "内取车"
            calcResult()
        }
    }

    private fun setGiveCarAddress() {
        val intent = Intent(this@BookActivity, ChoosePoiActivity::class.java)
        intent.putExtra(CarEntity.EXTRA_BUNDLE_KEY, CarEntity.EXTRA_BOOK_SEND_BOX)
        SharedPreferencesUtil.getInstance().cacheLat = takeSiteBean?.location?.lat ?: 0.0
        SharedPreferencesUtil.getInstance().cacheLng = takeSiteBean?.location?.lng ?: 0.0
        intent.putExtra(CarEntity.EXTRA_BOOK_CHECK_BOX, giveCarButton.isChecked)
        intent.putExtra(CarEntity.EXTRA_BOOK_SITE_RADIUS, takeSiteBean?.radius)
        intent.putExtra(CarEntity.EXTRA_BOOK_SERVICE_DESC, takeSiteBean?.send_service_description)
        startActivityForResult(intent, CarEntity.POI)
    }

    private fun getCarInfo(isChecked: Boolean) {
        StatisticsUtil.onEvent(this@BookActivity, ConstantsUtil.BOOK_CAR_SEND_TAKE_CAR, "TO DO")
        if (isChecked) {
            fromGetCar = false
            setGetCarAddress()
        } else {
            switchSiteLayout.visibility = View.VISIBLE
            returnCarAddressLayout.background = null
            returnCarAddress.setPadding(0, 0, 0, 0)
            returnCarAddress.text = if (!TextUtils.isEmpty(returnSiteName)) returnSiteName else "没有网点信息"
            returnSiteInfo.text = "请在" + returnSiteBean?.from_time + " - " + returnSiteBean?.to_time + "内取车"
            calcResult()
        }
    }

    private fun setGetCarAddress() {
        val intent = Intent(this@BookActivity, ChoosePoiActivity::class.java)
        intent.putExtra(CarEntity.EXTRA_BUNDLE_KEY, CarEntity.EXTRA_BOOK_GET_BOX)
        SharedPreferencesUtil.getInstance().cacheLat = returnSiteBean?.location?.lat ?: 0.0
        SharedPreferencesUtil.getInstance().cacheLng = returnSiteBean?.location?.lng ?: 0.0
        intent.putExtra(CarEntity.EXTRA_BOOK_CHECK_BOX, getCarButton.isChecked)
        intent.putExtra(CarEntity.EXTRA_BOOK_SITE_RADIUS, returnSiteBean?.radius)
        intent.putExtra(CarEntity.EXTRA_BOOK_SERVICE_DESC, returnSiteBean?.send_service_description)
        startActivityForResult(intent, CarEntity.RETURN_POI)
    }

//    private fun setBookBtnClick(clickable: Boolean) {
//        Util.isClicked(this, submitBook, clickable)
//    }

    private fun carSynopsisInfo(basics: CarBasicsBean?): String { // 拼车辆详情描述
        if (basics == null)
            return ""
        val builder = StringBuilder()
        builder.append(basics.carriage + " | " + basics.displacement + basics.transmission_name +
                " | " + basics.capacity.toString() + "座")
        return builder.toString()
    }

    private fun onBook() {
        if (!NetUtil.isNetConnected(this@BookActivity)) {
            OldToastUtil.showerror(this@BookActivity, OldToastUtil.TIMEOUT_EXCEPTION)
            return // 没网络
        }
        if (optionalServiceView.isTypeThird && optionalServiceView.personList.size <= 0) {
            showToast("您还没有被保人哦，赶紧添加吧~")
            return
        }
        if (DateTimeUtil.bookTimeLimit(startTime)) {
            showToast("取车时间需要在当前时间之后")
            return
        }
        requesting = true
        showLoadingDialog()
        val presenter = SubmitOrderPresenterImpl(this, SubmitOrderResult::class.java)
        presenter.addListener(model)
        presenter.book(getOnBookInfo(), this@BookActivity)
    }

    private fun getOnBookInfo(): SubmitOrderRequest {
        val request = SubmitOrderRequest()
        request.channel = ChannelUtil.getAppChannel(this)
        request.uid = spUtil.uid
        request.plan_id = planId
        request.city = spUtil.userCityName
        request.car_type_id = mCarDetailResult?.car_type_id
        request.fuel = "2"
        request.bounds = "0"
        request.basic_insurance = mCarDetailResult?.pays?.basic_insurance.toString()
        request.additional_insurance = mCarDetailResult?.pays?.additional_insurance.toString()
        request.hour_insurance = mCarDetailResult?.pays?.hour_insurance.toString()
        // 取车网点相关
        request.start_time = startTime
        request.siteid = takeSiteBean?.siteid
        if (!TextUtils.isEmpty(mCarDetailResultForH5?.activityCode))
            request.activity_code = mCarDetailResultForH5?.activityCode
        if (giveCarButton.isChecked) {
            request.send_service = giveServiceCharge.toString()
            request.send_service_mile = giveCarMile
            request.location = LocationBean(userGiveLng ?: 0.0, userGiveLat ?: 0.0)
            request.address = giveCarPoi
        } else {
            request.location = LocationBean(takeSiteBean?.location?.lng
                    ?: 0.0, takeSiteBean?.location?.lat ?: 0.0)
            request.address = takeSiteBean?.address
        }
        // 换车网点相关
        request.end_time = endTime
        request.return_siteid = returnSiteBean?.siteid
        if (getCarButton.isChecked) {
            request.return_service = getServiceCharge.toString()
            request.return_service_mile = getCarMile
            request.return_location = LocationBean(userGetLng ?: 0.0, userGetLat ?: 0.0)
            request.return_address = getCarPoi
        } else {
            request.return_location = LocationBean(returnSiteBean?.location?.lng
                    ?: 0.0, returnSiteBean?.location?.lat ?: 0.0)
            request.return_address = returnSiteBean?.address
        }
        //补充保险
        insuranceIdList.clear()
        for (i in viewHolderList.indices) {
            if (viewHolderList[i].addition0_tb.isChecked) {
                insuranceIdList.add(viewHolderList[i].select_insurance_id)
            }
        }
        if (insuranceIdList.size > 0)
            request.optional_service = insuranceIdList
        if (optionalServiceView.isTypeThird)
            request.insured = optionalServiceView.personList
        if (!TextUtils.isEmpty(giveCarPoi))
            request.address = giveCarPoi
        // 悟空币
        if (wkCoinButton.isChecked)
            request.wkcoin_pay = mWkUseSelectAmount.toString()
        //优惠券
        request.coupons = chooseCouponsIds
        request.coupon_pay = mSelectedCoupounAmount.toString()
        // 活动优惠
        request.activity_id = activityId
        request.switch = userSwitch
        return request
    }

    private val model = object : GeneralViewInterface {
        override fun getCodeBeanFail(errorCode: Int) {
            requesting = false
            try {
                dismissLoadingDialog()
            } catch (e: Exception) {
            }
        }

        override fun getCodeObjectSuccess(bean: Any) {
            requesting = false
            dismissLoadingDialog()
            val result = bean as SubmitOrderResult
            when (result.code) {
                CarEntity.SUCC -> {
                    val intent = Intent()
                    intent.setClass(this@BookActivity, OrderDetailActivity::class.java)
                    intent.putExtra(ConstantsUtil.ORDER_ID, result.orderid)
                    startActivity(intent)
                    finish()
                }
                else -> showToast(result.msg)
            }

        }
    }

    private fun calcResult() {
        if (isNotRunCalc) return
        showLoadingDialog()
        val presenter = CalcPresenterImpl(this, CalcResult::class.java)
        presenter.addListener(calcModel)
        presenter.calcResult(getCalcInfo(), this@BookActivity)
    }

    private fun getCalcInfo(): CalcRequest {
        val request = CalcRequest()
        request.uid = spUtil.uid
        request.type = "INSERT"
        request.car_type_id = mCarDetailResult?.car_type_id
        request.start_time = startTime
        request.end_time = endTime
        request.basic_insurance = mCarDetailResult?.pays?.basic_insurance.toString()
        request.additional_insurance = mCarDetailResult?.pays?.additional_insurance.toString()
        request.siteid = takeSiteBean?.siteid
        if (giveCarButton.isChecked) {
            request.send_service = giveServiceCharge.toString()
            request.send_service_mile = giveCarMile
        }
        request.return_siteid = returnSiteBean?.siteid
        if (getCarButton.isChecked) {
            request.return_service = getServiceCharge.toString()
            request.return_service_mile = getCarMile
        }
        if (!TextUtils.isEmpty(mCarDetailResultForH5?.activityCode))
            request.activity_code = mCarDetailResultForH5?.activityCode
        // 补充保险
        insuranceIdList.clear()
        paramsViewHolderList.clear()
        for (i in viewHolderList.indices) {
            if (viewHolderList[i].addition0_tb.isChecked) {
                insuranceIdList.add(viewHolderList[i].select_insurance_id ?: "")
                paramsViewHolderList.add(viewHolderList[i])
            }
        }
        if (insuranceIdList.size != 0) request.optional_service = insuranceIdList
        if (optionalServiceView.isTypeThird) request.insured = optionalServiceView.personList
        // 悟空币
        if (wkCoinButton.isChecked) request.wkcoin_pay = mWkUseSelectAmount.toString()
        // 优惠券
        if (chooseCouponsIds.size > 0)
            request.coupons = chooseCouponsIds
//        if (!isFirst) {
        request.switch = userSwitch
        LogUtil.e("userSwitch ------- $userSwitch")
        request.activity_id = activityId
        LogUtil.e("activityId ------- $activityId")
//        }
        return request
    }

    private val calcModel = object : GeneralViewInterface {
        override fun getCodeBeanFail(errorCode: Int) {
            dismissLoadingDialog()
            couldOrderAdd(false)
            showErrorToast(errorCode)
        }

        override fun getCodeObjectSuccess(bean: Any?) {
            dismissLoadingDialog()
            val result = bean as CalcResult
            when (result.code) {
                CarEntity.SUCC -> {
                    if (canBook)
                        couldOrderAdd(true)
                    setCalcData(result)
                }
                else -> {
                    showToast(result.msg)
                    couldOrderAdd(false)
                }
            }
        }
    }

    /**
     * 计算接口成功返回数据
     */
    @SuppressLint("InflateParams")
    private fun setCalcData(result: CalcResult?) {
        if (result == null)
            return
        mCalcResult = result
        planId = result.plan_id
        totalAmount.text = result.actual_total_amount + "   "
        // 送车上门相关
        giveServiceCharge = result.send_service_amount
        if (giveCarButton.isChecked) {
            takeSiteInfo.visibility = View.VISIBLE
            takeSiteInfo.text = "预计公里数" + giveCarMile + "km，送车上门费¥" + giveServiceCharge
        }
        // 上门取车相关
        getServiceCharge = result.return_service_amount
        if (getCarButton.isChecked) {
            returnSiteInfo.visibility = View.VISIBLE
            returnSiteInfo.text = "预计公里数" + getCarMile + "km，上门取车费¥" + getServiceCharge
        }
        //补充保险
        for (i in viewHolderList.indices) {
            viewHolderList[i].addition0_total_price_tv.text = "¥"
        }
        if (result.optional_service.size > 0) {
            for (i in result.optional_service.indices) {
                try {
                    if (TextUtils.equals(paramsViewHolderList[i].select_insurance_id, result.optional_service[i].id)) {
                        if (paramsViewHolderList[i].addition0_total_price_tv != null)
                            paramsViewHolderList[i].addition0_total_price_tv.text = "¥" + result.optional_service[i].amount
                    }
                } catch (e: Exception) {
                }
            }
        }
        if (!TextUtils.isEmpty(result.prompt) && showNightService) {
            DialogUtil.setNightDailog(this@BookActivity, result.prompt)
            showNightService = false
        }
        /* 悟空币显示*/
        setWKCoinInfo(result)

        /* 优惠券*/
        setCouponInfo(result)

        // 活动优惠
        setActivityInfo(result)

        // 第一次calc 返回后初始化userSwitch list 初始化后再将isFirst置为false
//        if (isFirst) {
//            if (result.activity != null)
//                userSwitch.add(0, ACTIVITY)
//            if (result.coupon_pay > 0)
//                userSwitch.add(0, COUPON)
//            isFirst = false
//        }


        val spannableString = SpannableStringBuilder("")
        AdvanceBackActivity.generatePromptString(spannableString, result.modify_prompt)
        spannableString.append(" 退改规则")
        spannableString.setSpan(object : ClickableSpan() {
            override fun updateDrawState(ds: TextPaint) {
                super.updateDrawState(ds)
                ds.isUnderlineText = false
            }

            override fun onClick(v: View) {
                Util.ruleOfWithdrawal(this@BookActivity)
            }
        }, spannableString.length - 4, spannableString.length, Spanned.SPAN_EXCLUSIVE_EXCLUSIVE)
        spannableString.setSpan(ForegroundColorSpan(ContextCompat.getColor(this@BookActivity, R.color.color_8)),
                spannableString.length - 4, spannableString.length, Spannable.SPAN_EXCLUSIVE_EXCLUSIVE)
        prompt.text = spannableString
        prompt.movementMethod = LinkMovementMethod.getInstance()


//      小白免押金提示
        if (TextUtils.isEmpty(result.car_deposit_free_tips)) {
            deposit_deduction.visibility = View.INVISIBLE
        } else {
            deposit_deduction.visibility = View.VISIBLE
            deposit_deduction.text = result.car_deposit_free_tips

            val text = promptText1 + mCarDetailResult?.pays?.car_deposit?.toInt() + promptText2 + mCarDetailResult?.pays?.illegal_deposit?.toInt() + promptText3
            val spa = SpannableString(text)
            spa.setSpan(StrikethroughSpan(), promptText1.length, promptText1.length + mCarDetailResult?.pays?.car_deposit?.toInt().toString().length, Spanned.SPAN_EXCLUSIVE_EXCLUSIVE)
            mTvDeposit.text = spa
        }


    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        LogUtil.e("onActivityResult -------------------------data: Intent?$data")
        super.onActivityResult(requestCode, resultCode, data)
        if (data == null) {
            if (requestCode == CarEntity.POI && !fromGiveCar)
                giveCarButton.isChecked = false
            if (requestCode == CarEntity.RETURN_POI && !fromGetCar)
                getCarButton.isChecked = false
            return
        }

        val b: Bundle? = data.extras
        when (requestCode) {
        // 送车上门
            CarEntity.POI -> resultGivePoi(b)
        // 上门取车
            CarEntity.RETURN_POI -> resultGetPoi(b)
        // 更换网点
            Constants.ADDRESS_RESULT -> resultReturnSite()
        // 优惠券
            ConstantsUtil.CHOOSE_COUPONS -> resultCoupons(b)
        // 活动优惠
            ConstantsUtil.CHOOSE_DISCOUNT -> {
                activityId = b?.getString("activity_id")
                LogUtil.e("activityId--->$activityId")
                if (activityId != null) {
                    switchList(ACTIVITY)
                    calcResult()
                }
            }
        }
    }

    @Suppress("UNCHECKED_CAST")
    private fun resultCoupons(b: Bundle?) {
        if (b == null) return
        val chooseCoupons = b.getSerializable("selectedCoupon") as ArrayList<CouponBean>
        chooseCouponsIds.clear()
        if (chooseCoupons.size != 0) {
            val coupons = chooseCoupons[0]
            chooseCouponsIds.add(coupons.id.toString())
        }
        switchList(COUPON)
        calcResult()
    }

    private fun resultGivePoi(b: Bundle?) { // 送车上门
        if (b == null) return
        if (b.containsKey(CarEntity.POI_KEY)) {
            isGiveCarOut = b.getBoolean(CarEntity.EXTRA_CHOOSE_POI_OUT)
            giveCarPoi = b.getString(CarEntity.POI_KEY)
        }
        if (!TextUtils.isEmpty(giveCarPoi)) {
            userGiveLat = b.getDouble("user_get_lat")
            userGiveLng = b.getDouble("user_get_lng")
            if (!isGiveCarOut) {
                val distance = DistanceUtil.getDistance(LatLng(takeSiteBean?.location?.lat ?: 0.0,
                        takeSiteBean?.location?.lng ?: 0.0), LatLng(userGiveLat ?: 0.0, userGiveLng
                        ?: 0.0)) / 1000
                giveCarMile = df.format(distance)
                addressBackground(takeCarAddress, giveCarPoi)
            } else {
                giveCarMile = "0.0"
                takeCarAddress.text = if (!TextUtils.isEmpty(takeSiteName)) takeSiteName else "没有网点信息"
            }
            calcResult()
        }
    }

    private fun resultGetPoi(b: Bundle?) { // 上门取车
        if (b == null) return
        if (b.containsKey(CarEntity.POI_RETURN_KEY)) {
            isGetCarOut = b.getBoolean(CarEntity.EXTRA_CHOOSE_POI_OUT)
            getCarPoi = b.getString(CarEntity.POI_RETURN_KEY)
        }
        if (!TextUtils.isEmpty(getCarPoi)) {
            userGetLat = b.getDouble("user_return_lat")
            userGetLng = b.getDouble("user_return_lng")
            if (!isGetCarOut) {
                val distance = DistanceUtil.getDistance(LatLng(returnSiteBean?.location?.lat ?: 0.0,
                        returnSiteBean?.location?.lng ?: 0.0), LatLng(userGetLat ?: 0.0, userGetLng
                        ?: 0.0)) / 1000
                getCarMile = df.format(distance)
                returnCarAddress.text = getCarPoi
                returnCarAddress.setPadding(10, 0, 0, 0)
                returnCarAddressLayout.background = resources.getDrawable(R.drawable.border_b8)
                switchSiteLayout.visibility = View.GONE
            } else {
                getCarMile = "0.0"
                returnCarAddress.text = if (!TextUtils.isEmpty(returnSiteName)) returnSiteName else "请选择网点信息"
            }
            calcResult()
        }
    }

    private fun addressBackground(tv: TextView, poi: String?) {
        tv.text = poi
        tv.background = resources.getDrawable(R.drawable.border_b8)
        tv.setPadding(10, 0, 0, 0)
    }

    private fun resultReturnSite() { // 切换网点
        couldOrderAdd(true)
        isNotRunCalc = false
        val bean = JsonConvertUtil.getChooseAddressBean(spUtil.getString(SharePreferenceTools.JSON_FOR_CHOOSE_ADDR))
        returnCarAddress.text = returnSiteCity + " - " + bean.site.name
        returnSiteBean = bean.site
        returnSiteInfo.text = "请在" + bean.site.from_time + "-" + bean.site.to_time + "内还车"
        calcResult()
    }

    private fun couldOrderAdd(isClick: Boolean) {
        if (isClick && cbAgreement.isChecked) {
            Util.isClicked(this, submitBook, true)
        } else {
            Util.isClicked(this, submitBook, false)
        }
    }

    private fun switchList(name: String) {
        userSwitch.clear()
        when (name) {
            ACTIVITY -> {
                if (chooseCouponsIds.size != 0) {
                    userSwitch.add(0, COUPON)
                }
                if (!TextUtils.isEmpty(activityId)) {
                    userSwitch.add(0, ACTIVITY)
                }
            }
            COUPON -> {
                if (!TextUtils.isEmpty(activityId)) {
                    userSwitch.add(0, ACTIVITY)
                }
                if (chooseCouponsIds.size != 0) {
                    userSwitch.add(0, name)
                }
            }
        }
    }

    private fun setCouponInfo(result: CalcResult) {
        mSelectedCoupounAmount = result.coupon_pay
        if (result.coupons?.size ?: 0 > 0) {
            chooseCouponsIds = result.coupons ?: ArrayList()
        } else {
            chooseCouponsIds.clear()
        }
        // 产品施展 需求 优惠券显示样式修改于03/15 选取优惠券后显示金额于右边，取消优惠券后显示张数于左边
        // 右侧金额显示三种情况 1.选取优惠券时显示金额  2.活动与优惠券不可同享  3.优惠券可用张数0显示暂无可用
        couponArrow.visibility = View.VISIBLE
        if (result.coupon_pay != 0) {
            couponAmount.text = Util.getMoneyString(result.coupon_pay)
            couponAmount.setTextColor(ContextCompat.getColor(this@BookActivity, R.color.color_6))
        } else {
            if (result.avai_coupons?.size ?: 0 > 0 && result.avai_activities?.size ?: 0 > 0) {
                couponAmount.text = if (result.activity == null) "" else "活动与优惠券不可同享"
                couponAmount.setTextColor(ContextCompat.getColor(this@BookActivity, R.color.color_5))
            } else {
                if (result.avai_coupons?.size ?: 0 == 0) {
                    couponArrow.visibility = View.GONE
                    couponAmount.text = "暂无可用"
                    couponAmount.setTextColor(ContextCompat.getColor(this@BookActivity, R.color.color_3))
                } else {
                    couponArrow.visibility = View.VISIBLE
                    couponAmount.text = ""
                }
            }
        }
        //左侧  1选取优惠券时不显示， 2不选取且优惠券张数大于0 显示张数
        if (result.coupon_pay != 0 || result.avai_coupons?.size ?: 0 == 0) {
            couponTitle.text = "优惠券"
        } else {
            val sp = "优惠券(可用${result.avai_coupons?.size ?: 0}张)"
            couponTitle.text = TextUtil.setForegroundColorAndSize(sp, 3, sp.length, ContextCompat.getColor(this@BookActivity, R.color.color_3),
                    3, sp.length, 0.8f)
        }
    }

    private fun setWKCoinInfo(result: CalcResult) {
        wkCoinLayout.visibility = if (result.wkcoin_pay_hide) View.GONE else View.VISIBLE
        val sp = if (result.wkcoin_avai_pay != 0) "悟空币(可抵扣¥${result.wkcoin_avai_pay})" else "悟空币(无可用)"
        wkCoinTitle.text = TextUtil.setForegroundColorAndSize(sp, 3, sp.length, ContextCompat.getColor(this@BookActivity, R.color.color_3),
                3, sp.length, 0.8f)
        wkCoinButton.isChecked = result.wkcoin_pay_switch
        wkCoinAvai = result.wkcoin_avai_pay
        mWkUseSelectAmount = if (wkCoinButton.isChecked) result.wkcoin_pay else 0
        wkCoinAmount.visibility = if (wkCoinButton.isChecked) View.VISIBLE else View.GONE
        wkCoinAmount.text = "-¥" + Math.abs(mWkUseSelectAmount)
        wkCoinprompt = result.wkcoin_pay_prompt
    }

    private fun setActivityInfo(result: CalcResult) {
        activityId = if (result.activity != null) result.activity?.id else ""
        val activity = result.activity
        if (activity != null) {
            discountTypeText.text = activity.tag
            discountTypeText.setBackColor(Color.parseColor(activity.tag_color ?: "#CB2A1E"))
            discountContent.text = activity.description
            discountTypeText.visibility = View.VISIBLE
            discountContent.visibility = View.VISIBLE
            discountNullHint.visibility = View.GONE
            discountNumber.visibility = View.GONE
        } else {
            discountNullHint.visibility = View.VISIBLE
            discountNumber.visibility = View.VISIBLE
            discountNumber.text = "（" + avaiActivitiesList.size + "个优惠活动）"
            discountTypeText.visibility = View.GONE
            discountContent.visibility = View.GONE
            if (result.avai_coupons?.size ?: 0 > 0 && result.avai_activities?.size ?: 0 > 0) {
                discountNullHint.text = if (result.coupon_pay == 0) "" else "活动与优惠券不可同享"
                discountNullHint.setTextColor(ContextCompat.getColor(this@BookActivity, R.color.color_5))
                discountNullHint.isEnabled = true
                discountRightIcon.visibility = View.VISIBLE
                discountNumber.visibility = View.VISIBLE
            } else {
                if (result.avai_activities?.size ?: 0 > 0) {
                    discountNullHint.text = ""
                    discountNullHint.isEnabled = true
                    discountNumber.visibility = View.VISIBLE
                } else {
                    discountNullHint.text = "暂无活动优惠"
                    discountNullHint.setTextColor(ContextCompat.getColor(this@BookActivity, R.color.color_3))
                    discountNullHint.isEnabled = false
                    discountNumber.visibility = View.GONE
                    discountRightIcon.visibility = View.GONE
                }
            }
        }
        //活动优惠列表
        avaiActivitiesList = result.avai_activities ?: ArrayList()
    }
}