package com.jiaoyinbrother.monkeyking.activity

import android.app.Activity
import android.content.Context
import android.content.Intent
import android.text.TextUtils
import android.view.View
import android.widget.ExpandableListView
import com.handmark.pulltorefresh.library.PullToRefreshBase
import com.handmark.pulltorefresh.library.PullToRefreshExpandableListView
import com.jiaoyinbrother.monkeyking.CarEntity
import com.jiaoyinbrother.monkeyking.Constants
import com.jiaoyinbrother.monkeyking.R
import com.jiaoyinbrother.monkeyking.adapter.CarTypeAdapter
import com.jiaoyinbrother.monkeyking.bean.CarDetailJsonBean
import com.jiaoyinbrother.monkeyking.bean.CarDetailResult
import com.jiaoyinbrother.monkeyking.bean.CarTypeSearchResult
import com.jiaoyinbrother.monkeyking.bean.ChooseAddressBean
import com.jiaoyinbrother.monkeyking.util.AuthUtil
import com.jiaoyinbrother.monkeyking.util.JsonConvertUtil
import com.jiaoyinbrother.monkeyking.util.SharedPreferencesUtil
import com.jiaoyinbrother.monkeyking.util.Util
import com.jiaoyinbrother.monkeyking.view.date.SelectDateTimeDialog
import com.jybrother.sineo.library.base.BaseActivity
import com.jybrother.sineo.library.bean.*
import com.jybrother.sineo.library.presenter.CarDetailPresenterImpl
import com.jybrother.sineo.library.presenter.CarTypeListPresenterImpl
import com.jybrother.sineo.library.util.ConstantsUtil
import com.jybrother.sineo.library.util.SharePreferenceTools
import com.jybrother.sineo.library.util.StatisticsUtil
import com.jybrother.sineo.library.view.GeneralViewInterface
import kotlinx.android.synthetic.main.activity_car_type_list.*
import kotlinx.android.synthetic.main.layout_car_type_footer.*
import kotlinx.android.synthetic.main.layout_car_type_header.*
import java.lang.ref.WeakReference
import java.util.*

class CarTypeListActivity : BaseActivity() {

    private var mContext: Context = this
    private var mRefreshExpandableListView: PullToRefreshExpandableListView? = null
    private var mExpandableListView: ExpandableListView? = null
    private var mCarTypeAdapter: CarTypeAdapter? = null
    private var mCarTypeTypeListPresenter: CarTypeListPresenterImpl? = null

    private var groupList: MutableList<SiteBean2>? = null
    private var childList: MutableList<List<CarBean>>? = null
    private var spTool: SharePreferenceTools? = null
    private var non_rent: Int = 0

    private var isRequesting: Boolean = false
    private var isMore: Boolean = false

    private var hasPrompt: Boolean = false
    private var recommendIndex: Int = 0
    private var site_ids: List<String>? = null
    private var siteGroupList: MutableList<SiteBean2>? = null
    private var siteChildList: MutableList<List<CarBean>>? = null
    private var mPrompt: String? = null

    private var isTake: Boolean = false

    private var mCarDetailResult: CarDetailResult? = null
    private var mSiteId: String? = null
    private var mCarTypeId: String? = null

    companion object {
        var mWeakReference: WeakReference<Activity>? = null
    }

    override fun getLayoutId(): Int {
        return R.layout.activity_car_type_list
    }

    override fun initView() {
        mRefreshExpandableListView = car_type_elv
        mRefreshExpandableListView?.mode = PullToRefreshBase.Mode.BOTH
        mExpandableListView = mRefreshExpandableListView?.refreshableView

        val layoutCarTypeHeader = View.inflate(mContext, R.layout.layout_car_type_header, null)
        mExpandableListView?.addHeaderView(layoutCarTypeHeader)
        val layoutCarTypeFooter = View.inflate(mContext, R.layout.layout_car_type_footer, null)
        mExpandableListView?.addFooterView(layoutCarTypeFooter)

        mCarTypeAdapter = CarTypeAdapter(mContext)
        mExpandableListView?.setAdapter(mCarTypeAdapter)

        mWeakReference = WeakReference(this)
    }

    override fun initToolBar() {
    }

    override fun initListeners() {
        mRefreshExpandableListView?.setOnRefreshListener(OnMyListener())
        mExpandableListView?.setOnGroupClickListener(OnMyListener())
        mExpandableListView?.setOnChildClickListener(OnMyListener())
        mCarTypeAdapter?.setOnMyClickListener(OnMyListener())
    }

    override fun initData() {
        spTool = SharePreferenceTools(this)
        mCarTypeTypeListPresenter = CarTypeListPresenterImpl(mContext)

        groupList = ArrayList()
        childList = ArrayList()
        siteGroupList = ArrayList()
        siteChildList = ArrayList()

        getCarSearchBeanData()
        getIntentData()

        requestCarTypeSearch(false)
    }


    override fun onResume() {
        super.onResume()
    }

    private fun requestCarTypeSearch(isMore: Boolean) {
        this.isMore = isMore
        if (!isRequesting) {
            requestUrl()
        }
    }

    private fun requestUrl() {
        showLoadingDialog()
        isRequesting = true
        mCarTypeTypeListPresenter?.requestCarTypeList(
                getCarTypeSearchEntity(),
                CarTypeSearchResult::class.java,
                mCarTypeListResponse)
    }

    private fun  getCarTypeSearchEntity() : CarTypeSearchEntity{
        val entity = CarTypeSearchEntity()
        if (!TextUtils.isEmpty(mCarTypeTypeListPresenter?.mCityStr)) {
            entity.city = mCarTypeTypeListPresenter?.mCityStr
        }
        if (!TextUtils.isEmpty(mCarTypeTypeListPresenter?.mReturnCityStr)) {
            entity.return_city = mCarTypeTypeListPresenter?.mReturnCityStr
        }
        if (mCarTypeTypeListPresenter?.mUserLacation != null) {
            entity.location = mCarTypeTypeListPresenter?.mUserLacation
        }
        if (!TextUtils.isEmpty(mCarTypeTypeListPresenter?.mSureStartTime)) {
            entity.from_time = mCarTypeTypeListPresenter?.mSureStartTime
        }
        if (!TextUtils.isEmpty(mCarTypeTypeListPresenter?.mSureEndTime)) {
            entity.to_time = mCarTypeTypeListPresenter?.mSureEndTime
        }
        if (mCarTypeTypeListPresenter?.mSite != null && !TextUtils.isEmpty(mCarTypeTypeListPresenter?.mSite?.siteid)) {
            entity.siteid = mCarTypeTypeListPresenter?.mSite?.siteid
        }
        // 常见品牌
        if (mCarTypeTypeListPresenter?.mBrand != null && mCarTypeTypeListPresenter?.mBrand?.size?:0 > 0) {
            entity.brand = mCarTypeTypeListPresenter?.mBrand
        }
        // 热门车型
        if (mCarTypeTypeListPresenter?.mModels != null && mCarTypeTypeListPresenter?.mModels?.size?:0 > 0) {
            entity.cartype = mCarTypeTypeListPresenter?.mModels
        }
        // 车辆类型
        if (mCarTypeTypeListPresenter?.mType != null && mCarTypeTypeListPresenter?.mType?.size?:0 > 0) {
            entity.categories = mCarTypeTypeListPresenter?.mType
        }
        // 筛选---变速箱
        if (!TextUtils.isEmpty(mCarTypeTypeListPresenter?.mTransmission)) {
            entity.transmission = mCarTypeTypeListPresenter?.mTransmission
        }
        //筛选---价格
        if (mCarTypeTypeListPresenter?.mMin?:0 > -1) {
            entity.min_price = mCarTypeTypeListPresenter?.mMin
        }
        if (mCarTypeTypeListPresenter?.mMax?:0 > -1) {
            entity.max_price = mCarTypeTypeListPresenter?.mMax
        }

        //加载更多
        if (isMore && site_ids != null) {
            entity.site_ids = site_ids
        }

        entity.page = 1
        entity.page_size = 5
        if (SharedPreferencesUtil.getInstance().isLogin) {
            entity.uid = SharedPreferencesUtil.getInstance().uid
        }
        return entity
    }


    private val mCarTypeListResponse = object : GeneralViewInterface {

        override fun getCodeBeanFail(errorCode: Int) {
            dismissLoadingDialog()
            isRequesting = false
            mRefreshExpandableListView?.onRefreshComplete()
            showErrorToast(errorCode)
        }

        override fun getCodeObjectSuccess(bean: Any) {
            dismissLoadingDialog()
            val result = bean as CarTypeSearchResult
            isRequesting = false
            mRefreshExpandableListView?.onRefreshComplete()
            if (result != null) {
                if (result.code == CarEntity.SUCC) {
                    getResponseData(result)
                } else {
                    showToast(result.msg)
                }
            }
            if (mCarTypeAdapter?.groupCount == 0) {
                footer_more_ll?.visibility = View.GONE
                footer_all_ll?.visibility = View.GONE
            }
        }
    }

    private fun getResponseData(result: CarTypeSearchResult?) {
        groupList?.clear()
        childList?.clear()

        if (!isMore) {
            //第一次
            if (result?.sites != null && result.sites.size > 0) {
                siteGroupList?.clear()
                siteChildList?.clear()
                for (i in result.sites.indices) {
                    val siteBean = result.sites[i]
                    if (siteBean != null && siteBean.car_types != null) {
                        siteGroupList?.add(siteBean)
                        val childData: MutableList<CarBean> = ArrayList<CarBean>()
                        for (j in result.sites[i].car_types?.indices!!) {
                            childData.add(result.sites[i].car_types!![j])
                        }
                        siteChildList?.add(childData)
                    }
                }
            } else {
                siteGroupList?.clear()
                siteChildList?.clear()
            }
            if (!TextUtils.isEmpty(result?.msg)) {
                mPrompt = result?.msg
            } else {
                mPrompt = ""
            }
            if (result?.site_ids != null) {
                site_ids = result?.site_ids
            }
//            result?.conditions
            footer_more_ll?.visibility = View.VISIBLE
            footer_all_ll?.visibility = View.GONE
        } else {
            //加载更多
            footer_more_ll?.visibility = View.GONE
            footer_all_ll?.visibility = View.VISIBLE
        }

        groupList?.addAll(siteGroupList!!)
        childList?.addAll(siteChildList!!)
        if (result?.recommends != null && result.recommends.size > 0) {
            for (i in result.recommends.indices) {
                val siteBean = result.recommends[i]
                if (siteBean != null && siteBean.car_types != null) {
                    groupList?.add(siteBean)
                    val childData = ArrayList<CarBean>()

                    for (j in result.recommends[i].car_types?.indices!!) {
                        childData.add(result.recommends[i].car_types!![j])
                    }
                    childList?.add(childData)
                }
            }
        }
        //黄条提示
        if (!TextUtils.isEmpty(mPrompt)) {
            header_prompt_ll?.postDelayed({
                header_prompt_ll?.visibility = View.VISIBLE
                header_prompt_tv?.text = mPrompt
                //blank_ll.setVisibility(View.GONE);
            }, 200)

            hasPrompt = true
        } else {
            header_prompt_ll?.postDelayed({
                header_prompt_ll?.visibility = View.GONE
                //blank_ll.setVisibility(View.VISIBLE);
            }, 200)

            hasPrompt = false
        }

        non_rent = result?.non_rent?:0
        recommendIndex = siteGroupList?.size?:0
        mCarTypeAdapter?.updateData(groupList, childList, recommendIndex, mCarTypeTypeListPresenter?.mUserLacation, non_rent, hasPrompt)
        expandAll()
    }

    private fun getCarSearchBeanData() {
        val json = SharedPreferencesUtil.getInstance().homePageScreen
        val carSearchBean = Util.jsonToEntity(json, CarSearchBean::class.java) as CarSearchBean
        if (carSearchBean == null) {
            val cityStr = SharedPreferencesUtil.getInstance().userCityName
            val userLacation = LocationBean(SharedPreferencesUtil.getInstance().userusePointLng.toDouble(),
                    SharedPreferencesUtil.getInstance().userusePointLat.toDouble())
            mCarTypeTypeListPresenter?.initCarSearchBean(cityStr, userLacation)
        } else {
            mCarTypeTypeListPresenter?.getCarSearchBean(carSearchBean)
            /* 筛选条件 */
            mCarTypeTypeListPresenter?.getScreenData()
        }
        start_time_tv?.text = mCarTypeTypeListPresenter?.mStartTimeValue
        end_time_tv?.text = mCarTypeTypeListPresenter?.mEndTimeValue
        take_address_name_tv?.text = mCarTypeTypeListPresenter?.mTakeAddressName
        take_address_value_tv?.text = mCarTypeTypeListPresenter?.mTakeAddressValue
    }

    private fun getIntentData(){
        var site = intent?.getSerializableExtra(Constants.RESULT_VALUE)
        if (site != null) {
            mCarTypeTypeListPresenter?.mSite = site as SiteBean2
            mCarTypeTypeListPresenter?.mIsDifferentCity = false
            take_address_value_tv?.setText(mCarTypeTypeListPresenter?.mSite?.name?:"")
            if (mCarTypeTypeListPresenter?.mCarSearchBean != null) {
                mCarTypeTypeListPresenter?.mCarSearchBean?.setType(CarSearchBean.TYPE_SITE)
                mCarTypeTypeListPresenter?.mCarSearchBean?.setDifferentCity(false)
            }
            saveCarSearchBeanData()
        }
    }

    private fun saveCarSearchBeanData() {
        val carSearchBean = mCarTypeTypeListPresenter?.saveCarSearchBean()
        val json = Util.entityToJson(carSearchBean)
        SharedPreferencesUtil.getInstance().saveHomePageScreen(json)
    }


    private fun expandAll() {
        for (i in groupList?.indices!!) {
            mExpandableListView?.expandGroup(i)
        }
    }

    internal inner class OnMyListener : CarTypeAdapter.OnMyClickListener, View.OnClickListener,
            PullToRefreshBase.OnRefreshListener2<ExpandableListView>, ExpandableListView.OnGroupClickListener,
            ExpandableListView.OnChildClickListener {
        override fun onPullDownToRefresh(refreshView: PullToRefreshBase<ExpandableListView>) {
            requestCarTypeSearch(false)
        }

        override fun onPullUpToRefresh(refreshView: PullToRefreshBase<ExpandableListView>) {
            if (isMore) {
                //已经加载更多了
                mRefreshExpandableListView?.onRefreshComplete()
            } else {
                requestCarTypeSearch(true)
            }
        }

        override fun onGroupClick(parent: ExpandableListView, v: View, groupPosition: Int, id: Long): Boolean {
            return true
        }

        override fun onChildClick(parent: ExpandableListView, v: View, groupPosition: Int, childPosition: Int, id: Long): Boolean {
            return true
        }

        override fun onChild(groupPosition: Int, childPosition: Int) {
            if (mCarTypeAdapter != null) {
                StatisticsUtil.onEvent(this@CarTypeListActivity, ConstantsUtil.CHOOSE_CAR_CARTYPE_LIST, "TO DO")
                StatisticsUtil.onEvent(this@CarTypeListActivity, ConstantsUtil.CHOOSE_CAR_OPEN_CAR_DETAIL, "TO DO")
                val site = mCarTypeAdapter?.getGroup(groupPosition) as SiteBean2
                val car = mCarTypeAdapter?.getChild(groupPosition, childPosition) as CarBean
                val siteid = site.siteid
                val car_type = car.car_type_id
                val avg = car.prices.avg.toInt().toString()

                val intent = Intent(mContext, CarTypeDetailActivity::class.java)
                val mGetDetailBean = GetDetailBean()
                mGetDetailBean.siteid = siteid
                mGetDetailBean.car_type_id = car_type
                mGetDetailBean.from_time = mCarTypeTypeListPresenter?.mSureStartTime
                mGetDetailBean.to_time = mCarTypeTypeListPresenter?.mSureEndTime
                intent.putExtra(CarEntity.EXTRA_BUNDLE_SITEID_KEY, mGetDetailBean)
                intent.putExtra(Constants.EXTRA_CAR_TYPE_AVG, avg)
                startActivity(intent)

            }
        }

        override fun onBook(groupPosition: Int, childPosition: Int) {
            if (mCarTypeAdapter != null) {
                //saveDataForBook();
                val site = mCarTypeAdapter?.getGroup(groupPosition) as SiteBean2
                val car = mCarTypeAdapter?.getChild(groupPosition, childPosition) as CarBean
                val siteid = site.siteid
                val car_type = car.car_type_id

                mSiteId = siteid
                mCarTypeId = car_type
                onClickBook()
            }
        }

        override fun onMap(groupPosition: Int) {
            if (mCarTypeAdapter != null) {
                StatisticsUtil.onEvent(this@CarTypeListActivity, ConstantsUtil.CHOOSE_CAR_SITE, "TO DO")
                val site = mCarTypeAdapter?.getGroup(groupPosition) as SiteBean2

                val intent = Intent(this@CarTypeListActivity, SiteDetailActivity::class.java)
                intent.putExtra("SiteDetailFromType", SiteDetailActivity.TYPE_FROM_CAR_DETAIL)
                intent.putExtra("siteDetailId", site.siteid)
                startActivity(intent)
            }
        }


        override fun onClick(v: View) {

        }

    }

    /**
     * 筛选
     *
     * @param v
     */
    fun onSelect(v: View) {
        StatisticsUtil.onEvent(mContext, ConstantsUtil.CHOOSE_CAR_SELECT, "TO DO")
        val intent = Intent(mContext, ScreenCarActivity::class.java)
        startActivityForResult(intent, Constants.SCREEN_CODE)
    }

    /**
     * 选择取车时间
     *
     * @param v
     */
    fun onSelectTakeTime(v: View) {
        StatisticsUtil.onEvent(this, ConstantsUtil.CHOOSE_CAR_CHANGE_TIME, "taketime")
        SelectDateTimeDialog.Builder(this)
                .setType(SelectDateTimeDialog.TYPE_START_TIME)
                .setStartTime(mCarTypeTypeListPresenter?.mSelectStartTime)
                .setEndTime(mCarTypeTypeListPresenter?.mSelectEndTime)
                .setOnResultBothListener { startDate, endDate ->
                    mCarTypeTypeListPresenter?.mSelectStartTime = startDate
                    mCarTypeTypeListPresenter?.mSelectEndTime = endDate
                    mCarTypeTypeListPresenter?.setSureDate(startDate, endDate)
                    start_time_tv.text = mCarTypeTypeListPresenter?.mStartTimeValue
                    end_time_tv.text = mCarTypeTypeListPresenter?.mEndTimeValue
                    saveCarSearchBeanData()
                    requestCarTypeSearch(false)
                }
                .show()
    }


    /**
     * 列表Footer查看更多
     *
     * @param v
     */
    fun onCheckMore(v: View) {
        StatisticsUtil.onEvent(this, ConstantsUtil.CHOOSE_CAR_MORE, "TO DO")
        requestCarTypeSearch(true)
    }


    fun onFinish(v: View) {
        StatisticsUtil.onEvent(this, ConstantsUtil.CHOOSE_CAR_RETURN, "TO DO")

        finish()
    }

    /**
     * 选择取车地址
     *
     * @param v
     */
    fun onTakeAddress(v: View) {
        StatisticsUtil.onEvent(mContext, ConstantsUtil.CHOOSE_CAR_GET_CAR_ADDRESS, "TO DO")
        isTake = true
        val intentType: String
        val intent: Intent
        val bean = ChooseAddressBean()
        bean.type = ChooseAddressBean.TYPE_NONE
        bean.city = mCarTypeTypeListPresenter?.mCityStr
        bean.returnCity = mCarTypeTypeListPresenter?.mReturnCityStr
        JsonConvertUtil.saveChooseAddrJson(spTool, Util.entityToJson(bean))
        if (mCarTypeTypeListPresenter?.mIsDifferentCity?:false) {
            // 异地城市
            intent = Intent(mContext, ChooseRemoteActivity::class.java)
            intentType = ChooseRemoteActivity.TYPE_REMOTE_CITY_CARS
        } else {
            // 取车网点
            intent = Intent(mContext, SiteListActivity::class.java)
            intent.putExtra("SiteDetailFromType", SiteDetailActivity.TYPE_FROM_CARLIST_CHANGE_SITE)
            intentType = SiteListActivity.TYPE_SITE_SEARCH_CARS
        }
        intent.putExtra(Constants.ENTRY_TYPE, intentType)
        startActivity(intent)
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        if (null == data) {
            return
        }
        val b = data.extras
        when (resultCode) {
            Constants.SCREEN_CODE -> {
                //筛选返回
                getCarSearchBeanData()
                requestCarTypeSearch(false)
            }
            Constants.FROM_CAR_TYPE -> {
                //从登陆返回
                val code = b?.getString(CarEntity.EXTRA_BUNDLE_KEY)
                if (code == "setResult") {
                    requestCarTypeDetail()
                }
            }
        }
    }


    private fun onClickBook() {
        if (SharedPreferencesUtil.getInstance().isLogin) {
            requestCarTypeDetail()
        } else {
            val intent = Intent(mContext, LoginActivity::class.java)
            intent.putExtra(CarEntity.EXTRA_BUNDLE_KEY, CarEntity.EXTRA_FLAG_CARDETAIL_NOLOGIN)
            startActivityForResult(intent, Constants.FROM_CAR_TYPE)
        }
    }


    private fun startBookActivity() {
        var intent: Intent? = null
        val mCarDetailJsonBean = CarDetailJsonBean()
        if (mCarDetailResult != null) {
            mCarDetailJsonBean.carDetail = mCarDetailResult
        }
        val json = Util.entityToJson(mCarDetailJsonBean)
        SharedPreferencesUtil.getInstance().setString(SharedPreferencesUtil.CAR_DETAIL_JSON, json)
        val status = SharedPreferencesUtil.getInstance().userAuth
        if (status == AuthUtil.USER_NOAUTH || status == AuthUtil.USER_AUTH_FAIL_REAPPLY) {
            intent = Intent(mContext, IdentificationActivity::class.java)
            intent.putExtra(CarEntity.EXTRA_BUNDLE_KEY, Constants.FROM_CAR_DETAIL)
        } else {
            intent = Intent(mContext, BookActivity::class.java)
            intent.putExtra(CarEntity.BOOK_CARID, Constants.FROM_CAR_DETAIL)
        }
        intent.flags = Intent.FLAG_ACTIVITY_CLEAR_TOP
        startActivity(intent)
    }

    private fun requestCarTypeDetail() {
        showLoadingDialog()

        val carDetailPresenter = CarDetailPresenterImpl(this, CarDetailResult::class.java)
        carDetailPresenter.addListener(mCarDetailResponse)

        val getDetailBean = GetDetailBean()
        if (!TextUtils.isEmpty(mSiteId)) {
            getDetailBean.siteid = mSiteId
        }
        if (!TextUtils.isEmpty(mCarTypeId)) {
            getDetailBean.car_type_id = mCarTypeId
        }
        if (SharedPreferencesUtil.getInstance().isLogin) {
            getDetailBean.uid = SharedPreferencesUtil.getInstance().uid
        }
        getDetailBean.from_time = mCarTypeTypeListPresenter?.mSureStartTime
        getDetailBean.to_time = mCarTypeTypeListPresenter?.mSureEndTime
        carDetailPresenter.getDetails(getDetailBean)
    }

    private val mCarDetailResponse = object : GeneralViewInterface {

        override fun getCodeBeanFail(errorCode: Int) {
            dismissLoadingDialog()
        }

        override fun getCodeObjectSuccess(bean: Any) {
            val result = bean as CarDetailResult
            if (result != null) {
                if (result.code == CarEntity.SUCC) {
                    mCarDetailResult = result
                    if (null != result.site) {
                        SharedPreferencesUtil.getInstance().lng = result.site.location?.lng.toString()
                        SharedPreferencesUtil.getInstance().lat = result.site.location?.lat.toString()
                    }
                    startBookActivity()
                }
            }
            dismissLoadingDialog()
        }
    }
}
