package com.jiaoyinbrother.monkeyking.activity

import android.app.Activity
import android.content.Intent
import android.support.v7.widget.RecyclerView
import android.support.v7.widget.RecyclerView.SCROLL_STATE_IDLE
import android.text.TextUtils
import android.util.Log
import android.view.View
import android.widget.RadioGroup
import com.google.gson.Gson
import com.jiaoyinbrother.monkeyking.CarEntity
import com.jiaoyinbrother.monkeyking.Constants
import com.jiaoyinbrother.monkeyking.R
import com.jiaoyinbrother.monkeyking.adapter.CarsContentAdapter
import com.jiaoyinbrother.monkeyking.adapter.CarsSubtitleAdapter
import com.jiaoyinbrother.monkeyking.bean.CarDetailJsonBean
import com.jiaoyinbrother.monkeyking.bean.CarDetailResult
import com.jybrother.sineo.library.bean.CarSearchBean
import com.jiaoyinbrother.monkeyking.bean.ChooseAddressBean
import com.jiaoyinbrother.monkeyking.util.*
import com.jiaoyinbrother.monkeyking.util.Util
import com.jiaoyinbrother.monkeyking.view.date.SelectDateTimeDialog
import com.jybrother.sineo.library.base.BaseActivity
import com.jybrother.sineo.library.bean.*
import com.jybrother.sineo.library.presenter.CarDetailPresenterImpl
import com.jybrother.sineo.library.presenter.CarTypeListPresenterImpl
import com.jybrother.sineo.library.util.*
import com.jybrother.sineo.library.view.GeneralViewInterface
import kotlinx.android.synthetic.main.activity_car_type_list_parity.*
import java.lang.ref.WeakReference
import java.util.ArrayList

class CarTypeListParityActivity : BaseActivity() {

    private val mContext = this
    private var mCarsSubtitleAdapter: CarsSubtitleAdapter? = null
    private var mCarsContentAdapter: CarsContentAdapter? = null
    private var mCarTypeListPresenter: CarTypeListPresenterImpl? = null
    private var mCarDetailPresenter: CarDetailPresenterImpl? = null
    companion object {
        var mWeakReference: WeakReference<Activity>? = null
    }

    override fun getLayoutId(): Int {
        return R.layout.activity_car_type_list_parity
    }

    override fun initView() {
        mCarsSubtitleAdapter = CarsSubtitleAdapter(mContext)
        subtitel_rv.adapter = mCarsSubtitleAdapter
        mCarsContentAdapter = CarsContentAdapter(mContext)
        content_rv.adapter = mCarsContentAdapter
        mWeakReference = WeakReference<Activity>(this)
    }

    override fun initToolBar() {
        mainTitle?.text = "选车列表"
    }
    private var mTotalDy = 0
    private var mDy = 0

    override fun initListeners() {
        content_rv.addOnScrollListener(object: RecyclerView.OnScrollListener(){
            override fun onScrolled(recyclerView: RecyclerView?, dx: Int, dy: Int) {
                super.onScrolled(recyclerView, dx, dy)
                mDy = dy
                mTotalDy -= dy
            }

            override fun onScrollStateChanged(recyclerView: RecyclerView?, newState: Int) {
                super.onScrollStateChanged(recyclerView, newState)
                if(newState == SCROLL_STATE_IDLE){
                    if (mDy > 0 && mCarTypeListPresenter!!.isShow) mCarTypeListPresenter?.hideAnimator?.start()
                    if (mDy < 0 && !mCarTypeListPresenter!!.isShow) mCarTypeListPresenter?.showAnimator?.start()
                }
            }
        })
        select_rg?.setOnCheckedChangeListener(object : RadioGroup.OnCheckedChangeListener{
            override fun onCheckedChanged(group: RadioGroup?, checkedId: Int) {
                when (checkedId) {
                    R.id.btn_0 -> mSort = CarTypeListParityRequest.SORT_DEFAULT
                    R.id.btn_1 -> mSort = CarTypeListParityRequest.SORT_PRICE
                    R.id.btn_2 -> mSort = CarTypeListParityRequest.SORT_DISTANCE
                }
                requestCarListParity()
            }

        })
        mCarsSubtitleAdapter?.setOnMyItemListener(object : CarsSubtitleAdapter.OnMyItemListener{
            override fun onItem(position: Int, categoriesBean: CategoriesBean?) {
                mCarsSubtitleAdapter?.selectItem(position)

                mIsRecommend = categoriesBean?.hot?:0
                mCategory = categoriesBean?.name
                requestCarListParity()
            }
        })
        mCarsContentAdapter?.setOnMyItemListener(object: CarsContentAdapter.OnMyItemListener{
            override fun onSiteMap(siteId: String?) {
                //Toast.makeText(mContext,"siteId>>"+siteId,Toast.LENGTH_SHORT).show()
                val intent = Intent(mContext, SiteDetailActivity::class.java)
                intent.putExtra("SiteDetailFromType", SiteDetailActivity.TYPE_FROM_CAR_DETAIL)
                intent.putExtra("siteDetailId", siteId)
                startActivity(intent)
            }

            override fun onBook(carTypeId: String?, siteId: String?) {
                mSiteId = siteId
                mCarTypeId = carTypeId
                onClickBook()
            }

            override fun onMoreSites(position: Int, carTypeId: String?,nextPage: Int) {
                mCarPosition = position
                mCarTypeId = carTypeId
                mPage = nextPage
                requestCartypeSites()
            }

        })
    }

    private var spTool: SharePreferenceTools? = null

    override fun initData() {
        spTool = SharePreferenceTools(this)

        mCarTypeListPresenter = CarTypeListPresenterImpl(mContext)
        mCarDetailPresenter = CarDetailPresenterImpl(this, CarDetailResult::class.java)
        mCarDetailPresenter?.addListener(mCarDetailResponse)

        mCarTypeListPresenter?.initAnimator(bottom_ll)
        initCarSearchBeanData()
        getIntentData()

        mIsRecommend = 1
        mCategory = null
        requestCarListParity()
    }

    private fun requestCarListParity(){
        showLoadingDialog()
        mRequestType = TYPE_CARS
        mCarTypeListPresenter?.requestCarListParity(
                getCarListParityEntity(mIsRecommend,mCategory,mSort),
                CarTypeListParityResult::class.java,
                mCarListParityRespons)
    }
    private fun requestCartypeSites(){
        showLoadingDialog()
        mRequestType = TYPE_SITES
        mCarTypeListPresenter?.requestCarTypeSites(
                getCarListParityEntity(mIsRecommend,mCategory,mSort),
                CarBean::class.java,
                mCartypeSitesResponse)
    }

    private var mRequestType = 0
    private val TYPE_CARS = 0
    private val TYPE_SITES = 1
    private var mIsRecommend = 0
    private var mCategory: String? = null
    private var mSort = 0
    private var mPage = 0

    private fun getCarListParityEntity(is_recommend: Int,category: String?,sort: Int) : CarTypeListParityRequest{
        val requestEntity = CarTypeListParityRequest()
        if (SharedPreferencesUtil.getInstance().isLogin) {
            requestEntity.uid = SharedPreferencesUtil.getInstance().uid
        }
        if (!TextUtils.isEmpty(mCarTypeListPresenter?.mCityStr)) {//取车城市
            requestEntity.setCity(mCarTypeListPresenter?.mCityStr)
        }
        if (!TextUtils.isEmpty(mCarTypeListPresenter?.mReturnCityStr)) {//还车城市
            requestEntity.setReturn_city(mCarTypeListPresenter?.mReturnCityStr)
        }
        if(mCarTypeListPresenter?.mSite != null && !TextUtils.isEmpty(mCarTypeListPresenter?.mSite?.siteid)){
            requestEntity.siteid = mCarTypeListPresenter?.mSite?.siteid
        }
        if (mCarTypeListPresenter?.mUserLacation != null) {
            requestEntity.setLocation(mCarTypeListPresenter?.mUserLacation)
        }
        if (!TextUtils.isEmpty(mCarTypeListPresenter?.mSureStartTime)) {
            requestEntity.setFrom_time(mCarTypeListPresenter?.mSureStartTime)
        }
        if (!TextUtils.isEmpty(mCarTypeListPresenter?.mSureEndTime)) {
            requestEntity.setTo_time(mCarTypeListPresenter?.mSureEndTime)
        }
        if (is_recommend == 1){
            requestEntity.is_recommend = 1
        }else{
            if (category != null){
                val categories: MutableList<String> = ArrayList()
                categories.add(category)
                requestEntity.categories = categories
            }
        }
        requestEntity.sort = sort
        if (mRequestType == TYPE_SITES){
            //更多网点
            requestEntity.page = mPage
            requestEntity.car_type_id = mCarTypeId
        }

        return requestEntity
    }

    private val mCarListParityRespons = object: GeneralViewInterface{
        override fun getCodeBeanFail(errorCode: Int) {
            dismissLoadingDialog()
            showErrorToast(errorCode)
            isHasData("")
        }

        override fun getCodeObjectSuccess(bean: Any?) {
            val result =  bean as CarTypeListParityResult
            dismissLoadingDialog()
            if (result == null) return
            var msg:String = ""
            if (result.code == CarEntity.SUCC){
                getConditionsData(result)
                getCartypesData(result)
                msg = result.result_msg?:""
            }else{
                showToast(result.msg)
                clearData()
                msg = result.msg?:""
            }
            isHasData(msg)
        }
    }

    private val mCartypeSitesResponse = object: GeneralViewInterface{
        override fun getCodeBeanFail(errorCode: Int) {
            dismissLoadingDialog()
            showErrorToast(errorCode)
        }

        override fun getCodeObjectSuccess(bean: Any?) {
            val result =  bean as CarBean
            dismissLoadingDialog()
            if (result == null) return
            if (result.code == CarEntity.SUCC){
                getMoreSitesData(result)
            }else{
                showToast(result.msg)
            }
        }
    }

    private fun getConditionsData(result: CarTypeListParityResult){
        if (result.conditions == null || result.conditions.categories == null || result.conditions.categories.size == 0) return
        val categoriesList = result.conditions.categories
        mCarsSubtitleAdapter?.list = categoriesList
        mCarsSubtitleAdapter?.notifyDataSetChanged()
    }
    private fun getCartypesData(result: CarTypeListParityResult){
        if (result.cartypes == null || result.cartypes.size == 0){
            clearData()
            return
        }
        val cartypes = result.cartypes
        mCarsContentAdapter?.list = cartypes
        mCarsContentAdapter?.list?.add(CarBean())
        mCarsContentAdapter?.notifyDataSetChanged()
        //content_rv.smoothScrollToPosition(0)
        content_rv.smoothScrollBy(0,mTotalDy)
    }

    private fun clearData(){
        mCarsContentAdapter?.list = null
        mCarsContentAdapter?.notifyDataSetChanged()
    }

    private fun isHasData(msg: String){
        root?.post(object : Runnable{
            override fun run() {
                if(mCarsContentAdapter?.itemCount == 0){
                    content_rv.visibility = View.GONE
                    no_data_ll.visibility = View.VISIBLE
                    no_data_tv.text = msg?:""
                }else{
                    content_rv.visibility = View.VISIBLE
                    no_data_ll.visibility = View.GONE
                }
            }
        })
    }

    private var mCarPosition = 0
    private var mCarTypeId: String? = null

    private fun getMoreSitesData(result: CarBean){
        if (result.sites == null || result.sites.size == 0) return
        val carBean = mCarsContentAdapter?.list?.get(mCarPosition) as CarBean
        carBean.sites.addAll(result.sites)
        carBean.last_site_num = result.last_site_num
        carBean.next_page++
        mCarsContentAdapter?.notifyItemChanged(mCarPosition)
    }



    private fun initCarSearchBeanData(){
        val json = SharedPreferencesUtil.getInstance().homePageScreen
        val carSearchBean = Util.jsonToEntity(json, CarSearchBean::class.java) as CarSearchBean
        if (carSearchBean == null){
            val cityStr = SharedPreferencesUtil.getInstance().userCityName
            val userLacation = LocationBean(SharedPreferencesUtil.getInstance().userusePointLng.toDouble(),
                    SharedPreferencesUtil.getInstance().userusePointLat.toDouble())
            mCarTypeListPresenter?.initCarSearchBean(cityStr,userLacation)
        }else{
            mCarTypeListPresenter?.getCarSearchBean(carSearchBean)
        }
        start_time_tv.text = mCarTypeListPresenter?.mStartTimeValue
        end_time_tv.text = mCarTypeListPresenter?.mEndTimeValue
        take_address_name_tv.text = mCarTypeListPresenter?.mTakeAddressName
        take_address_value_tv.text = mCarTypeListPresenter?.mTakeAddressValue
    }

    private fun getIntentData(){
        var site = intent?.getSerializableExtra(Constants.RESULT_VALUE)
        if (site != null) {
            mCarTypeListPresenter?.mSite = site as SiteBean2
            mCarTypeListPresenter?.mIsDifferentCity = false
            take_address_value_tv.setText(mCarTypeListPresenter?.mSite?.name?:"")
            if (mCarTypeListPresenter?.mCarSearchBean != null) {
                mCarTypeListPresenter?.mCarSearchBean?.setType(CarSearchBean.TYPE_SITE)
                mCarTypeListPresenter?.mCarSearchBean?.setDifferentCity(false)
            }
            saveCarSearchBeanData()
        }
    }

    private fun saveCarSearchBeanData(){
        val carSearchBean = mCarTypeListPresenter?.saveCarSearchBean()
        val json = Util.entityToJson(carSearchBean)
        SharedPreferencesUtil.getInstance().saveHomePageScreen(json)
    }

    /**
     * 选择取车时间
     */
    fun onSelectTakeTime(v: View) {
        StatisticsUtil.onEvent(this, ConstantsUtil.CHOOSE_CAR_CHANGE_TIME, "taketime")

        SelectDateTimeDialog.Builder(this)
                .setType(SelectDateTimeDialog.TYPE_START_TIME)
                .setStartTime(mCarTypeListPresenter?.mSelectStartTime)
                .setEndTime(mCarTypeListPresenter?.mSelectEndTime)
                .setOnResultBothListener { startDate, endDate ->
                    //LogUtilLib.e("*********************************startDate>>>>"+startDate+"******endDate>>>>"+endDate);
                    mCarTypeListPresenter?.mSelectStartTime = startDate
                    mCarTypeListPresenter?.mSelectEndTime = endDate
                    mCarTypeListPresenter?.setSureDate(startDate, endDate)
                    start_time_tv.text = mCarTypeListPresenter?.mStartTimeValue
                    end_time_tv.text = mCarTypeListPresenter?.mEndTimeValue
                    saveCarSearchBeanData()
                    requestCarListParity()
                }
                .show()
    }
    /**
     * 选择取车地址
     */
    fun onTakeAddress(v: View) {
        val intentType: String
        val intent: Intent
        val bean = ChooseAddressBean()
        bean.type = ChooseAddressBean.TYPE_NONE
        bean.city = mCarTypeListPresenter?.mCityStr
        bean.returnCity = mCarTypeListPresenter?.mReturnCityStr
        JsonConvertUtil.saveChooseAddrJson(spTool, Util.entityToJson(bean))
        if (mCarTypeListPresenter?.mIsDifferentCity?:false) {
            // 异地城市
            intent = Intent(mContext, ChooseRemoteActivity::class.java)
            intentType = ChooseRemoteActivity.TYPE_REMOTE_CITY_CARS
        } else {
            // 取车网点
            intent = Intent(mContext, SiteListActivity::class.java)
            intent.putExtra("SiteDetailFromType", SiteDetailActivity.TYPE_FROM_CARLIST_CHANGE_SITE)
            intentType = SiteListActivity.TYPE_SITE_SEARCH_CARS
        }
        intent.putExtra(Constants.ENTRY_TYPE, intentType)
        startActivity(intent)
    }


    private fun onClickBook() {
        if (SharedPreferencesUtil.getInstance().isLogin) {
            requestCarTypeDetail()
        } else {
            val intent = Intent(mContext, LoginActivity::class.java)
            intent.putExtra(CarEntity.EXTRA_BUNDLE_KEY, CarEntity.EXTRA_FLAG_CARDETAIL_NOLOGIN)
            startActivityForResult(intent, Constants.FROM_CAR_TYPE)
        }
    }

    private var mCarDetailResult: CarDetailResult? = null
    private var mSiteId: String? = null

    private fun requestCarTypeDetail() {
        showLoadingDialog()

        val getDetailBean = GetDetailBean()
        if (!TextUtils.isEmpty(mSiteId)) {
            getDetailBean.siteid = mSiteId
        }
        if (!TextUtils.isEmpty(mCarTypeId)) {
            getDetailBean.car_type_id = mCarTypeId
        }
        if (SharedPreferencesUtil.getInstance().isLogin) {
            getDetailBean.uid = SharedPreferencesUtil.getInstance().uid
        }
        getDetailBean.from_time = mCarTypeListPresenter?.mSureStartTime
        getDetailBean.to_time = mCarTypeListPresenter?.mSureEndTime
        mCarDetailPresenter?.getDetails(getDetailBean)
    }


    private val mCarDetailResponse = object : GeneralViewInterface {

        override fun getCodeBeanFail(errorCode: Int) {
            dismissLoadingDialog()
        }

        override fun getCodeObjectSuccess(bean: Any) {
            val result = bean as CarDetailResult
            if (result != null) {
                if (result.code == CarEntity.SUCC) {
                    mCarDetailResult = result
                    if (null != result.site) {
                        SharedPreferencesUtil.getInstance().lng = result.site.location?.lng.toString()
                        SharedPreferencesUtil.getInstance().lat = result.site.location?.lat.toString()
                    }
                    startBookActivity()
                }
            }
            dismissLoadingDialog()
        }
    }

    private fun startBookActivity() {
        var intent: Intent? = null
        val mCarDetailJsonBean = CarDetailJsonBean()
        if (mCarDetailResult != null) {
            mCarDetailJsonBean.carDetail = mCarDetailResult
        }
        val json = Util.entityToJson(mCarDetailJsonBean)
        SharedPreferencesUtil.getInstance().setString(SharedPreferencesUtil.CAR_DETAIL_JSON, json)
        val status = SharedPreferencesUtil.getInstance().userAuth
        if (status == AuthUtil.USER_NOAUTH || status == AuthUtil.USER_AUTH_FAIL_REAPPLY) {
            intent = Intent(mContext, IdentificationActivity::class.java)
            intent.putExtra(CarEntity.EXTRA_BUNDLE_KEY, Constants.FROM_CAR_DETAIL)
        } else {
            intent = Intent(mContext, BookActivity::class.java)
            intent.putExtra(CarEntity.BOOK_CARID, Constants.FROM_CAR_DETAIL)
        }
        intent.flags = Intent.FLAG_ACTIVITY_CLEAR_TOP
        startActivity(intent)
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        if (null == data) {
            return
        }
        val b = data.extras
        when (resultCode) {
            Constants.FROM_CAR_TYPE -> {
                //从登陆返回
                val code = b?.getString(CarEntity.EXTRA_BUNDLE_KEY)
                if (code == "setResult") {
                    requestCarTypeDetail()
                }
            }
        }
    }
}
