package com.jiaoyinbrother.monkeyking.activity

import android.content.Intent
import android.widget.Button
import com.jiaoyinbrother.monkeyking.CarEntity
import com.jiaoyinbrother.monkeyking.R
import com.jiaoyinbrother.monkeyking.util.AuthUtil
import com.jiaoyinbrother.monkeyking.util.LocationUtil
import com.jiaoyinbrother.monkeyking.util.SharedPreferencesUtil
import com.jiaoyinbrother.monkeyking.util.Util
import com.jybrother.sineo.library.base.BaseActivity
import com.jybrother.sineo.library.util.ConstantsUtil
import com.jybrother.sineo.library.util.StatisticsUtil
import com.jybrother.sineo.library.util.TextViewUtil
import kotlinx.android.synthetic.main.activity_certification_result.*

class CertificationResultActivity : BaseActivity() {

    private var title: String? = null
    private var userStatus = 2


    override fun getLayoutId(): Int {
        val it = this.intent

        if (it.hasExtra(CarEntity.EXTRA_BUNDLE_KEY)) {
            val b = it.extras
            title = b.getString(TENANT)
            userStatus = b.getInt("userStatus")

        }
        return R.layout.activity_certification_result
    }

    override fun initView() {

    }

    override fun initToolBar() {

    }

    override fun initListeners() {

    }

    override fun initData() {
        (findViewById(R.id.ivTitleName) as Button).text = "实名认证"

        if (userStatus == AuthUtil.USER_AUTHING) {
            // 认证中
            act_tenant_suss_img_iv.setImageResource(R.mipmap.certificating)
            act_tenant_suss_status_tv.text = "认证中"
            act_tenant_suss_text1_tv.text = "我们正全力审核中，请耐心等待。"
            button_left.text = "联系客服"
            button_left.setOnClickListener{ handleCustomService()}
            button_right.text = "去看看车"
            button_right.setOnClickListener{ handleCarList()}
        } else if (userStatus == AuthUtil.USER_AUTHED) {
            // 认证成功
            act_tenant_suss_img_iv.setImageResource(R.mipmap.certification_passed)
            act_tenant_suss_status_tv.text = "认证通过"
            act_tenant_suss_text1_tv.text = "想租好车？赶紧去升级吧~"
            button_left.text = "会员升级"
            button_left.setOnClickListener{handleLevelUpdate()}
            button_right.text = "去看看车"
            button_right.setOnClickListener{handleCarList()}
            TextViewUtil.setButtonStatus(button_right, this@CertificationResultActivity, TextViewUtil.BUTTON_ENABLE_NORMAL)
        } else if (userStatus == AuthUtil.USER_AUTH_FAIL_NO_REAPPLY) {
            // 认证失败(不重新提交)
            act_tenant_suss_img_iv.setImageResource(R.mipmap.certification_fail)
            act_tenant_suss_status_tv.text = "认证未通过"
            act_tenant_suss_text1_tv.text = SharedPreferencesUtil.getInstance().getString(SharedPreferencesUtil.AUTH_COMMENTS)
            button_left.text = "联系客服"
            button_left.setOnClickListener{handleCustomService()}
            button_right.text = "返回首页"
            button_right.setOnClickListener{handleHome()}
        } else if (userStatus == AuthUtil.USER_AUTH_FAIL_REAPPLY) {
            // 认证失败(重新提交)
            act_tenant_suss_img_iv.setImageResource(R.mipmap.certification_fail)
            act_tenant_suss_status_tv.text = "认证未通过"
            act_tenant_suss_text1_tv.text = SharedPreferencesUtil.getInstance().getString(SharedPreferencesUtil.AUTH_COMMENTS)
            button_left.text = "联系客服"
            button_left.setOnClickListener{handleCustomService()}
            button_right.text = "重新提交"
            button_right.setOnClickListener{handleResubmit()}
        }
    }

    private fun handleResubmit() {
        // 认证失败(重新提交)
        startActivity(Intent(this@CertificationResultActivity, IdentificationActivity::class.java))
        finish()
    }

    private fun handleHome() {
        // 认证失败(不重新提交)
        startActivity(Intent(this@CertificationResultActivity, MonkeyMainActivity::class.java))
        finish()
    }

    private fun CertificationResultActivity.handleLevelUpdate() {
        startActivity(Intent(this@CertificationResultActivity, LevelUpgradeActivity::class.java))
        finish()
    }

    private fun handleCarList() {
        StatisticsUtil.onEvent(this,ConstantsUtil.AUTH_STATUS_CHOOSE_CAR,"")
        var intent: Intent? = null
        intent = if (LocationUtil.isParityCity()) {
            Intent(this@CertificationResultActivity, CarTypeListParityActivity::class.java)
        } else {
            Intent(this@CertificationResultActivity, CarTypeListActivity::class.java)
        }
        startActivity(intent)
        finish()
    }

    private fun handleCustomService() {
        StatisticsUtil.onEvent(this, ConstantsUtil.AUTH_STATUS_CUSTOMER_SERVICE,"")
        Util.contactService(this@CertificationResultActivity)
    }

    companion object {
        val TENANT = "tenant"
    }

}
