package com.jiaoyinbrother.monkeyking.activity

import android.app.Activity
import android.content.Intent
import android.os.AsyncTask
import android.view.View
import android.widget.Button
import android.widget.LinearLayout
import android.widget.TextView
import com.camnter.easyrecyclerview.adapter.EasyRecyclerViewAdapter
import com.camnter.easyrecyclerview.holder.EasyRecyclerViewHolder
import com.jiaoyinbrother.monkeyking.CarEntity
import com.jiaoyinbrother.monkeyking.R
import com.jiaoyinbrother.monkeyking.bean.GetWkrecordsEntity
import com.jiaoyinbrother.monkeyking.bean.GetWkrecordsResult
import com.jiaoyinbrother.monkeyking.bean.Wkrecords
import com.jiaoyinbrother.monkeyking.network.CarLib
import com.jiaoyinbrother.monkeyking.util.AuthUtil
import com.jiaoyinbrother.monkeyking.util.NetUtil
import com.jiaoyinbrother.monkeyking.util.SharedPreferencesUtil
import com.jybrother.sineo.library.base.BaseActivity
import com.jybrother.sineo.library.util.LogUtil
import com.jybrother.sineo.library.util.OldToastUtil
import kotlinx.android.synthetic.main.activity_my_wookong_coin.*

class MyWookongCoinActivity : BaseActivity() {
    private val REQUEST_TRANSFERPAY = 0

    private var pageNo = 1
    private var mCarLib: CarLib? = null
    private var isIntegralDetailTaskRun = false

    private var integralRecyclerAdapter: WookingCoinRecyclerAdapter? = null
    private var mData: ArrayList<Wkrecords>? = null

    override fun getLayoutId(): Int {
        return R.layout.activity_my_wookong_coin
    }

    override fun initView() {

    }

    override fun initToolBar() {

    }

    override fun initListeners() {
        refresh_layout.setRefreshListener {
            pageNo = 1
            getWookongCoinDetail()
        }
        refresh_layout.setMoreListener { getWookongCoinDetail() }
    }

    private var wkcoin_transfer = 0
    override fun initData() {

        wkcoin_transfer = 0

        if (intent.hasExtra("wkcoin_transfer")) {
            wkcoin_transfer = intent.getIntExtra("wkcoin_transfer", 0)
        }


        (findViewById(R.id.ivTitleName) as Button).text = "悟空币明细"
        findViewById(R.id.ivTitleBtnRight_ll).visibility = View.INVISIBLE

        pageNo = 1
        mData = ArrayList()
        refresh_layout.setFooter()


        integralRecyclerAdapter = WookingCoinRecyclerAdapter(wookongCoinTransferCallback)
        recyclerview_wookongcoin.adapter = integralRecyclerAdapter

        getWookongCoinDetail()
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        if (requestCode == REQUEST_TRANSFERPAY && resultCode == Activity.RESULT_OK) {
            getWookongCoinDetail()
        }
    }

    //充值
    private val wookongCoinTransferCallback = object : WookongCoinTransferCallback {
        override fun transferPressed() {
            if (SharedPreferencesUtil.getInstance().isLogin && SharedPreferencesUtil.getInstance().userAuth == AuthUtil.USER_AUTHED) {
                val intent = Intent(this@MyWookongCoinActivity, TransferActivity::class.java)
                startActivityForResult(intent, REQUEST_TRANSFERPAY)
            } else {
                OldToastUtil.show(this@MyWookongCoinActivity, "请先通过实名认证")
            }
        }
    }

    /**
     * 获取用户账户余额
     */
    private fun getWookongCoinDetail() {
        if (!isIntegralDetailTaskRun) {
            isIntegralDetailTaskRun = true
            AmountDetailAsyncTask().execute()
        }
    }

    private inner class AmountDetailAsyncTask : AsyncTask<Void, Void, GetWkrecordsResult>() {

        override fun onPreExecute() {
            super.onPreExecute()
            showLoadingDialog()
        }

        override fun doInBackground(vararg params: Void): GetWkrecordsResult {
            if (null == mCarLib)
                mCarLib = CarLib.getInstance(applicationContext)
            val gre = GetWkrecordsEntity()
            gre.uid = SharedPreferencesUtil.getInstance().uid
            gre.page = pageNo
            gre.page_size = PAGE_SIZE
            var grr = GetWkrecordsResult()
            try {
                grr = mCarLib?.postRequest(gre.toJson(gre), "account/wkcoin/get_records",
                        GetWkrecordsResult::class.java) as GetWkrecordsResult
            } catch (e: Exception) {
                NetUtil.handlePostException(grr, e)
            }
            return grr
        }

        override fun onPostExecute(result: GetWkrecordsResult?) {
            super.onPostExecute(result)
            dismissLoadingDialog()

            refresh_layout.refreshIsEnd()
            refresh_layout.loadMoreIsEnd()

            isIntegralDetailTaskRun = false

            if (result == null) return

            when (result.code) {
                CarEntity.SUCC -> {

//                    第一页，清除数据，footer
                    if (pageNo == 1) {
                        mData?.clear()
//                        添加header使用数据
                        val header = Wkrecords()
                        header.amount = result.total.toInt()
//                        使用type,传递是否可以转账
                        header.type = wkcoin_transfer
                        mData?.add(header)
                        deleteFooter()
                    }

                    mData?.addAll(result.records ?: ArrayList())

                    if (result.records.size < PAGE_SIZE) {
//                        最后的数据
                        if (result.records.size > 0) {
                            addFooter()
                        } else {
//                            个数为0， 如果是第一页，空页面；不是第一页，添加footer
                            if (pageNo > 1) {
                                addFooter()
                            }
                        }
                    } else {
                        // 还有数据
                    }
                    integralRecyclerAdapter?.list = mData
                    integralRecyclerAdapter?.notifyDataSetChanged()
                    pageNo++

                }
                else -> showToast(result.msg)
            }
            LogUtil.e("integralRecyclerAdapter?.itemCount =" + integralRecyclerAdapter?.itemCount)
            if (integralRecyclerAdapter?.itemCount!! <= 1) {
                my_integral_no_data.visibility = View.VISIBLE
                refresh_layout.visibility = View.GONE
            } else {
                my_integral_no_data.visibility = View.GONE
                refresh_layout.visibility = View.VISIBLE
            }
        }
    }


    private fun deleteFooter() {
        integralRecyclerAdapter?.deleteFooter()
        isFooterAdded = false
    }

    private var isFooterAdded = false

    private fun addFooter() {

        if (isFooterAdded)
            return

        integralRecyclerAdapter?.addFooter()
        val footer = Wkrecords()// bug 重复添加
        mData?.add(footer)
        isFooterAdded = true
    }


    companion object {
        private val PAGE_SIZE = 20
    }


    interface WookongCoinTransferCallback {
        fun transferPressed()
    }
}

internal class WookingCoinRecyclerAdapter(private var transferCallback: MyWookongCoinActivity.WookongCoinTransferCallback) : EasyRecyclerViewAdapter() {
    private var footer = false

    override fun getRecycleViewItemType(position: Int): Int {
        return when (position) {
            0 -> 0
            itemCount - 1 -> {
                if (footer) 2 else 1
            }
            else -> 1
        }
    }

    override fun onBindRecycleViewHolder(viewHolder: EasyRecyclerViewHolder, position: Int) {
        val recycleViewItemType = getRecycleViewItemType(position)
        when (recycleViewItemType) {
            0 -> onBindHeaderViewHolder(viewHolder, position)
            1 -> onBindIntegralItemViewHolder(position, viewHolder)
        }
    }

    private fun onBindHeaderViewHolder(viewHolder: EasyRecyclerViewHolder, position: Int) {
        val entity = list[position] as Wkrecords

        val total = viewHolder.findViewById<TextView>(R.id.all)
        total.text = entity.amount.toString()

//        转账回调
        val transfer = viewHolder.findViewById<LinearLayout>(R.id.transfer);
        transfer.setOnClickListener {
            transferCallback.transferPressed()
        }

        if (entity.type == 0) {
            transfer.visibility = View.GONE
        } else {
            transfer.visibility = View.VISIBLE
        }

    }

    private fun onBindIntegralItemViewHolder(position: Int, viewHolder: EasyRecyclerViewHolder) {
        val entity = list[position] as Wkrecords

        val type = viewHolder.findViewById<TextView>(R.id.type)
        val count = viewHolder.findViewById<TextView>(R.id.count)
        val time = viewHolder.findViewById<TextView>(R.id.time)

        if (null != entity) {
            if (null != entity.time) {
                val strs = entity.time.split("[ ]".toRegex()).dropLastWhile({ it.isEmpty() }).toTypedArray()
                time.text = strs[0]
            }
            count.text = entity.amount.toString()

            // 类型（1：支出收入，2：收入，3：转入，4：转出，5：兑换，6：注册，7：认证，8：用车，9：油费）
            when (entity.type) {
                0 -> type.text = ("扣除" + entity.amount + "元悟空币。")
                1 -> type.text = ("支出"
                        + entity.amount + "元悟空币。")
                2 -> type.text = ("收入"
                        + entity.amount + "元悟空币。")
                3 -> type.text = ("转入"
                        + entity.amount + "元悟空币。")
                4 -> type.text = ("转出"
                        + entity.amount + "元悟空币。")
                5 -> type.text = ("兑换"
                        + entity.amount + "元悟空币。")
                6 -> type.text = ("您邀请的好友成功入驻悟空平台，送您"
                        + entity.amount + "元悟空币。")
                7 -> type.text = ("您的朋友认证了，送您"
                        + entity.amount + "元悟空币。")
                8 -> type.text = ("您的朋友用车了，送您"
                        + entity.amount + "元悟空币。")
                9 -> type.text = ("油费返还"
                        + entity.amount + "元悟空币。")
                10 -> type.text = "冻结"
                11 -> type.text = "解冻"
                12 -> type.text = "退还"
//                12 -> type.text = "退款" + entity.amount + "元悟空币。"
                else -> type.text = ("未知"
                        + entity.amount + "元悟空币。")
            }
        }
    }

    override fun getItemLayouts(): IntArray {
        return intArrayOf(R.layout.layout_my_wookong_item_header, R.layout.adapter_wkcoinitem, R.layout.layout_footer_all_data)
    }

    fun addFooter() {
        this.footer = true
    }

    fun deleteFooter() {
        this.footer = false
    }

}
