package com.jiaoyinbrother.monkeyking.activity

import android.annotation.SuppressLint
import android.content.BroadcastReceiver
import android.content.Context
import android.content.Intent
import android.content.IntentFilter
import android.support.v4.content.ContextCompat
import android.support.v7.widget.GridLayoutManager
import android.text.SpannableString
import android.text.Spanned
import android.text.TextPaint
import android.text.TextUtils
import android.text.method.LinkMovementMethod
import android.text.style.ClickableSpan
import android.text.style.ForegroundColorSpan
import android.view.View
import cn.sharesdk.framework.Platform
import com.camnter.easyrecyclerview.holder.EasyRecyclerViewHolder
import com.jiaoyinbrother.monkeyking.CarEntity
import com.jiaoyinbrother.monkeyking.Constants
import com.jiaoyinbrother.monkeyking.R
import com.jiaoyinbrother.monkeyking.adapter.RuleAdapter
import com.jiaoyinbrother.monkeyking.fragment.DialogInvisibleOKFragment
import com.jiaoyinbrother.monkeyking.util.AuthUtil
import com.jiaoyinbrother.monkeyking.util.DialogUtil
import com.jiaoyinbrother.monkeyking.util.NetUtil
import com.jiaoyinbrother.monkeyking.util.SharedPreferencesUtil
import com.jiaoyinbrother.monkeyking.view.CommentListLayout
import com.jiaoyinbrother.monkeyking.view.IOSdialog.IOSAlertDialog
import com.jiaoyinbrother.monkeyking.view.SharePopupWindow
import com.jybrother.sineo.library.base.BaseActivity
import com.jybrother.sineo.library.bean.*
import com.jybrother.sineo.library.presenter.OrderPresenterImpl
import com.jybrother.sineo.library.util.*
import com.jybrother.sineo.library.view.GeneralViewInterface
import com.jybrother.sineo.library.widget.*
import kotlinx.android.synthetic.main.activity_order_detail.*
import org.json.JSONObject

/**
 * 订单详情
 * by Soda on 2018/4/05.
 */
@SuppressLint("SetTextI18n")
class OrderDetailActivity : BaseActivity(), View.OnClickListener, DialogInvisibleOKFragment.YesNoDialogListener,
        EasyRecyclerViewHolder.OnItemClickListener {

    private var mOrderID: String? = null
    private var userRoles: Int? = null
    private var mOrderDetail: OrderDetailResult? = null
    private val mOrderTimeArray = arrayOf("", "", "", "", "", "", "")
    private var mRuleAdapter: RuleAdapter? = null
    private var mShareResult: OrderShareResult? = null

    override fun getLayoutId(): Int {
        getExtra()
        return R.layout.activity_order_detail
    }

    private fun getExtra() {
        mOrderID = intent.extras.getString(ConstantsUtil.ORDER_ID)
        LogUtil.e("mOrderID=$mOrderID")
    }

    override fun initView() {}

    override fun initToolBar() {
        mainTitle.text = "订单详情"
        subTitle.text = "取消订单"
    }

    override fun initListeners() {
        refreshLayout.setRefreshListener { getOrderDetail() }
        // 取还车相关
        orderSiteInfoView.setListener(object : OrderSiteInfoView.OrderSiteInfoListener {

            override fun onTakingPic(result: OrderDetailResult?, status: String) {
                if (status == TakingPicturesActivity.FLAG_TAKE_PIC) {
                    val intent = Intent(this@OrderDetailActivity, TakingPicturesActivity::class.java)
                    intent.putExtra(Constants.FLAG_TAKING_PIC, TakingPicturesActivity.FLAG_TAKE_PIC)
                    intent.putExtra(Constants.KEY_ORDER_DETAIL, result)
                    startActivity(intent)
                } else {
                    if (result?.return_car_image != null) {
                        if (result.return_car_image?.status_code ?: 0 == 0) {
                            // 已认证 & 认证失败
                            val intent = Intent(this@OrderDetailActivity, AuditResultActivity::class.java)
                            intent.putExtra("OrderResult", result)
                            startActivity(intent)
                        } else {
                            val intent = Intent(this@OrderDetailActivity, TakingPicturesActivity::class.java)
                            intent.putExtra(Constants.FLAG_TAKING_PIC, TakingPicturesActivity.FLAG_RETURN_FINISH)
                            intent.putExtra(Constants.KEY_ORDER_DETAIL, result)
                            if (result.return_car_image?.status_code == 1) {
                                intent.putExtra("fromSucc", "fromSucc")
                            }
                            startActivity(intent)
                        }
                    }
                }
            }

            override fun onRenterInfo(renterID: String) {
                val intent = Intent(this@OrderDetailActivity, RenterPhotoActivity::class.java)
                intent.putExtra("renterid", renterID)
                startActivity(intent)
            }

            override fun onCallPhone(phoneNum: String) {
                DialogUtil.onSiteDial(this@OrderDetailActivity, phoneNum)
            }

            override fun onSeeEvaluate(adminNum: String) {
                StatisticsUtil.onEvent(this@OrderDetailActivity, ConstantsUtil.ORDER_DETAIL_MARK, ConstantsUtil.ORDER_DETAIL_MARK)
                if (!TextUtils.isEmpty(adminNum)) {
                    val intent = Intent(this@OrderDetailActivity, SiteInfoCommentActivity::class.java)
                    intent.putExtra("SITE_MANAGER_ID", adminNum)
                    SharedPreferencesUtil.getInstance().commondUid = adminNum
                    intent.putExtra("type", CommentListLayout.TYPE_PERSON)
                    startActivity(intent)
                }
            }

            override fun onSiteInfo(siteID: String) {
                val intent = Intent(this@OrderDetailActivity, SiteDetailActivity::class.java)
                intent.putExtra("SiteDetailFromType", SiteDetailActivity.TYPE_FROM_CAR_DETAIL)
                intent.putExtra("siteDetailId", siteID)
                startActivity(intent)
            }
        })

        orderDepositView.setListener(object : OrderDepositView.OrderDepositListener {
            override fun onRefundInfo() {
                com.jiaoyinbrother.monkeyking.util.Util.onBackMoney(this@OrderDetailActivity)
            }

            override fun onPrompt(isHide: Boolean, prompt: String, target: Int) {
                warmPrompt.visibility = if (isHide) View.GONE else View.VISIBLE
                warmPrompt.highlightColor = ContextCompat.getColor(this@OrderDetailActivity, android.R.color.transparent)//防止点击后有默认背景色
                if (!TextUtils.isEmpty(prompt)) {
                    val sp = SpannableString(prompt)
                    sp.setSpan(object : ClickableSpan() {
                        override fun updateDrawState(ds: TextPaint) {
                            super.updateDrawState(ds)
                            ds.isUnderlineText = false
                        }

                        override fun onClick(v: View) {
                            when (target) {
                                OrderDepositView.NONE -> {
                                }
                                OrderDepositView.VEHICLE -> {
                                    onPayDeposit(ConstantsUtil.PAY_PROJECT_VEHICLE)
                                }
                                OrderDepositView.ILLEGA -> {
                                    if (TextUtils.isEmpty(Util.getDepositBean(mOrderDetail, ConstantsUtil.PAY_PROJECT_ILLEGAL).description)) {
                                        onPayDeposit(ConstantsUtil.PAY_PROJECT_ILLEGAL)
                                    } else {
                                        ExplainDialog(this@OrderDetailActivity).builder().setTitle("违章押金说明")
                                                .setMsg(Util.getDepositBean(mOrderDetail, ConstantsUtil.PAY_PROJECT_ILLEGAL).description, true)
                                                .onSure("立即支付", { onPayDeposit(ConstantsUtil.PAY_PROJECT_ILLEGAL); }).show()
                                    }
                                }
                            }
                        }
                    }, sp.length - 12, sp.length, Spanned.SPAN_INCLUSIVE_INCLUSIVE)
                    sp.setSpan(ForegroundColorSpan(ContextCompat.getColor(this@OrderDetailActivity, R.color.color_8)), sp.length - 12, sp.length, Spanned.SPAN_EXCLUSIVE_EXCLUSIVE)
                    warmPrompt.text = sp
                    warmPrompt.movementMethod = LinkMovementMethod.getInstance()
                }
            }

            override fun onVehicleDeposit() {
                //支付车辆押金
                StatisticsUtil.onEvent(this@OrderDetailActivity, ConstantsUtil.ORDER_DETAIL_CAR_DEPOSIT, ConstantsUtil.ORDER_DETAIL_CAR_DEPOSIT)
                onPayDeposit(ConstantsUtil.PAY_PROJECT_VEHICLE)
            }

            override fun onIllegalDeposit(mIllegeDesc: String?) {
                //支付违章押金
                StatisticsUtil.onEvent(this@OrderDetailActivity, ConstantsUtil.ORDER_DETAIL_ILLEGAL_DEPOSIT, ConstantsUtil.ORDER_DETAIL_ILLEGAL_DEPOSIT)
                if (TextUtils.isEmpty(mIllegeDesc)) {
                    onPayDeposit(ConstantsUtil.PAY_PROJECT_ILLEGAL)
                } else {
                    ExplainDialog(this@OrderDetailActivity).builder().setTitle("违章押金说明")
                            .setMsg(mIllegeDesc, true).onSure("立即支付", { onPayDeposit(ConstantsUtil.PAY_PROJECT_ILLEGAL) }).show()
                }
            }
        })

        orderBottomBtn.setListener(object : OrderButton.OrderBtnListener {
            override fun smallOne(mStatus: Int?) {
                when (mStatus) {
                    4 -> {// 确认交车(车管)
                        val intent = Intent(this@OrderDetailActivity, ConfirmCarActivity::class.java)
                        intent.putExtra("order_detail", mOrderDetail)
                        startActivityForResult(intent, Constants.CONFIRM_SALOON_CAR_CODE)
                    }
                    5 -> {// 申请结算(车管) || 续租(用户)
                        if (userRoles == 0) {
                            StatisticsUtil.onEvent(this@OrderDetailActivity, ConstantsUtil.ORDER_DETAIL_RENEW, ConstantsUtil.ORDER_DETAIL_RENEW)
                            val intent = Intent(this@OrderDetailActivity, ReletActivity::class.java)
                            intent.putExtra(ConstantsUtil.ORDER_RESULT, mOrderDetail)
                            startActivityForResult(intent, Constants.RELET_CODE)
                        } else {
                            val intent = Intent(this@OrderDetailActivity, SettlementForOwnerActivity::class.java)
                            intent.putExtra("order_detail", mOrderDetail)
                            startActivityForResult(intent, Constants.CLOSE_ACCT_CODE)
                        }
                    }
                    6 -> {// 代客支付(车管) || 费用结算(用户)
                        val intent = Intent(this@OrderDetailActivity, SettlementForRenterActivity::class.java)
                        if (userRoles == 0) {
                            intent.putExtra("Flag", "确认结算")
                        } else {
                            intent.putExtra("Flag", "代客支付")
                        }
                        intent.putExtra("order_detail", mOrderDetail)
                        startActivityForResult(intent, Constants.CLOSE_ACCT_CODE)
                    }
                }
            }

            override fun smallTwo(mStatus: Int?) {
                when (mStatus) {
                    4 -> {// 换车(车管)
                        val intent = Intent(this@OrderDetailActivity, ChangeCarActivity::class.java)
                        intent.putExtra(ConstantsUtil.ORDER_RESULT, mOrderDetail)
                        startActivityForResult(intent, Constants.CHANGE_CAR_CODE)
                    }
                    5 -> {// 提前还车(用户)
                        StatisticsUtil.onEvent(this@OrderDetailActivity, ConstantsUtil.ORDER_DETAIL_RETURN_CAR, ConstantsUtil.ORDER_DETAIL_RETURN_CAR)
                        val intent = Intent(this@OrderDetailActivity, AdvanceBackActivity::class.java)
                        intent.putExtra(ConstantsUtil.ORDER_RESULT, mOrderDetail)
                        startActivityForResult(intent, Constants.ADVANCE_CODE)
                    }
                }
            }

            override fun bigThree(mStatus: Int?) {
                when (mStatus) {
                    1 -> {// 预付租金(用户)
                        StatisticsUtil.onEvent(this@OrderDetailActivity, ConstantsUtil.ORDER_DETAIL_PREPAY, ConstantsUtil.ORDER_DETAIL_PREPAY)
                        onPayDeposit(ConstantsUtil.PAY_PROJECT_RENT)
                    }
                    3 -> {// 支付违章押金(用户)
                        onPayDeposit(ConstantsUtil.PAY_PROJECT_ILLEGAL)
                    }
                    else -> {// 评价(用户)
                        val intent = Intent(this@OrderDetailActivity, EvaluateActivity::class.java)
                        intent.putExtra(CarEntity.CMMT_SINGLE_ID, mOrderDetail?.ownerid)
                        intent.putExtra(ConstantsUtil.ORDER_ID, mOrderDetail?.orderid)
                        startActivityForResult(intent, Constants.COMMENT_SINGLE_CODE)
                    }
                }
            }
        })
        mRuleAdapter?.setOnItemClickListener(this)
        subTitle.setOnClickListener(this)
        carImg.setOnClickListener(this)
        carRemote.setOnClickListener(this)
        costLayout.setOnClickListener(this)
        checkVehicleLayout.setOnClickListener(this)
        contactService.setOnClickListener(this)
        complaints.setOnClickListener(this)
        onLevelUpLayout.setOnClickListener(this)
        onLevelUp.setOnClickListener(this)
        unAuthLayout.setOnClickListener(this)
        onAuth.setOnClickListener(this)
        shareOrder.setOnClickListener(this)
    }

    override fun initData() {
        userRoles = SharedPreferencesUtil.getInstance().role
        complaints.visibility = if (userRoles == 0) View.VISIBLE else View.GONE
        mRuleAdapter = RuleAdapter(this@OrderDetailActivity)
        val manager = GridLayoutManager(this, 2)
        rulesRv.layoutManager = manager
        mRuleAdapter?.list = setRules()
        val decoration = SimpleItemDecoration(this@OrderDetailActivity, R.color.color_1)
        rulesRv.addItemDecoration(decoration)
        rulesRv.adapter = mRuleAdapter
        getOrderDetail()
    }

    override fun onClick(v: View?) {
        if (!NetUtil.isNetworkAvailable(this@OrderDetailActivity))
            return
        when (v?.id) {
        // 级别升级消失
            R.id.onLevelUpLayout -> onLevelUpLayout.visibility = View.GONE
        // 级别升级
            R.id.onLevelUp -> startActivity(LevelUpgradeActivity::class.java)
        // 未认证消失
            R.id.unAuthLayout -> unAuthLayout.visibility = View.GONE
        // 实名认证
            R.id.onAuth -> startActivity(IdentificationActivity::class.java)
        //订单分享
            R.id.shareOrder -> orderShare()
        // 取消订单
            R.id.subTitle -> {
                StatisticsUtil.onEvent(this, ConstantsUtil.ORDER_DETAIL_CANCEL, ConstantsUtil.ORDER_DETAIL_CANCEL)
                val intent = Intent(this@OrderDetailActivity, OrderCancelActivity::class.java)
                intent.putExtra("orderid", mOrderDetail?.orderid)
                intent.putExtra("total_amount", mOrderDetail?.bill?.total_amount)
                startActivityForResult(intent, Constants.ORDER_CANCEL_CODE)
            }
        // 跳转车型详情
            R.id.carImg -> {
                val intent = Intent(this@OrderDetailActivity, CarTypeDetailActivity::class.java)
                val mGetDetailBean = GetDetailBean()
                mGetDetailBean.siteid = mOrderDetail?.site?.siteid
                mGetDetailBean.car_type_id = mOrderDetail?.car_type_id
                mGetDetailBean.from_time = mOrderDetail?.start_time
                mGetDetailBean.to_time = mOrderDetail?.end_time
                intent.putExtra(CarEntity.EXTRA_BUNDLE_SITEID_KEY, mGetDetailBean)
                intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK)
                startActivity(intent)
            }
        // 智能钥匙
            R.id.carRemote -> {
                val carDeposit = Util.getDepositBean(mOrderDetail, ConstantsUtil.PAY_PROJECT_VEHICLE)
                if (carDeposit?.status_code == DepositBean.DEPOSIT_PAYED) {
                    val intent = Intent(this@OrderDetailActivity, RemoteCarActivity::class.java)
                    intent.putExtra(CarEntity.EXTRA_BUNDLE_KEY, "orderDetail")
                    intent.putExtra(ConstantsUtil.ORDER_RESULT, mOrderDetail)
                    startActivityForResult(intent, 990)
                } else {
                    IOSAlertDialog(this@OrderDetailActivity).builder().setTitle("温馨提示").setMsg("您尚未支付车辆押金，取车前请先支付车辆押金哦~", true)
                            .setNegativeButton("取消") { }.setPositiveButton("支付") { onPayDeposit(ConstantsUtil.PAY_PROJECT_VEHICLE) }.show()
                }
            }
        // 费用明细
            R.id.costLayout -> {
                StatisticsUtil.onEvent(this@OrderDetailActivity, ConstantsUtil.ORDER_DETAIL_BILL, ConstantsUtil.ORDER_DETAIL_BILL)
                val intent = Intent(this@OrderDetailActivity, CostActivity::class.java)
                intent.putExtra(CarEntity.EXTRA_BUNDLE_KEY, "OrderDetailCost")
                intent.putExtra("detailCost", mOrderDetail)
                startActivity(intent)
            }
        // 验车单
            R.id.checkVehicleLayout -> {
                if (mOrderDetail?.status ?: 0 >= OrdersBean.ORDER_STATUS_5) {
                    StatisticsUtil.onEvent(this, ConstantsUtil.ORDER_DETAIL_VALIDATE_CAR, ConstantsUtil.ORDER_DETAIL_VALIDATE_CAR)
                    val intent = Intent(this, VehicleCarActivity::class.java)
                    intent.putExtra("order_detail", mOrderDetail)
                    startActivity(intent)
                }
            }
        // 联系客服
            R.id.contactService -> {
                StatisticsUtil.onEvent(this, ConstantsUtil.ORDER_DETAIL_CUSTOMER_SERVICE, ConstantsUtil.ORDER_DETAIL_CUSTOMER_SERVICE)
                com.jiaoyinbrother.monkeyking.util.Util.contactService(this@OrderDetailActivity)
            }
        // 投诉
            R.id.complaints -> {
                StatisticsUtil.onEvent(this, ConstantsUtil.ORDER_DETAIL_COMPLAINT, ConstantsUtil.ORDER_DETAIL_COMPLAINT)
                val intent = Intent(this@OrderDetailActivity, ComplainActivity::class.java)
                intent.putExtra("orderid", mOrderDetail?.orderid)
                startActivity(intent)
            }
        }
    }

    override fun onItemClick(p0: View?, position: Int) {
        when (position) {
            0 -> {// 退改规则
                StatisticsUtil.onEvent(this, ConstantsUtil.ORDER_DETAIL_BACK_RULE, ConstantsUtil.ORDER_DETAIL_BACK_RULE)
                com.jiaoyinbrother.monkeyking.util.Util.onBackRule(this@OrderDetailActivity)
            }
            1 -> { // 油电费说明
                StatisticsUtil.onEvent(this, ConstantsUtil.ORDER_DETAIL_OIL_ELE_FEE, ConstantsUtil.ORDER_DETAIL_OIL_ELE_FEE)
                com.jiaoyinbrother.monkeyking.util.Util.onCostsInfo(this@OrderDetailActivity)
            }
            2 -> {// 里程限制
                StatisticsUtil.onEvent(this, ConstantsUtil.ORDER_DETAIL_MAIL_LIMIT, ConstantsUtil.ORDER_DETAIL_MAIL_LIMIT)
                com.jiaoyinbrother.monkeyking.util.Util.onMileLimit(this@OrderDetailActivity)
            }
            3 -> {// 出险理赔
                StatisticsUtil.onEvent(this, ConstantsUtil.ORDER_DETAIL_CLAIM, ConstantsUtil.ORDER_DETAIL_CLAIM)
                com.jiaoyinbrother.monkeyking.util.Util.onClaims(this@OrderDetailActivity)
            }
            4 -> { // 违章处理
                StatisticsUtil.onEvent(this, ConstantsUtil.ORDER_DETAIL_LLLEGAL, ConstantsUtil.ORDER_DETAIL_LLLEGAL)
                com.jiaoyinbrother.monkeyking.util.Util.onIllegalProcessing(this@OrderDetailActivity)

            }
            5 -> { // 限行说明
                StatisticsUtil.onEvent(this, ConstantsUtil.ORDER_DETAIL_RESTRICT_DRIVING, ConstantsUtil.ORDER_DETAIL_RESTRICT_DRIVING)
                com.jiaoyinbrother.monkeyking.util.Util.onLimitLine(this@OrderDetailActivity)
            }
        }
    }

    private fun getOrderDetail() {
        showLoadingDialog()
        val presenter = OrderPresenterImpl(this@OrderDetailActivity, OrderDetailResult::class.java)
        presenter.addListener(orderDetailModel)
        val request = OrderDetailRequest()
        request.uid = SharedPreferencesUtil.getInstance().uid
        request.orderid = mOrderID
        presenter.getOrderDetail(request)
    }

    private val orderDetailModel = object : GeneralViewInterface {
        override fun getCodeBeanFail(errorCode: Int) {
            refreshLayout.refreshIsEnd()
            dismissLoadingDialog()
            showUnNetWork(true)
        }

        override fun getCodeObjectSuccess(bean: Any) {
            refreshLayout.refreshIsEnd()
            val result = bean as OrderDetailResult
            when (result.code) {
                CarEntity.SUCC -> {
                    showUnNetWork(false)
                    setOrderData(result)
                }
                else -> showToast(result.msg)
            }
            dismissLoadingDialog()
        }
    }

    @SuppressLint("SetTextI18n")
    private fun setOrderData(result: OrderDetailResult) {
        mOrderDetail = result
        if (userRoles == 0) initUserLayout(result) else initManagerLayout(result)
        // 订单号
        orderNo.text = "订单号：${result.orderid}"
        // 订单状态
        orderStatus.text = result.status_name
        // 车辆图片
        carImg.setImageURI(result.pic)
        // 车辆类型
        carType.text = result.type
        // 车辆相关（SUV/1.5L自动/5座）
        carInfo.text = getCarInfo(result)
        // 车牌号
        carNumber.text = result.number
        // 智能钥匙
        carRemote.visibility = if (result.remote > 0) View.VISIBLE else View.GONE
        // 流程轴
        orderTimeLine.setData(result.status, userRoles ?: 0, getOrderTime(result))
        // 取还车相关
        orderSiteInfoView.setData(userRoles ?: 0, result)
        // 押金相关
        orderDepositView.setData(userRoles ?: 0, result)
        // 费用 & 活动
        costDesc.visibility = if (result.status <= 5) View.VISIBLE else View.INVISIBLE
        costAmount.text = "¥${result.bill?.total_amount}"
        activitiesLayout.visibility = if (result.activity != null) View.VISIBLE else View.GONE
        activityType.text = if (!TextUtils.isEmpty(result.activity?.name)) result.activity?.name else ""
        // 验车单
        if (result.status <= 4) {
            checkVehicle.setTextColor(ContextCompat.getColor(this@OrderDetailActivity, R.color.color_3))
        } else {
            checkVehicle.setTextColor(ContextCompat.getColor(this@OrderDetailActivity, R.color.color_5))
        }
        orderBottomBtn.setDetailInfo(result, userRoles ?: 0)
    }

    /**
     * 订单详情(用户界面)
     * */
    private fun initUserLayout(result: OrderDetailResult) {
        // 用户未认证蒙版
        unAuthLayout.visibility = if (result.status == OrdersBean.ORDER_STATUS_4 &&
                SharedPreferencesUtil.getInstance().userAuth == AuthUtil.USER_NOAUTH) View.VISIBLE else View.GONE
        // 用户等级不足蒙版
        onLevelUpLayout.visibility = if (result.is_car_rentable == 0) View.VISIBLE else View.GONE
        // 用车前可以取消
        subTitle.visibility = if (result.status <= 4 && result.status != 2) View.VISIBLE else View.GONE
        // 车牌号
        carNumber.visibility = if (result.status < OrdersBean.ORDER_STATUS_5) View.GONE else View.VISIBLE
        // 智能钥匙
        carRemote.isEnabled = (result.status == 4 || result.status == 5)
        // 预付交租金
        when {
            result.status == OrdersBean.ORDER_STATUS_1 -> {
                payReminders.visibility = View.VISIBLE
                payReminders.text = "请您在${DateTimeUtil.getTimeAfter45min(result.accept_time)}之前完成支付"
            }
            result.status == OrdersBean.ORDER_STATUS_3 -> {
                payReminders.visibility = View.VISIBLE
                payReminders.text = "请您在${DateTimeUtil.getTimeAfter45min(result.pay_time)}之前完成支付"
            }
            else -> payReminders.visibility = View.INVISIBLE
        }
        // 订单可分享，且是一般用户，才可分享红包
        shareOrder.visibility = if (result.share == 1) View.VISIBLE else View.GONE
        if (result.share == 1 && TextUtils.equals(SharedPreferencesUtil.getInstance().getString(result.orderid), "true")) {
            orderShare()
            SharedPreferencesUtil.getInstance().setString(result.orderid, "false")
        }
    }

    /**
     * 订单详情(车管界面)
     * */
    private fun initManagerLayout(result: OrderDetailResult) {
        LogUtil.e("OrderDetail : $result")
        subTitle.visibility = View.GONE
        // 订单渠道
        orderChannel.text = if (TextUtils.isEmpty(result.channel)) "" else "(${result.channel})"
        // 智能钥匙
        carRemote.isEnabled = (result.status < 4 || result.status > 5)
        shareOrder.visibility = View.GONE
    }

    /**
     * add 车辆信息
     * */
    private fun getCarInfo(result: OrderDetailResult): String {
        val builder = StringBuilder()
        if (!TextUtils.isEmpty(result.carriage)) {
            builder.append(result.carriage)
        }
        if (!TextUtils.isEmpty(result.displacement)) {
            if (builder.isNotEmpty()) {
                builder.append("/")
            }
            builder.append(result.displacement)
        }
        if (!TextUtils.isEmpty(result.transmission_name)) {
            builder.append(result.transmission_name)
        }
        if (builder.isNotEmpty()) {
            builder.append("/")
        }
        builder.append(result.capacity.toString() + "座")
        return builder.toString()
    }

    /**
     * 初始化订单时间数组
     */
    private fun getOrderTime(result: OrderDetailResult): Array<String> {
        if (!TextUtils.isEmpty(result.submit_time)) {
            mOrderTimeArray[0] = result.submit_time ?: ""
        }
        if (!TextUtils.isEmpty(result.accept_time)) {
            mOrderTimeArray[1] = result.accept_time ?: ""
        }
        if (!TextUtils.isEmpty(result.pay_time)) {
            mOrderTimeArray[2] = result.pay_time ?: ""
        }
        if (!TextUtils.isEmpty(result.take_time)) {
            mOrderTimeArray[3] = result.take_time ?: ""
        }
        if (!TextUtils.isEmpty(result.accept_bill_time)) {
            mOrderTimeArray[4] = result.accept_bill_time ?: ""
        }
        if (!TextUtils.isEmpty(result.finish_time)) {// 违章处理时间
            mOrderTimeArray[5] = result.finish_time ?: ""
        }
        if (!TextUtils.isEmpty(result.finish_time)) {
            mOrderTimeArray[6] = result.finish_time ?: ""
        }
        return mOrderTimeArray
    }

    fun onPayDeposit(mType: String) {
        val intent = Intent(this@OrderDetailActivity, CashierDeskActivity::class.java)
        intent.putExtra(ConstantsUtil.BUNDLE_EXTRA_KEY, mType)
        intent.putExtra(ConstantsUtil.ORDER_RESULT, mOrderDetail)
        startActivityForResult(intent, ConstantsUtil.PAYMENT_RESULT)
    }

    private fun setRules(): ArrayList<String> {
        val rules = ArrayList<String>()
        rules.add("退改规则&修改订单费用说明")
        rules.add("油(电)费说明&油(电)费用计算须知")
        rules.add("里程限制&车辆里程限制须知")
        rules.add("出险理赔&用车保险说明")
        rules.add("违章处理&车辆租赁期违章处理")
        rules.add("限行说明&车辆限行查询说明")
        return rules
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        if (requestCode == Constants.ORDER_CANCEL_CODE && resultCode == Constants.ORDER_CANCEL_CODE) {
            startActivity(Intent(this@OrderDetailActivity, MonkeyMainActivity::class.java))
            finish()
            return
        } else {
            getOrderDetail()
        }
    }

    private fun orderShare() {
        val presenter = OrderPresenterImpl(this@OrderDetailActivity, OrderShareResult::class.java)
        presenter.addListener(orderShareModel)
        val request = OrderDetailRequest()
        request.uid = SharedPreferencesUtil.getInstance().uid
        request.orderid = mOrderID
        presenter.getOrderShare(request)
    }

    private val orderShareModel = object : GeneralViewInterface {
        override fun getCodeBeanFail(errorCode: Int) {
        }

        override fun getCodeObjectSuccess(bean: Any) {
            val result = bean as OrderShareResult
            if (result.code == CarEntity.SUCC) {
                try {
                    mShareResult = result
                    val fragmentManager = supportFragmentManager
                    val yesnoDialog = DialogInvisibleOKFragment()
                    yesnoDialog.setmPicURL(result.pic_big)
                    yesnoDialog.isCancelable = true
                    yesnoDialog.show(fragmentManager, "Yes/No Dialog")
                } catch (e: Exception) {
                    LogUtil.e("yesnoDialog --- exception")
                }
            }
        }
    }

    override fun onFinishYesNoDialog(state: Boolean) {
        if (!state || null == mShareResult)
            return
        if (!NetUtil.isNetworkAvailable(this@OrderDetailActivity)) {
            showErrorToast(ErrorToast.NO_NETWORK)
            return
        }
        SharePopupWindow.startSharePopupWindow(initShareParams(), this.findViewById(R.id.mainView), this@OrderDetailActivity,
                SharePopupWindow.SHARE_IMAGE_TEXT)
    }

    /**
     * 初始化分享参数
     */
    private fun initShareParams(): Platform.ShareParams {
        val sp = Platform.ShareParams()
        sp.shareType = Platform.SHARE_TEXT
        sp.shareType = Platform.SHARE_WEBPAGE
        sp.title = mShareResult?.title
        sp.text = mShareResult?.description
        sp.url = mShareResult?.url
        sp.imageUrl = mShareResult?.pic
        return sp
    }

    private fun showUnNetWork(isUnNet: Boolean) {
        refreshLayout.visibility = if (isUnNet) View.GONE else View.VISIBLE
        orderBottomLayout.visibility = if (isUnNet) View.GONE else View.VISIBLE
        unNetWork.visibility = if (isUnNet) View.VISIBLE else View.GONE
        unNetWork.setEmptyData(R.mipmap.ic_no_network, "", ConstantsUtil.NO_NETWORK, "")
        unNetWork.setNegativeButton("重新加载", View.OnClickListener { getOrderDetail() })
    }

    override fun onNewIntent(intent: Intent?) {
        super.onNewIntent(intent)
        getExtra()
        getOrderDetail()
    }

    override fun onStart() {
        super.onStart()
        registerReceiver()
    }

    private fun registerReceiver() {
        val filter = IntentFilter()
        filter.addAction(CarEntity.BROADCAST_JPUSH_ORDER_STATUS_CHANGED)
        registerReceiver(receiver, filter)
    }

    private val receiver = object : BroadcastReceiver() {
        override fun onReceive(context: Context?, intent: Intent?) {
            val mAction = intent?.action
            if (mAction == CarEntity.BROADCAST_JPUSH_ORDER_STATUS_CHANGED) {
                if (intent.hasExtra(CarEntity.JPUSH_ORDER_KEY)) {
                    val pushJson = intent.extras.getString(CarEntity.JPUSH_ORDER_KEY)
                    if (!TextUtils.isEmpty(pushJson)) {
                        try {
                            val obj = JSONObject(pushJson)
                            mOrderID = obj.optString("orderid")
//                            val owner = obj.optString("owner")
//                            val renter = obj.optString("renter")
//                            val uid = SharedPreferencesUtil.getInstance().uid
//                            getOrderDetail() // TODO 这个地方接受到广播后还需掉订单详情吗？
                        } catch (e: Exception) {
                            LogUtil.e("BroadcastReceiver err")
                        }
                    }
                }
            }
        }
    }

}