package com.jiaoyinbrother.monkeyking.activity

import android.annotation.SuppressLint
import android.content.Intent
import android.os.Handler
import android.support.v4.content.ContextCompat
import android.text.*
import android.text.method.LinkMovementMethod
import android.text.style.ClickableSpan
import android.text.style.ForegroundColorSpan
import android.view.View
import android.widget.TextView
import com.jiaoyinbrother.monkeyking.CarEntity
import com.jiaoyinbrother.monkeyking.Constants
import com.jiaoyinbrother.monkeyking.R
import com.jiaoyinbrother.monkeyking.util.DialogUtil
import com.jybrother.sineo.library.base.BaseActivity
import com.jybrother.sineo.library.bean.DepositBean
import com.jybrother.sineo.library.bean.OrderDetailResult
import com.jybrother.sineo.library.bean.PayInfoBean
import com.jybrother.sineo.library.util.ConstantsUtil
import com.jybrother.sineo.library.util.SharePreferenceTools
import com.jybrother.sineo.library.util.StatisticsUtil
import com.jybrother.sineo.library.util.Util
import kotlinx.android.synthetic.main.activity_order_pay_result.*
import java.util.*


class OrderPayResultActivity : BaseActivity(), View.OnClickListener {

    private var mPayStatus: Int? = null
    private var mPayType: Int? = null
    private var mPayInfo: PayInfoBean? = null
    private var mOrderInfo: OrderDetailResult? = null
    private var fromTakingPic: String? = null

    private var mDepositVehicle: DepositBean? = null
    private var mDepositIllegal: DepositBean? = null
    private var mDepositRent: DepositBean? = null

    override fun getLayoutId(): Int {
        mPayStatus = intent?.extras?.getInt("PayResultCode")
        mPayType = intent?.extras?.getInt("PayType")
        mPayInfo = intent?.extras?.getSerializable("PayInfo") as PayInfoBean
        mOrderInfo = intent?.extras?.getSerializable(ConstantsUtil.ORDER_RESULT) as OrderDetailResult?
        fromTakingPic = intent?.extras?.getString("where are you from")
        return R.layout.activity_order_pay_result
    }

    override fun initView() {}

    override fun initToolBar() {
        mainTitle.text = "支付"
    }

    override fun initListeners() {
        // 失败页面
        negativeFail.setOnClickListener(this)
        positiveFail.setOnClickListener(this)
        // 成功页面
        negativeSucc.setOnClickListener(this)
        positiveSucc.setOnClickListener(this)
    }

    override fun initData() {
        mDepositRent = Util.getDepositBean(mOrderInfo, ConstantsUtil.PAY_PROJECT_RENT)
        mDepositVehicle = Util.getDepositBean(mOrderInfo, ConstantsUtil.PAY_PROJECT_VEHICLE)
        mDepositIllegal = Util.getDepositBean(mOrderInfo, ConstantsUtil.PAY_PROJECT_ILLEGAL)
        Handler().postDelayed({
            mLoadingLayout.visibility = View.GONE
            when (mPayStatus) {
                PayMethodActivity.SUCC -> {
                    mainTitle.text = "支付成功"
                    getSuccessfulPage(mPayType ?: 0)
                    mSuccessLayout.visibility = View.VISIBLE
                }
                PayMethodActivity.FAIL -> {
                    mainTitle.text = "支付失败"
                    mFailedLayout.visibility = View.VISIBLE
                }
            }
        }, 2000)

    }

    override fun onClick(v: View?) {
        when (v?.id) {
            R.id.negativeFail -> DialogUtil.onServiceDial(this@OrderPayResultActivity)
            R.id.positiveFail -> backOrderInfoPage()
            R.id.negativeSucc -> {
                if (TextUtils.equals(fromTakingPic, "TakingPic")) {
                    val intent = Intent(this, TakingPicturesActivity::class.java)
                    intent.putExtra("OrderDetail", mOrderInfo)
                    intent.putExtra("onNewIntent", "onNewIntent")
                    intent.flags = Intent.FLAG_ACTIVITY_CLEAR_TOP
                    intent.addFlags(Intent.FLAG_ACTIVITY_SINGLE_TOP)
                    startActivity(intent)
                } else {
                    backOrderInfoPage()
                }
            }
            R.id.positiveSucc -> {
//                if (!TextUtils.isEmpty(mOrderDetail.getOrderid())) {
//                    SharedPreferencesUtil.getInstance().setString(mOrderDetail.getOrderid(), "true")
//                }
                val intent1 = Intent(this@OrderPayResultActivity, EvaluateActivity::class.java)
                intent1.putExtra(ConstantsUtil.ORDER_ID, mOrderInfo?.orderid)
                intent1.putExtra("CAR_ID", mOrderInfo?.carid)
                intent1.putExtra(CarEntity.CMMT_SINGLE_ID, mOrderInfo?.ownerid)
                startActivity(intent1)
                finish()
            }
        }
    }

    @SuppressLint("SetTextI18n")
    private fun getSuccessfulPage(payType: Int) {
        when (payType) {
            CashierDeskActivity.PAY_TYPE_VEHICLE -> {
                mainTitle.text = "支付成功"
                tvTitle.text = "支付成功"
                bookSuccPromptLayout.visibility = View.GONE
                tvDescription.text = resources.getString(R.string.payment_cardeposit_desc)
                tvDescription.setTextColor(ContextCompat.getColor(this@OrderPayResultActivity, R.color.color_3))
                positiveSucc.visibility = View.GONE
            }
            CashierDeskActivity.PAY_TYPE_ILLEGAL -> {
                mainTitle.text = "支付成功"
                tvTitle.text = "支付成功"
                bookSuccPromptLayout.visibility = View.GONE
                tvDescription.text = resources.getString(R.string.payment_illdeposit_desc)
                tvDescription.setTextColor(ContextCompat.getColor(this@OrderPayResultActivity, R.color.color_3))
                positiveSucc.visibility = View.GONE
                if (TextUtils.equals(fromTakingPic, "TakingPic")) {
                    negativeSucc.text = "拍摄照片"
                }
            }
            CashierDeskActivity.PAY_TYPE_RENT -> {// 预付租金
                StatisticsUtil.onEvent(this,ConstantsUtil.ORDER_SUCCESS, "")
                mainTitle.text = "预订成功"
                tvTitle.text = "预订成功"
                tvDescription.text = "车辆押金 ¥${mDepositVehicle?.amount?.toInt()}    违章押金 ¥${mDepositIllegal?.amount?.toInt()}"
                tvDescription.setTextColor(ContextCompat.getColor(this@OrderPayResultActivity, R.color.color_6))
                succBtnLayout.visibility = View.GONE
                bookSuccPromptLayout.visibility = View.VISIBLE
                if (isJoin()) {
                    if (mDepositVehicle?.status_code == DepositBean.DEPOSIT_WAIT_PAYED)
                        setText(tvCard, resources.getString(R.string.book_succ_desc_site))
                    else
                        tvCard.text = "取车前完成车辆押金的支付，还车时完成违章押金的支付即可。押金支付方式可选择到店支付或刷卡支付；"
                } else {
                    if (mDepositVehicle?.status_code == DepositBean.DEPOSIT_WAIT_PAYED)
                        setText(tvCard, resources.getString(R.string.book_succ_desc_online))
                    else
                        tvCard.text = "取车前完成车辆押金的支付，还车时完成违章押金的支付即可。"
                }
            }
            CashierDeskActivity.PAY_TYPE_SETTLEMENT -> {
                mainTitle.text = "支付成功"
                tvTitle.text = "支付成功"
                tvDescription.visibility = View.GONE
                bookSuccPromptLayout.visibility = View.GONE
            }
            CashierDeskActivity.PAY_TYPE_WEB -> {
                mainTitle.text = "支付成功"
                tvTitle.text = "支付成功"
                tvDescription.visibility = View.GONE
                positiveSucc.visibility = View.GONE
                bookSuccPromptLayout.visibility = View.GONE
            }
        }
    }

    private fun isJoin(): Boolean {
        if (mDepositRent != null) {
            val mPaymentsList = mDepositRent?.pay_method_avai ?: ArrayList()
            for (i in mPaymentsList.indices) {
                if (mPaymentsList[i].id == 10) {
                    return true
                }
            }
        }
        return false
    }

    private fun setText(tv: TextView, str: String) {
        val spannableString = SpannableString(str)
        if (isNeedPayDeposit()) {
            spannableString.setSpan(object : ClickableSpan() {
                override fun updateDrawState(ds: TextPaint) {
                    super.updateDrawState(ds)
                    ds.isUnderlineText = false
                }

                override fun onClick(v: View) {
                    val intent = Intent(this@OrderPayResultActivity, CashierDeskActivity::class.java)
                    if (mDepositVehicle?.status_code == 2) {
                        intent.putExtra(ConstantsUtil.BUNDLE_EXTRA_KEY, ConstantsUtil.PAY_PROJECT_VEHICLE)
                    } else {
                        intent.putExtra(ConstantsUtil.BUNDLE_EXTRA_KEY, ConstantsUtil.PAY_PROJECT_ILLEGAL)
                    }
                    intent.putExtra(ConstantsUtil.ORDER_RESULT, mOrderInfo)
                    startActivityForResult(intent, ConstantsUtil.PAYMENT_RESULT)
                    finish()
                }
            }, str.length - 12, str.length, Spanned.SPAN_EXCLUSIVE_EXCLUSIVE)
            spannableString.setSpan(ForegroundColorSpan(resources.getColor(R.color.color_8)), str.length - 12,
                    str.length, Spannable.SPAN_EXCLUSIVE_EXCLUSIVE)
        } else {
            spannableString.setSpan(ForegroundColorSpan(resources.getColor(R.color.color_3)), str.length - 12,
                    str.length, Spannable.SPAN_EXCLUSIVE_EXCLUSIVE)
        }
        tv.text = spannableString
        tv.movementMethod = LinkMovementMethod.getInstance()
    }

    private fun isNeedPayDeposit(): Boolean {
        val vehicle = mDepositVehicle?.status_code
        val illegal = mDepositIllegal?.status_code
        return !(vehicle == 0 && illegal == 0)
    }

    /**
     * 返回订单详情
     * */
    private fun backOrderInfoPage() {
        if (mPayType == CashierDeskActivity.PAY_TYPE_WEB) {
            // web pay back web page
            setWebResult(mPayStatus ?: 0)
        } else {
            // 返回订单详情
            val intent = Intent(this@OrderPayResultActivity, OrderDetailActivity::class.java)
            intent.putExtra(ConstantsUtil.ORDER_ID, mOrderInfo?.orderid)
            intent.flags = Intent.FLAG_ACTIVITY_CLEAR_TOP
            intent.addFlags(Intent.FLAG_ACTIVITY_SINGLE_TOP)
            startActivity(intent)
        }
        finish()
    }

    private fun setWebResult(status: Int) {
        val result = if (status == 1) "SUCC" else "FAIL"
        val intent = Intent()
        val spTools = SharePreferenceTools(this)
        spTools.putString(SharePreferenceTools.WEB_PAY_RESULT, result)
        intent.putExtra("WEB_RESULT", result)
        setResult(Constants.WEB_PAY_RESULT, intent)
    }
}