package com.jiaoyinbrother.monkeyking.activity

import android.os.Handler
import android.view.View
import com.jiaoyinbrother.monkeyking.R
import com.jiaoyinbrother.monkeyking.util.DialogUtil
import com.jybrother.sineo.library.base.BaseActivity
import kotlinx.android.synthetic.main.activity_pay_result.*

class PayResultActivity : BaseActivity(), View.OnClickListener {

    private var status = 0
    private var message = ""
    private var amount = 0

    override fun getLayoutId(): Int {
        return R.layout.activity_pay_result
    }

    override fun initView() {
        amount = intent.extras.getInt("amount")
        status = intent.extras.getInt("code")
        message = intent.extras.getString("message")
    }

    override fun initToolBar() {
        mainTitle.text = "支付"
    }

    override fun initListeners() {
        negativeFail.setOnClickListener(this)
        positiveFail.setOnClickListener(this)
        negativeSucc.setOnClickListener(this)
        positiveSucc.setOnClickListener(this)
    }

    override fun initData() {
        payAmountTv.text = "$amount"
        Handler().postDelayed({
            mLoading.visibility = View.GONE
            mSuccess.visibility = if (status == PayMethodActivity.SUCC) View.VISIBLE else View.GONE
            mFailed.visibility = if (status == PayMethodActivity.FAIL) View.VISIBLE else View.GONE
            mainTitle.text = if (status == PayMethodActivity.SUCC) "支付成功" else "支付失败"
        }, 2000)
    }

    override fun onClick(v: View?) {
        when (v?.id) {
            R.id.positiveFail, R.id.positiveSucc -> finish()
            R.id.negativeFail -> DialogUtil.onServiceDial(this@PayResultActivity)
            R.id.negativeSucc -> {
                startActivity(MonkeyMainActivity::class.java)
                finish()
            }
        }
    }

}