package com.jiaoyinbrother.monkeyking.activity

import android.app.Activity
import android.content.BroadcastReceiver
import android.content.Context
import android.content.Intent
import android.content.IntentFilter
import android.net.Uri
import android.os.AsyncTask
import android.os.Environment
import android.provider.MediaStore
import android.support.v7.app.AlertDialog
import android.text.InputFilter
import android.text.TextUtils
import android.view.*
import android.view.inputmethod.EditorInfo
import android.view.inputmethod.InputMethodManager
import android.widget.EditText
import android.widget.PopupWindow
import android.widget.TextView
import com.google.gson.Gson
import com.jiaoyinbrother.monkeyking.CarApp
import com.jiaoyinbrother.monkeyking.CarEntity
import com.jiaoyinbrother.monkeyking.R
import com.jiaoyinbrother.monkeyking.bean.*
import com.jiaoyinbrother.monkeyking.network.CarLib
import com.jiaoyinbrother.monkeyking.network.HttpFileUpTool
import com.jiaoyinbrother.monkeyking.util.NetUtil
import com.jiaoyinbrother.monkeyking.util.SharedPreferencesUtil
import com.jiaoyinbrother.monkeyking.util.Util
import com.jiaoyinbrother.monkeyking.view.IOSdialog.IOSAlertDialog
import com.jiaoyinbrother.monkeyking.view.date.SelectBirthdayDialog
import com.jiaoyinbrother.monkeyking.wxutil.WXUitls
import com.jiaoyinbrother.monkeyking.wxutil.WxStatus
import com.jybrother.sineo.library.base.BaseActivity
import com.jybrother.sineo.library.bean.BindThirdEntitiy
import com.jybrother.sineo.library.bean.UserDetailRequestBean
import com.jybrother.sineo.library.presenter.UserDetailPresenterImpl
import com.jybrother.sineo.library.util.FileUtils
import com.jybrother.sineo.library.util.LogUtil
import com.jybrother.sineo.library.util.OldToastUtil
import com.jybrother.sineo.library.util.TextUtil
import com.jybrother.sineo.library.view.GeneralViewInterface
import com.tencent.mm.sdk.modelmsg.SendAuth
import com.tencent.mm.sdk.openapi.IWXAPI
import kotlinx.android.synthetic.main.act_personal.*
import kotlinx.android.synthetic.main.main_title.*
import org.json.JSONException
import java.io.File
import java.io.IOException
import java.text.SimpleDateFormat
import java.util.*
import java.util.concurrent.TimeoutException

class PersonalInfoActivity : BaseActivity(), View.OnClickListener {
    // 请求相机
    private val REQUEST_CAPTURE = 100
    // 请求相册
    private val REQUEST_PICK = 101
    // 请求截图
    private val REQUEST_CROP_PHOTO = 102

    private var mCarLib: CarLib? = null
    private var mUdr: UserDetailResult? = null

    private var uid: String? = null

    // 调用照相机返回图片临时文件
    private var tempFile: File? = null
    private var headImgUrl: String? = null

    override fun getLayoutId(): Int {
        return R.layout.act_personal
    }

    override fun initView() {
    }

    override fun initToolBar() {

    }

    override fun initListeners() {
        headImage_layout.setOnClickListener(this)
        sex_layout.setOnClickListener(this)
        nick_name_layout.setOnClickListener(this)
        tv_nickname.setOnClickListener(this)
        birthday_layout.setOnClickListener(this)
        qrcode_layout.setOnClickListener(this)
        third_binding_layout.setOnClickListener(this)


        tv_nickname.onFocusChangeListener = View.OnFocusChangeListener { v, hasFocus ->
            if (hasFocus) {
                tv_nickname.gravity = Gravity.LEFT or Gravity.CENTER_VERTICAL
            }
        }


        tv_nickname.setOnTouchListener(View.OnTouchListener { _, event ->
            if (event.getAction() === MotionEvent.ACTION_OUTSIDE) {
                tv_nickname.isFocusable = false//EditText 失去焦点
                //其他要实现的功能。
                return@OnTouchListener true
            }
            false
        })

        tv_nickname.setOnEditorActionListener { v, actionId, event ->
            var isOK = true
            when (actionId) {
                EditorInfo.IME_ACTION_NONE -> showToast("点击-->NONE")
                EditorInfo.IME_ACTION_GO -> showToast("点击-->GO")
                EditorInfo.IME_ACTION_SEARCH -> showToast("点击-->SEARCH")
                EditorInfo.IME_ACTION_SEND -> showToast("点击-->SEND")
                EditorInfo.IME_ACTION_NEXT -> showToast("点击-->NEXT")
                EditorInfo.IME_ACTION_DONE -> {
                    //处理事件
                    tv_nickname.isFocusable = false
                    tv_nickname.gravity = Gravity.RIGHT or Gravity.CENTER_VERTICAL
                    if (!TextUtils.isEmpty(tv_nickname.text.toString()))
                        UserUpdataAsyncTask().execute()
                    isOK = true
                }
                else -> isOK = false
            }
            isOK
        }

    }


    override fun initData() {
        createCameraTempFile()
        iwxApi = WXUitls.initWxApi(this)

        val intent = this.intent
        val b = intent.extras
        if (b != null) {
            try {
                mUdr = b.getSerializable("PersonInfo") as UserDetailResult
            } catch (e: Exception) {

            }

        }

        ivTitleName.text = "个人信息"

        val emojiFilters = arrayOf<InputFilter>(TextUtil.getEmojiFilter(), InputFilter.LengthFilter(20))
        tv_nickname.filters = emojiFilters
        tv_nickname.imeOptions = EditorInfo.IME_ACTION_DONE;
        setData(mUdr)
    }


    override fun onDestroy() {
        try {
            if (null != mBindReceiver)
                unregisterReceiver(mBindReceiver)
        } catch (e: Exception) {
        }

        super.onDestroy()
    }

    override fun onResume() {
        super.onResume()
        bindWechatReceiver()
    }

    private fun setData(userDetailResult: UserDetailResult?) {
        if (userDetailResult == null) {
            requestUserDetail()
            return
        }

        val head_img_url = SharedPreferencesUtil.getInstance()
                .getString("head_img" + SharedPreferencesUtil.getInstance().uid)
        imageview_head!!.setImageURI(head_img_url)

        // 姓名
        if (!TextUtils.isEmpty(userDetailResult.name)) {
            tv_username.text = userDetailResult.name
        } else {
            tv_username.text = SharedPreferencesUtil.getInstance().name
        }
        // 电话
        if (!TextUtils.isEmpty(userDetailResult.uid)) {
            val pcode = userDetailResult.uid.substring(0, 3) + "****" + userDetailResult.uid.substring(7)
            tv_usernum.text = pcode
        } else {
            uid = SharedPreferencesUtil.getInstance().uid
            val pcode = uid!!.substring(0, 3) + "****" + uid!!.substring(7)
            tv_usernum.text = pcode
        }
        // 昵称
        if (!TextUtils.isEmpty(userDetailResult.nickname)) {
            tv_nickname.setText(userDetailResult.nickname)
        }
        // 性别
        if (!TextUtils.isEmpty(userDetailResult.gender)) {
            when (userDetailResult.gender) {
                "f" -> tv_sex.text = "女"
                "m" -> tv_sex.text = "男"
                "u" -> tv_sex.text = "男"
                else -> tv_sex.text = "添加"
            }
        }
        // 生日
        if (!TextUtils.isEmpty(userDetailResult.birthday)) {
            tv_birthday.text = userDetailResult.birthday
        }

//        微信绑定状态
        if (userDetailResult.thirdparty != null && userDetailResult.thirdparty.size > 0) {
            for (i in 0 until userDetailResult.thirdparty.size) {
                if (userDetailResult.thirdparty[i].type.contains("ZUCHE_WEIXIN")) {
                    setButtonText(bind_status_textview, true)
                } else {
                    setButtonText(bind_status_textview, false)
                }
            }
        } else {
            setButtonText(bind_status_textview, false)
        }

    }

    private fun requestUserDetail() {
        val userDetailBean = UserDetailRequestBean()
        userDetailBean.uid = SharedPreferencesUtil.getInstance().getString(SharedPreferencesUtil.UID_KEY, "")

        showLoadingDialog()
        var mUserDetailPresenter = UserDetailPresenterImpl(this, UserDetailResult::class.java)
        mUserDetailPresenter?.addListener(object : GeneralViewInterface {
            override fun getCodeBeanFail(errorCode: Int) {
                dismissLoadingDialog()
                showErrorToast(errorCode)
            }

            override fun getCodeObjectSuccess(bean: Any) {
                dismissLoadingDialog()
                setData(bean as UserDetailResult)
            }
        })
        mUserDetailPresenter?.getUserDetail(userDetailBean)
    }

    /**
     * 设置button要显示内容
     */
    private fun setButtonText(btn: TextView, bindStatus: Boolean) {
        if (bindStatus) {
            btn.text = "解除绑定"
        } else {
            btn.text = "绑定"
        }
        isWeChatBind = bindStatus
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        myOnActivityResult(requestCode, resultCode, data)
    }

    override fun onClick(v: View?) {
        when (v?.id) {
            R.id.headImage_layout -> uploadHeadImage()
            R.id.sex_layout -> goGender()

            R.id.nick_name_layout -> goNickName()
            R.id.tv_nickname -> goNickName()

            R.id.birthday_layout -> goBirthday()

            R.id.qrcode_layout -> goQrcode()

            R.id.third_binding_layout -> goThirdBinding()
        }
    }

    /**
     * 更新个人信息
     */
    internal inner class UserUpdataAsyncTask : AsyncTask<Void, Void, ProjectBaseResult>() {
        override fun doInBackground(vararg params: Void): ProjectBaseResult {
            mCarLib = CarLib.getInstance(applicationContext)
            val uue = UserUpdataEntity()
            uue.uid = SharedPreferencesUtil.getInstance().uid

            if (!TextUtils.isEmpty(tv_nickname.text.toString()) && !TextUtils.equals("添加", tv_nickname.text.toString())) {
                uue.nickname = tv_nickname.text.toString()
            }

            if (!TextUtils.isEmpty(tv_sex.text.toString()) && !TextUtils.equals("添加", tv_sex.text.toString())) {
                when (tv_sex.text.toString()) {
                    "男" -> uue.gender = "m"
                    "女" -> uue.gender = "f"
                }
            }

            if (!TextUtils.isEmpty(tv_birthday.text.toString()) && !TextUtils.equals("添加", tv_birthday.text.toString())) {
                uue.birthday = tv_birthday.text.toString()
            }

            if (!TextUtils.isEmpty(headImgUrl)) {
                uue.headimg_url = headImgUrl
            }

            var br = ProjectBaseResult()
            try {
                br = mCarLib?.postRequest(uue.toJson(uue), "user/update", ProjectBaseResult::class.java) as ProjectBaseResult
            } catch (e: Exception) {
                NetUtil.handlePostException(br, e)
            }

            return br
        }

        override fun onPostExecute(result: ProjectBaseResult) {
            super.onPostExecute(result)
            if (result.errCode == -1) {
                if (result.code == CarEntity.SUCC) {
                    OldToastUtil.show(this@PersonalInfoActivity, "个人信息修改成功")
                } else {
                    OldToastUtil.show(this@PersonalInfoActivity, result.msg)
                }
            } else {
                OldToastUtil.showerror(this@PersonalInfoActivity, result.errCode)
            }
        }
    }

    /**
     * 上传头像
     */
    private fun uploadHeadImage() {
        val view = LayoutInflater.from(this).inflate(R.layout.layout_popupwindow_image, null)
        val btnCarema = view.findViewById(R.id.btn_camera) as TextView
        val btnPhoto = view.findViewById(R.id.btn_photo) as TextView
        val btnCancel = view.findViewById(R.id.btn_cancel) as TextView
        val popupWindow = PopupWindow(view, ViewGroup.LayoutParams.MATCH_PARENT,
                ViewGroup.LayoutParams.WRAP_CONTENT)
        popupWindow.setBackgroundDrawable(resources.getDrawable(android.R.color.transparent))
        popupWindow.isOutsideTouchable = true
        val parent = LayoutInflater.from(this).inflate(R.layout.act_personal, null)
        popupWindow.showAtLocation(parent, Gravity.BOTTOM, 0, 0)
        // popupWindow在弹窗的时候背景半透明
        val params = window.attributes
        params.alpha = 0.7f
        window.attributes = params
        popupWindow.setOnDismissListener {
            params.alpha = 1.0f
            window.attributes = params
        }
        btnCarema.setOnClickListener {
            // 跳转到调用系统相机
            val intent = Intent(MediaStore.ACTION_IMAGE_CAPTURE)
            intent.putExtra(MediaStore.EXTRA_OUTPUT, Uri.fromFile(tempFile))
            startActivityForResult(intent, REQUEST_CAPTURE)
            popupWindow.dismiss()
        }
        btnPhoto.setOnClickListener {
            // 跳转到调用系统图库
            val intent = Intent(Intent.ACTION_PICK, MediaStore.Images.Media.EXTERNAL_CONTENT_URI)
            startActivityForResult(Intent.createChooser(intent, "请选择图片"), REQUEST_PICK)
            popupWindow.dismiss()
        }
        btnCancel.setOnClickListener { popupWindow.dismiss() }
    }

    /**
     * 创建调用系统照相机待存储的临时文件
     *
     * @param savedInstanceState
     */
    private fun createCameraTempFile() {
        tempFile = File(FileUtils.createPathIfNotExist(Environment.getExternalStorageDirectory().toString() + File.separator
                + Environment.DIRECTORY_DCIM + File.separator + "Camera" + File.separator),
                System.currentTimeMillis().toString() + ".jpg")
    }

    private fun myOnActivityResult(requestCode: Int, resultCode: Int, intent: Intent?) {
        when (requestCode) {
            REQUEST_CAPTURE // 调用系统相机返回
            -> if (resultCode == Activity.RESULT_OK) {
                gotoClipActivity(Uri.fromFile(tempFile))
            }
            REQUEST_PICK // 调用系统相册返回
            -> if (resultCode == Activity.RESULT_OK) {
                val uri = intent!!.data
                gotoClipActivity(uri)
            }
            REQUEST_CROP_PHOTO // 剪切图片返回
            -> if (resultCode == Activity.RESULT_OK) {
                val uri = intent!!.data ?: return

                PostHeadImageAsyncTask().execute()
            }
        }
    }

    /**
     * 打开截图界面
     *
     * @param uri
     */
    private fun gotoClipActivity(uri: Uri?) {
        if (uri == null) {
            return
        }
        val intent = Intent()
        intent.setClass(this, ClipImageActivity::class.java)
        intent.data = uri
        startActivityForResult(intent, REQUEST_CROP_PHOTO)
    }

    internal inner class PostHeadImageAsyncTask : AsyncTask<Void, Int, UploadResult>() {

        override fun onPreExecute() {
            super.onPreExecute()
        }

        override fun doInBackground(vararg params: Void): UploadResult {
            val file = File(Environment.getExternalStorageDirectory().toString() + File.separator + Environment.DIRECTORY_DCIM
                    + File.separator + "Camera" + File.separator, "head_img.jpg")
            val map_params = HashMap<String, String>()
            map_params.put("type", "64")
            val mFiles = HashMap<String, File>()
            mFiles.put("file1", file)
            var ur = UploadResult()
            try {
                ur = HttpFileUpTool.post(CarEntity.UploadActionUrl, map_params, mFiles)
            } catch (e: IOException) {
                ur.errCode = OldToastUtil.IO_EXCEPTION
            } catch (e: JSONException) {
                ur.errCode = OldToastUtil.IO_EXCEPTION
            } catch (e: TimeoutException) {
                ur.errCode = OldToastUtil.TIMEOUT_EXCEPTION
            }

            return ur
        }

        override fun onPostExecute(result: UploadResult) {
            super.onPostExecute(result)
            if (result.errCode == -1) {
                if (result.code == CarEntity.SUCC) {
                    if (!TextUtils.isEmpty(result.file1)) {
                        //                        ImageLoader.getInstance().displayImage(result.getFile1(), imageview_head);
                        imageview_head!!.setImageURI(result.file1)
                        Util.saveHeadImage(result.file1)
                        headImgUrl = result.file1
                        UserUpdataAsyncTask().execute()
                    }
                } else {
                    OldToastUtil.show(this@PersonalInfoActivity, result.msg)
                }
            } else {
                OldToastUtil.showerror(this@PersonalInfoActivity, result.errCode)
            }
        }
    }

    // 生日
    private fun goBirthday() {
        var time = ""
        if (!TextUtils.isEmpty(tv_birthday.text.toString()) && !TextUtils.equals(tv_birthday.text.toString(), "添加")) {
            time = tv_birthday.text.toString()
        } else {
            time = SimpleDateFormat("yyyy-MM-dd").format(Date())
        }
        SelectBirthdayDialog.Builder(this@PersonalInfoActivity)
                .setTitle("出生日期")
                .setDefaultDate(time)
                .setOnResultListener { resultTime ->
                    tv_birthday.text = resultTime
                    UserUpdataAsyncTask().execute()
                }
                .show()

    }

    // 我的二维码
    private fun goQrcode() {
        if (!NetUtil.isNetworkAvailable(this@PersonalInfoActivity)) {
            OldToastUtil.showerror(this@PersonalInfoActivity, OldToastUtil.TIMEOUT_EXCEPTION)
            return
        }
        if (SharedPreferencesUtil.getInstance().isLogin) {
            val intent = Intent(this@PersonalInfoActivity, UserQBCodeActivity::class.java)
            intent.putExtra("uid", SharedPreferencesUtil.getInstance().uid)
            intent.putExtra("name", SharedPreferencesUtil.getInstance().name)
            intent.putExtra("role", SharedPreferencesUtil.getInstance().role)
            intent.putExtra("rolename", SharedPreferencesUtil.getInstance().roleName)
            startActivity(intent)
        }
    }

    // 第三方绑定
    private fun goThirdBinding() {
        if (isWeChatBind)
            unbindWechat(CarEntity.ThirdLoginType.WEIXIN.typeName) // 解除绑定
        else
            bindWechat() // 绑定
    }


    /**
     * 微信解绑
     */
    private fun unbindWechat(type: String) {
        IOSAlertDialog(this@PersonalInfoActivity).builder().setTitle("提示").setMsg("确定解除绑定？", true)
                .setPositiveButton("解绑") { unBind(type) }.setNegativeButton("取消") { }.show()

    }

    //    微信是否绑定
    private var isWeChatBind = false
    private var iwxApi: IWXAPI? = null
    private var isBindingWechat = false
    /**
     * 微信绑定
     */
    private fun bindWechat() {
        if (!isBindingWechat) {
            isBindingWechat = true
            LogUtil.e("bindWechat")
            CarApp.setWxStatus(WxStatus.BIND)
            val req = SendAuth.Req()
            req.scope = "snsapi_userinfo"
            req.state = "wkzuche_test"
            iwxApi?.sendReq(req)
        }

    }


    private var isUnbindTaskRun = false
    /**
     * 解除绑定接口
     */
    private fun unBind(type: String) {
        if (!NetUtil.isNetworkAvailable(this@PersonalInfoActivity)) {
            OldToastUtil.showerror(this@PersonalInfoActivity, OldToastUtil.TIMEOUT_EXCEPTION)
            return
        }
        if (!isUnbindTaskRun) {
            isUnbindTaskRun = true
            UnbingThirdAsyncTask(type).execute()
        }
    }


    internal inner class UnbingThirdAsyncTask constructor(private val type: String) : AsyncTask<Void, Void, ProjectBaseResult>() {

        override fun onPreExecute() {
            super.onPreExecute()

            showLoadingDialog()
        }

        override fun doInBackground(vararg params: Void): ProjectBaseResult {
            if (null == mCarLib)
                mCarLib = CarLib.getInstance(this@PersonalInfoActivity)
            val ute = UnbindThirdEntity()
            // 解除绑定内容
            ute.type = this.type
            ute.uid = SharedPreferencesUtil.getInstance().uid
            var br = ProjectBaseResult()
            try {
                br = mCarLib?.postRequest(ute.toJson(ute), "user/thirdparty/unbinding", ProjectBaseResult::class.java) as ProjectBaseResult
            } catch (e: Exception) {
                NetUtil.handlePostException(br, e)
            }

            return br
        }

        override fun onPostExecute(result: ProjectBaseResult) {
            super.onPostExecute(result)

            dismissLoadingDialog()
            isUnbindTaskRun = false

            if (result.errCode == -1) {
                if (result.code == CarEntity.SUCC) {
//                    getBindStatusDetail()
                    setButtonText(bind_status_textview, false)
                    OldToastUtil.show(this@PersonalInfoActivity, "解除绑定成功")
                } else {
                    OldToastUtil.show(this@PersonalInfoActivity, result.msg)
                }
            } else {
                OldToastUtil.showerror(this@PersonalInfoActivity, result.errCode)
            }
        }
    }

//    微信绑定receiver

    private var mBindReceiver: BindReceiver? = null
    /* wechat */
    private var mWeChatOpenId: String? = null
    private var mWeChatUnionid: String? = null
    private var mWeChatResult: WXUserResult? = null

    private fun bindWechatReceiver() {
        mBindReceiver = BindReceiver()
        val intentFilter = IntentFilter()
        intentFilter.addAction(CarEntity.ACTION_BIND_WX)
        intentFilter.addAction(CarEntity.BROADCAST_SHARE_RETURN_STATUS)
        registerReceiver(mBindReceiver, intentFilter)
    }

    private inner class BindReceiver : BroadcastReceiver() {
        override fun onReceive(context: Context, intent: Intent) {
            val action = intent.action
            if (!TextUtils.isEmpty(action) && action == CarEntity.ACTION_BIND_WX) {
                mWeChatResult = intent.getSerializableExtra("wx_user_info") as WXUserResult
                mWeChatOpenId = intent.getStringExtra("wx_openid")
                mWeChatUnionid = intent.getStringExtra("wx_unionid")
                bindThird()

            }
            isBindingWechat = false
        }
    }


    private var isBindThirdTaskRun = false

    private fun bindThird() {
        if (!NetUtil.isNetworkAvailable(this@PersonalInfoActivity)) {
            OldToastUtil.showerror(this@PersonalInfoActivity, OldToastUtil.TIMEOUT_EXCEPTION)
            return
        }
        if (mWeChatResult == null || TextUtils.isEmpty(mWeChatOpenId)) {
            OldToastUtil.showerror(this@PersonalInfoActivity, OldToastUtil.TIMEOUT_EXCEPTION)
            return
        }
        if (mWeChatResult == null || TextUtils.isEmpty(mWeChatUnionid)) {
            OldToastUtil.showerror(this@PersonalInfoActivity, OldToastUtil.TIMEOUT_EXCEPTION)
            return
        }
        if (!isBindThirdTaskRun) {
            isBindThirdTaskRun = true
            BindThirdAsyncTask().execute()
        }
    }


    internal inner class BindThirdAsyncTask : AsyncTask<Void, Void, BindThirdResult>() {

        override fun onPreExecute() {
            super.onPreExecute()

            showLoadingDialog()
        }

        override fun doInBackground(vararg params: Void): BindThirdResult {
            if (mCarLib == null)
                mCarLib = CarLib.getInstance(this@PersonalInfoActivity)
            val bte = BindThirdEntitiy()
            bte.uid = SharedPreferencesUtil.getInstance().uid
            bte.openid = mWeChatOpenId
            bte.unionid = mWeChatUnionid
            if (!TextUtils.isEmpty(mWeChatResult?.nickname)) {
                bte.nickname = mWeChatResult?.nickname
            }
            if (!TextUtils.isEmpty(mWeChatResult?.sex)) {
                if (mWeChatResult?.sex == "2") {
                    bte.gender = "女"
                } else {
                    bte.gender = "男"
                }
            } else {
                bte.gender = "男"
            }
            if (!TextUtils.isEmpty(mWeChatResult?.province)) {
                bte.province = mWeChatResult?.province
            }
            if (!TextUtils.isEmpty(mWeChatResult?.city)) {
                bte.city = mWeChatResult?.city
            }
            if (!TextUtils.isEmpty(mWeChatResult?.country)) {
                bte.country = mWeChatResult?.country
            }
            if (!TextUtils.isEmpty(mWeChatResult?.headimgurl)) {
                bte.headimgurl = mWeChatResult?.headimgurl
            }
            bte.type = CarEntity.ThirdLoginType.WEIXIN.typeName
            var btr = BindThirdResult()
            try {
                btr = mCarLib?.postRequest(Gson().toJson(bte), "user/thirdparty/binding",
                        BindThirdResult::class.java) as BindThirdResult
            } catch (e: Exception) {
                NetUtil.handlePostException(btr, e)
            }

            return btr
        }

        override fun onPostExecute(result: BindThirdResult) {
            super.onPostExecute(result)

            dismissLoadingDialog()
            isBindThirdTaskRun = false

            if (result.errCode == -1) {
                if (result.code == CarEntity.SUCC) {
//                    getBindStatusDetail()
                    setButtonText(bind_status_textview, true)
                } else {
                    OldToastUtil.show(this@PersonalInfoActivity, result.msg)
                }
            } else {
                OldToastUtil.showerror(this@PersonalInfoActivity, result.errCode)
            }
        }
    }


    private val sexArry = arrayOf("男", "女")// 性别选择
    /* 性别选择框 */
    private fun goGender() {
        var checkedItem = 0

        when (tv_sex.text.toString()) {
            "男" -> checkedItem = 0
            "女" -> checkedItem = 1
        }

        val builder = AlertDialog.Builder(this)// 自定义对话框
        builder.setSingleChoiceItems(sexArry, checkedItem) { dialog, which ->
            // which是被选中的位置
            tv_sex.text = sexArry[which]
            dialog.dismiss()// 随便点击一个item消失对话框，不用点击确认取消
            UserUpdataAsyncTask().execute()
        }
        builder.show()// 让弹出框显示
    }


//    昵称相关

    /**
     * 昵称
     */
    private fun goNickName() {
        // 获取焦点弹出键盘，并且文字置右
        tv_nickname.isFocusable = true
        tv_nickname.isFocusableInTouchMode = true
        tv_nickname.requestFocus()
        tv_nickname.findFocus()
        val inputManager = tv_nickname.context.getSystemService(Context.INPUT_METHOD_SERVICE) as InputMethodManager
        inputManager.showSoftInput(tv_nickname, 0)
    }


    override fun dispatchTouchEvent(ev: MotionEvent): Boolean {
        if (ev.action === MotionEvent.ACTION_DOWN) {
            val v = currentFocus
            if (isShouldHideInput(v, ev)) {
                val imm = getSystemService(Context.INPUT_METHOD_SERVICE) as InputMethodManager
                if (imm != null) {
                    imm!!.hideSoftInputFromWindow(v.windowToken, 0)
                }
            }
            return super.dispatchTouchEvent(ev)
        }
        // 必不可少，否则所有的组件都不会有TouchEvent了
        return if (window.superDispatchTouchEvent(ev)) {
            true
        } else onTouchEvent(ev)
    }

    private fun isShouldHideInput(v: View?, event: MotionEvent): Boolean {
        if (v != null && v is EditText) {
            val leftTop = intArrayOf(0, 0)
            //获取输入框当前的location位置
            v.getLocationInWindow(leftTop)
            val left = leftTop[0]
            val top = leftTop[1]
            val bottom = top + v.height
            val right = left + v.width
            if (event.x > left && event.x < right
                    && event.y > top && event.y < bottom) {
                // 点击的是输入框区域，保留点击EditText的事件
                return false
            } else {
                //使EditText触发一次失去焦点事件
                v.isFocusable = false
                v.isFocusableInTouchMode = false
                return true
            }
        }
        return false
    }


}
