package com.jiaoyinbrother.monkeyking.activity

import android.content.Intent
import android.os.AsyncTask
import android.os.Handler
import android.text.TextUtils
import android.view.View
import android.widget.*
import com.jiaoyinbrother.monkeyking.CarEntity
import com.jiaoyinbrother.monkeyking.R
import com.jiaoyinbrother.monkeyking.bean.*
import com.jiaoyinbrother.monkeyking.network.CarLib
import com.jiaoyinbrother.monkeyking.util.SharedPreferencesUtil
import com.jybrother.sineo.library.base.BaseActivity
import com.jybrother.sineo.library.bean.DepositBean
import com.jybrother.sineo.library.bean.OrderDetailResult
import com.jybrother.sineo.library.bean.OrderPayRequest
import com.jybrother.sineo.library.bean.PayMethodAvaiBean
import com.jybrother.sineo.library.view.GeneralViewInterface
import com.jybrother.sineo.library.presenter.PayMoneyPresenterImpl
import com.jybrother.sineo.library.util.ConstantsUtil
import com.jybrother.sineo.library.util.OldToastUtil
import com.jybrother.sineo.library.util.QRCodeUtil
import kotlinx.android.synthetic.main.activity_qrcode_pay.*
import java.util.ArrayList

class QRCodePayActivity : BaseActivity() {

    private var mContext = this
    private var title_btn: Button? = null

    private val pay_method_wxin = 6
    private val pay_method_alipay = 7
    private val pay_method_bank = 12

    private val qurey_interval: Long = 5 * 1000

    companion object {
        val order_id: String = "order_id"
        val amount: String = "amount"
        val pay_type: String = "pay_type"
        val pay_method_avai: String = "pay_method_avai"
        val pay_type_car = 1  //车辆押金
        val pay_type_illegal = 2 //违章押金
        val deposit_status_name = "deposit_status_name"
    }

    override fun getLayoutId(): Int {
        return R.layout.activity_qrcode_pay
    }

    override fun initView() {
        title_btn = findViewById(R.id.ivTitleName) as Button
    }

    override fun initToolBar() {
    }

    override fun initListeners() {
        select_rg.setOnCheckedChangeListener(object : RadioGroup.OnCheckedChangeListener {
            override fun onCheckedChanged(group: RadioGroup?, checkedId: Int) {
                when (checkedId) {
                    R.id.btn_0 -> requestOrderPay(pay_method_bank)
                    R.id.btn_1 -> requestOrderPay(pay_method_wxin)
                    R.id.btn_2 -> requestOrderPay(pay_method_alipay)
                }
                if (checkedId == R.id.btn_0) {
                    if (mBankDescription != null) pre_tv.text = "（" + mBankDescription + "）"
                } else {
                    pre_tv.text = ""
                }
            }

        })
    }

    private var mOrderId: String? = null
    private var mAmount: Int? = null
    private var mPayType = 0

    private var mCarLib: CarLib? = null
    private var bgWidth = 0
    private var qrCodeWidth = 0
    private var mBankDescription = ""

    override fun initData() {
        title_btn?.setText("收款码")
        var sreenWidth = windowManager.defaultDisplay.width
        bgWidth = sreenWidth * 83 / 100
        qrCodeWidth = sreenWidth * 11 / 20
        qrcode_bg1.layoutParams = LinearLayout.LayoutParams(bgWidth, bgWidth)
        qrcode_bg2.layoutParams = LinearLayout.LayoutParams(bgWidth, bgWidth / 5)
        img_qrcode.layoutParams = LinearLayout.LayoutParams(qrCodeWidth, qrCodeWidth)
        setRadioBtnDrawable(btn_0, R.drawable.selector_bankcard)
        setRadioBtnDrawable(btn_1, R.drawable.selector_wx)
        setRadioBtnDrawable(btn_2, R.drawable.selector_alipay)

        mOrderId = intent.getStringExtra(order_id)
        mAmount = intent.getIntExtra(amount, 0)
        mPayType = intent.getIntExtra(pay_type, 0)
        val serializableExtra = intent.getSerializableExtra(pay_method_avai) as ArrayList<PayMethodAvaiBean>

        if (mPayType == pay_type_car) {
            deposit_tv.text = "请支付车辆押金"
        } else if (mPayType == pay_type_illegal) {
            deposit_tv.text = "请支付违章押金"
        }
        amount_tv.text = " ¥" + mAmount?.toInt()

        for (i in serializableExtra?.indices) {
            val paymethodAvai = serializableExtra[i]
            when (paymethodAvai?.id) {
                PayMethodAvaiBean.YIBAOPAY -> {
                    btn_0.visibility = View.VISIBLE
                    mBankDescription = paymethodAvai?.description ?: ""
                }
                PayMethodAvaiBean.WECHATPAY -> {
                    btn_1.visibility = View.VISIBLE
                }
                PayMethodAvaiBean.ALIPAY -> {
                    btn_2.visibility = View.VISIBLE
                }
            }
        }


        if (btn_0.visibility == View.VISIBLE) {
            btn_0.isChecked = true
            if (mBankDescription != null) pre_tv.text = "（" + mBankDescription + "）"
            requestOrderPay(pay_method_bank)
        } else {
            if (btn_1.visibility == View.VISIBLE) {
                btn_1.isChecked = true
                requestOrderPay(pay_method_wxin)
            } else {
                btn_2.isChecked = true
                requestOrderPay(pay_method_alipay)
            }
        }
        requestOrderDetail()
    }

    private fun setRadioBtnDrawable(btn: RadioButton, imgId: Int) {
        val drawable = resources.getDrawable(imgId)
        drawable.setBounds(0, 0, drawable.intrinsicWidth * 3 / 4, drawable.intrinsicHeight * 3 / 4)
        btn.setCompoundDrawables(null, drawable, null, null)
    }

    private fun createQRCode(url: String?) {
        var content = ""
        if (url != null) content = url
        val qrCodeBitmap = QRCodeUtil.createQRCodeBitmap(content, qrCodeWidth, qrCodeWidth)
        img_qrcode.setImageBitmap(qrCodeBitmap)
    }

    private var mPayMethod = 0

    private fun requestOrderPay(pay_method: Int) {
        val presenter = PayMoneyPresenterImpl(this, OrderPayResult::class.java)
        presenter.addListener(orderPayModel)
        showLoadingDialog()
        mPayMethod = pay_method
        presenter.goOrderPay(getRequestEntity(pay_method))
    }

    private fun getRequestEntity(pay_method: Int): OrderPayRequest {
        var request = OrderPayRequest()
        request.orderid = mOrderId
        request.amount = (mAmount ?: 0).toFloat()
        request.pay_method = pay_method
        request.pay_type = mPayType
        if (pay_method == pay_method_wxin ||
                pay_method == pay_method_alipay) {
            request.trade_type = "NATIVE"
        } else if (pay_method == pay_method_bank) {
            request.runtype = "APP_SCAN"
        }
        return request
    }

    private val orderPayModel = object : GeneralViewInterface {
        override fun getCodeObjectSuccess(bean: Any?) {
            dismissLoadingDialog()
            val result = bean as OrderPayResult
            if (result != null) {
                if (result.code == CarEntity.SUCC) {
                    when (mPayMethod) {
                        pay_method_wxin -> createQRCode(result.code_url)
                        pay_method_alipay -> createQRCode(result.url)
                        pay_method_bank -> createQRCode(result.url)
                    }
                } else {
                    showToast(result.msg)
                }
            }
        }

        override fun getCodeBeanFail(errorCode: Int) {
            showErrorToast(errorCode)
            dismissLoadingDialog()
        }

    }


    private inner class OrderDetailAsyncTask : AsyncTask<Void, Void, OrderDetailResult>() {

        override fun onPreExecute() {
            super.onPreExecute()
        }

        override fun doInBackground(vararg params: Void): OrderDetailResult {
            if (null == mCarLib)
                mCarLib = CarLib.getInstance(applicationContext)
            val gde = OrderDetailEntity()
            gde.uid = SharedPreferencesUtil.getInstance().uid
            if (null != mOrderId)
                gde.orderid = mOrderId
            var godr = OrderDetailResult()
            try {
                godr = mCarLib?.postRequest(gde.toJson(gde), "order/get_detail",
                        OrderDetailResult::class.java) as OrderDetailResult
            } catch (e: Exception) {
//                NetUtil.handlePostException(godr, e)
            }

            return godr
        }

        override fun onPostExecute(result: OrderDetailResult) {
            super.onPostExecute(result)
            //LogUtilLib.e("*******************OrderDetailAsyncTask**********************")
            if (result.errCode == -1) {
                if (!TextUtils.isEmpty(result.code)) {
                    when (result.code) {
                        CarEntity.SUCC -> {
                            getPayResult(result)
                        }
                        CarEntity.NO_ACCESS -> {
                            if (!TextUtils.isEmpty(result.msg)) {
                                OldToastUtil.show(mContext, result.msg)
                            }
                            finish()
                        }
                        CarEntity.SIGN_ERROR -> {
                            finish()
//                            SharedPreferencesUtil.getInstance().logout()
//                            val intent = Intent(mContext, LoginActivity::class.java)
//                            intent.putExtra(CarEntity.EXTRA_BUNDLE_KEY, CarEntity.EXTRA_FLAG_ORDER_DETAIL_NOLOGIN)
//                            startActivityForResult(intent, FROM_ORDER_DETAIL)
                        }
                    }
                }

            } else {
                OldToastUtil.showerror(mContext, result.errCode)
                finish()
            }
        }

    }

    private fun getPayResult(result: OrderDetailResult) {
        if (result?.deposit == null) return
        if (mPayType == pay_type_car) {
            //车辆押金
            for (i in result.deposit!!.indices) {
                var deposit = result.deposit!![i]
                if (deposit != null && TextUtils.equals(deposit.type, ConstantsUtil.PAY_PROJECT_VEHICLE)) {
                    getResultStatus(deposit)
                }
            }
        } else if (mPayType == pay_type_illegal) {
            //违章押金
            for (i in result.deposit!!.indices) {
                var deposit = result.deposit!![i]
                if (deposit != null && TextUtils.equals(deposit.type, ConstantsUtil.PAY_PROJECT_ILLEGAL)) {
                    getResultStatus(deposit)
                }
            }
        }


    }

    private fun getResultStatus(deposit: DepositBean) {
        if (!isFinish) {

            if (deposit.status_code == DepositBean.DEPOSIT_PAYED) {
                //已支付

                var intent = Intent()
                intent.putExtra(deposit_status_name, deposit.status_name)
                setResult(0, intent)
                finish()
            } else {
                //支付失败
                Handler().postDelayed(Runnable {
                    runOnUiThread {
                        requestOrderDetail()
                    }

                }, qurey_interval)
            }
        }
    }

    private var isFinish: Boolean = false

    private fun requestOrderDetail() {
        var orderDetailAsyncTask = OrderDetailAsyncTask()
        orderDetailAsyncTask.execute()
    }

    override fun finish() {
        isFinish = true
        super.finish()
    }

    override fun onBackPressed() {
        isFinish = true
        super.onBackPressed()
    }

}
