package com.jiaoyinbrother.monkeyking.activity

import android.text.TextUtils
import android.view.View
import com.jiaoyinbrother.monkeyking.R
import com.jybrother.sineo.library.base.BaseActivity
import com.jybrother.sineo.library.bean.XiaoBaiResult
import com.jybrother.sineo.library.util.LogUtil

import kotlinx.android.synthetic.main.activity_result_data.*

class ResultDataActivity : BaseActivity() {
    var type: Int = 0;
    var xiaoBaiResult: XiaoBaiResult? = null;

    override fun initView() {
        result_data.visibility = View.VISIBLE;
    }

    override fun initToolBar() {

        when (type) {
            TYPE_FROM_XIAOBAI -> {
                mainTitle.text = "绑定结果"
            }
            else -> {
                mainTitle.text = "Default"
            }
        }

    }

    override fun initListeners() {
        when (type) {
            TYPE_FROM_XIAOBAI -> {
                // 此处需要白底红框按钮
                result_data.setNegativeButton("确定", View.OnClickListener {
                    finish();
                })
            }
            else -> {

            }
        }

//        result_data.setNegativeButton("No", View.OnClickListener {
//            val i:Int = 0;
//        })
    }

    override fun initData() {
        when (type) {
            TYPE_FROM_XIAOBAI -> {
                handleXiaoBaiData()
            }
            else -> {

            }
        }


    }

    private fun handleXiaoBaiData() {
        if (xiaoBaiResult == null) {
            finish()
        } else {
            var pic = 0//: Int = R.mipmap.icon_xiaobai_success
            var title = ""
            var contentGreen = ""
            var contentGrey = ""

            if (TextUtils.isEmpty(xiaoBaiResult?.jd_score)) {
                title = "抱歉！"
                contentGreen = ""
                contentGrey = "暂未获取到您的京东小白信用评估值。为了保障您的权益，请重新认证"
                pic = R.mipmap.icon_xiaobai_re_authentication
            } else {
                if (xiaoBaiResult?.status == XiaoBaiResult.AUTHED) {
                    if (xiaoBaiResult?.is_freed == XiaoBaiResult.IS_FREED) {
                        title = "恭喜！您符合减免要求"
                        contentGreen = "您的小白信用为" + xiaoBaiResult?.jd_score
                        contentGrey = "（车辆押金≤5000元的押金全免，车辆押金>5000元的需支付全部押金，在取车时需要刷取3000元的违章押金）"
                        pic = R.mipmap.icon_xiaobai_success
                    } else {
                        title = "抱歉！您暂不符合减免要求\n"
                        contentGreen = "您的小白信用为" + xiaoBaiResult?.jd_score
                        contentGrey = "赶紧去提升京东小白信用吧"
                        pic = R.mipmap.icon_xiaobai_fail
                    }
                }
            }
//
//
            result_data.setEmptyData(pic, title, contentGrey, contentGreen);


        }

    }

    override fun getLayoutId(): Int {

        getParams()

        return R.layout.activity_result_data;
    }

    private fun getParams() {

        val b = this.intent.extras ?: return
        type = b.getInt(ACTIVITY_TYPE)
        xiaoBaiResult = b.getSerializable(XIAOBAI_RESULT) as XiaoBaiResult
        LogUtil.e("xiaoBaiResult=" + xiaoBaiResult.toString());
        LogUtil.e("type =" + type)

    }

    companion object {
        val ACTIVITY_TYPE = "ACTIVITY_TYPE"
        val XIAOBAI_RESULT = "XIAOBAI_RESULT";

        val TYPE_FROM_XIAOBAI = 10;


    }

}
