package com.jiaoyinbrother.monkeyking.activity

import android.content.Context
import android.content.Intent
import android.view.View
import android.view.View.GONE
import android.widget.*
import com.baidu.location.BDLocation
import com.baidu.mapapi.map.*
import com.baidu.mapapi.model.LatLng
import com.facebook.drawee.view.SimpleDraweeView
import com.jiaoyinbrother.monkeyking.Constants
import com.jiaoyinbrother.monkeyking.R
import com.jybrother.sineo.library.bean.CarSearchBean
import com.jiaoyinbrother.monkeyking.bean.ChooseAddressBean
import com.jiaoyinbrother.monkeyking.util.DialogUtil
import com.jiaoyinbrother.monkeyking.util.LocationUtil
import com.jiaoyinbrother.monkeyking.util.*
import com.jiaoyinbrother.monkeyking.util.Util
import com.jiaoyinbrother.monkeyking.view.CommentListLayout
import com.jybrother.sineo.library.base.BaseActivity
import com.jybrother.sineo.library.bean.LocationBean
import com.jybrother.sineo.library.bean.SiteBean2
import com.jybrother.sineo.library.bean.SiteInfoResult
import com.jybrother.sineo.library.view.GeneralViewInterface
import com.jybrother.sineo.library.presenter.SiteInfoPresenterImpl
import com.jybrother.sineo.library.util.DensityUtil
import com.jybrother.sineo.library.util.LogUtil
import com.jybrother.sineo.library.util.SharePreferenceTools
import kotlinx.android.synthetic.main.activity_site_detail.*

class SiteDetailActivity : BaseActivity(), View.OnClickListener, GeneralViewInterface {

    private var mPresenter: SiteInfoPresenterImpl? = null//SiteInfoPresenter(this, SiteInfoResult::class.java)
    private var locBean: LocationBean? = null
    private var site: SiteBean2? = null
    private var result: SiteInfoResult? = null
    private var siteid = ""
    private var mFromType = 0
    private var spTool: SharePreferenceTools? = null
    private var spUtil: SharedPreferencesUtil? = null
    private var addressBean: ChooseAddressBean? = null
    private var MODIFY_TYPE = ChooseAddressBean.TYPE_NONE

    override fun onClick(v: View?) {
        when (v) {
            site_detail_evaluation_more -> {
                var intent = Intent(this, SiteInfoCommentActivity::class.java)
                intent.putExtra("siteid", siteid)
                intent.putExtra("type", CommentListLayout.TYPE_SITE)
                startActivity(intent)
            }
            site_detail_tel -> DialogUtil.onSiteDial(this, result?.phone)
            site_detail_evaluation_btn -> {

                when (mFromType) {

                    TYPE_FROM_BOOK -> {
                        saveBean(site)
                        val intent = Intent(this, BookActivity::class.java)
                        intent.putExtra("onNewIntent", "onNewIntent")
                        intent.flags = Intent.FLAG_ACTIVITY_CLEAR_TOP
                        intent.addFlags(Intent.FLAG_ACTIVITY_SINGLE_TOP)
                        startActivity(intent)
                    }
                    TYPE_FROM_CARLIST_CHANGE_SITE -> {
                        toCarType()
                        var intent: Intent? = null
                        if(LocationUtil.isParityCity()){
                            intent = Intent(this@SiteDetailActivity, CarTypeListParityActivity::class.java)
                        }else{
                            intent = Intent(this@SiteDetailActivity, CarTypeListActivity::class.java)
                        }
                        intent.flags = Intent.FLAG_ACTIVITY_CLEAR_TOP
                        intent.putExtra("TYPE", ChooseAddressBean.TYPE_SITE_ONLY)
                        intent.putExtra(Constants.RESULT_VALUE, site)
                        startActivity(intent)
                    }
                    TYPE_FROM_MAIN_SEARCH_ADDRESS -> {
                        toCarType()
                        var intent: Intent? = null
                        if(LocationUtil.isParityCity()){
                            intent = Intent(this@SiteDetailActivity, CarTypeListParityActivity::class.java)
                        }else{
                            intent = Intent(this@SiteDetailActivity, CarTypeListActivity::class.java)
                        }
//                        intent.flags = Intent.FLAG_ACTIVITY_CLEAR_TOP
                        intent.putExtra("TYPE", ChooseAddressBean.TYPE_SITE_ONLY)
                        intent.putExtra(Constants.RESULT_VALUE, site)
                        startActivity(intent)
                    }
                    TYPE_FROM_MAIN_SITES -> {
                        toCarType()
                        var intent: Intent? = null
                        if(LocationUtil.isParityCity()){
                            intent = Intent(this@SiteDetailActivity, CarTypeListParityActivity::class.java)
                        }else{
                            intent = Intent(this@SiteDetailActivity, CarTypeListActivity::class.java)
                        }
                        intent.putExtra("TYPE", ChooseAddressBean.TYPE_SITE_ONLY)
                        intent.putExtra(Constants.RESULT_VALUE, site)
                        startActivity(intent)
                        // todo 寸
                    }
                }

            }
        }
    }

    private fun toCarType() {
        val json = spUtil?.homePageScreen
        val carSearchBean = Util.jsonToEntity(json, CarSearchBean::class.java) as CarSearchBean
        carSearchBean.type = ChooseAddressBean.TYPE_SITE_ONLY
        carSearchBean.site = site
        SharedPreferencesUtil.getInstance().saveHomePageScreen(Util.entityToJson(carSearchBean))
    }


    private var mToolBarTitle: TextView? = null
    private var mMapView: MapView? = null
    private var mBaidumap: BaiduMap? = null
    private var mMarkLayout: View? = null
    //评论

    private var mCommentAvatar: SimpleDraweeView? = null
    private var mCommentPhone: TextView? = null
    private var mCommentDate: TextView? = null
    private var mCommentContent: TextView? = null
    private var mCommentRating: RatingBar? = null
    override fun getLayoutId(): Int {
        return R.layout.activity_site_detail
    }

    override fun initView() {
        spTool = SharePreferenceTools(this@SiteDetailActivity)
        spUtil = SharedPreferencesUtil.getInstance()
        mMapView = findViewById(R.id.map_layout) as MapView
        mBaidumap = mMapView?.map
        mToolBarTitle = findViewById(R.id.ivTitleName) as TextView
        mMarkLayout = findViewById(R.id.site_detail_mark)
        mCommentAvatar = mMarkLayout?.findViewById(R.id.item_site_detail_evaluation_avatar) as SimpleDraweeView
        mCommentPhone = mMarkLayout?.findViewById(R.id.item_site_detail_evaluation_phone) as TextView
        mCommentDate = mMarkLayout?.findViewById(R.id.item_site_detail_evaluation_date) as TextView
        mCommentContent = mMarkLayout?.findViewById(R.id.item_site_detail_evaluation_content) as TextView
        mCommentRating = mMarkLayout?.findViewById(R.id.rb_comment) as RatingBar
    }

    override fun initToolBar() {
        mToolBarTitle?.text = "网点详情"
    }

    override fun initListeners() {
        mBaidumap?.setOnMarkerClickListener({
            var location = BDLocation()
            location.latitude = locBean!!.lat
            location.longitude = locBean!!.lng
            LocationUtil.startChooseMap(
                    this@SiteDetailActivity,
                    location,
                    "",
                    locBean,
                    "",
                    ""
            )
            true
        })
        site_detail_evaluation_more.setOnClickListener(this)
        site_detail_tel.setOnClickListener(this)
        site_detail_evaluation_btn.setOnClickListener(this)
    }

    override fun initData() {
        mFromType = intent.getIntExtra("SiteDetailFromType", 0)
        if (intent.getSerializableExtra("siteDetail") != null) {
            site = intent.getSerializableExtra("siteDetail") as SiteBean2
        }
        siteid = intent.getStringExtra("siteDetailId")
        MODIFY_TYPE = intent.getIntExtra("changeType", 0)
//        siteid = site?.siteid.toString()
        mPresenter = SiteInfoPresenterImpl(this, SiteInfoResult::class.java)
        mPresenter?.requestSiteInfo(siteid)
        mPresenter?.addListener(this)
        when (mFromType) {
            TYPE_FROM_CAR_DETAIL -> site_detail_evaluation_btn.visibility = GONE
            TYPE_FROM_CARLIST_CHANGE_SITE, TYPE_FROM_MAIN_SEARCH_ADDRESS, TYPE_FROM_MAIN_SITES -> site_detail_evaluation_btn.text = "预订车辆"
            TYPE_FROM_BOOK -> site_detail_evaluation_btn.text = "确认更换"
        }
        addressBean = JsonConvertUtil.getChooseAddressBean(spTool?.getString(SharePreferenceTools.JSON_FOR_CHOOSE_ADDR)) ?: ChooseAddressBean()

    }

    private fun saveBean(site: SiteBean2?) {

        addressBean?.type = MODIFY_TYPE
        addressBean?.city = spUtil?.userCityName
        addressBean?.address = ""
        addressBean?.location = null
        addressBean?.site = site
        JsonConvertUtil.saveChooseAddrJson(spTool, Util.entityToJson(addressBean))
    }


    override fun getCodeBeanFail(errorCode: Int) {
        showErrorToast(errorCode)
        finish()
    }

    override fun getCodeObjectSuccess(bean: Any?) {
        LogUtil.e("bean-->" + bean.toString())

        result = bean as SiteInfoResult
        val markBean = result?.mark
        site_detail_evaluation_more.text = "查看全部" + markBean?.total + "条评价" //评论总数
        site_detail_ratingbar.rating = markBean?.rate0?.toFloat() ?: 0.0f//综合评价
        site_detail_number.text = markBean?.rate0.toString()


        //名称
        site_detail_name.text = result?.name
        //标签
        val tagList = result?.icon_tags
//        site_detail_tag?.removeAllViews()
        if (tagList != null) {
            for (tag in tagList) {
//                site_detail_tag?.addView(SiteAdapter.addViews(tag, this))
                site_detail_tag?.addView(addViews(tag, this))
            }
            site_detail_tag?.visibility = View.VISIBLE
        }


        val screenWidth = windowManager.defaultDisplay.width - DensityUtil.dip2px(this, 28f)
        // 下面代码是用来计算控件宽度的为了满足产品的无聊需求
        val w = View.MeasureSpec.makeMeasureSpec(0, View.MeasureSpec.UNSPECIFIED)
        val h = View.MeasureSpec.makeMeasureSpec(0, View.MeasureSpec.UNSPECIFIED)
        // 尾部布局宽度
        val endWidth = DensityUtil.dip2px(this, 15f)
        // 标签布局宽度
        site_detail_tag?.measure(w, h)
        val tagWidth = site_detail_tag?.measuredWidth ?: 0
        // site 名称最大宽度，用来设置名称尾部省略
        site_detail_name?.maxWidth = screenWidth - endWidth - tagWidth


        //营业时间
        site_detail_time.text = result?.from_time + "-" + result?.to_time
        //地址
        site_detail_address.text = result?.address
        //坐标
        locBean = result?.location
        initMap(locBean?.lat ?: 0.0, locBean?.lng ?: 0.0)

        val markList = markBean?.marks
        if (markList != null && markList.size > 0) {
            val marksItemBean = markList[0]
            mCommentPhone?.text = marksItemBean.name
            mCommentDate?.text = marksItemBean.time
            mCommentContent?.text = marksItemBean.comment
            mCommentAvatar?.setImageURI(marksItemBean.headimg_url)
            mCommentRating?.rating = (marksItemBean.rate0 ?: 0).toFloat()
        } else {
            site_detail_number.visibility = View.GONE
            site_detail_ratingbar.visibility = View.GONE
            site_detail_mark.visibility = View.GONE
            site_detail_evaluation_more.visibility = View.GONE
            site_detail_none_evaluation.visibility = View.VISIBLE
        }
    }

    private fun initMap(lat: Double, lng: Double) {

        mBaidumap = mMapView?.map
        var mLatLng = LatLng(lat, lng)
        val ooA = MarkerOptions().position(mLatLng).icon(BitmapDescriptorFactory.fromResource(R.mipmap.icon_mark_site))
                .zIndex(9).draggable(true).animateType(MarkerOptions.MarkerAnimateType.grow)
        val mMapStatus = MapStatus.Builder().target(mLatLng).zoom(15f).build()
        val mMapStatusUpdate = MapStatusUpdateFactory.newMapStatus(mMapStatus)
        //改变地图状态
        mBaidumap?.setMapStatus(mMapStatusUpdate)
        mBaidumap?.addOverlay(ooA)

    }

    companion object {
//        val FROM_TYPE_YUDING  = 1
//        val FROM_TYPE_CHANGE  = 2

        //        网点详情类型
//        提交订单页 更换
        val TYPE_FROM_BOOK = 1
        //        选车列表，更换网点 预订
        val TYPE_FROM_CARLIST_CHANGE_SITE = 2
        //        列表页点击网点；和车辆详情，类型一致 gone
        val TYPE_FROM_CAR_DETAIL = 3
        //        主页搜索地址 预订
        val TYPE_FROM_MAIN_SEARCH_ADDRESS = 4
        //        主页网点 预订
        val TYPE_FROM_MAIN_SITES = 5


    }


    fun addViews(tag: String, context: Context): ImageView {
        val img = ImageView(context)
        var lp = LinearLayout.LayoutParams(DensityUtil.dip2px(context, 14f), DensityUtil.dip2px(context, 14f))
        var resource = 0
        when (tag) {
            "品牌" -> {
                resource = R.mipmap.ic_tag_brand
                lp = LinearLayout.LayoutParams(DensityUtil.dip2px(context, 21f), DensityUtil.dip2px(context, 12f))
            }
            "24h" -> {
                resource = R.mipmap.ic_tag_24h
            }
            "充电桩" -> {
                resource = R.mipmap.ic_tag_charge
            }
            "机场" -> {
                resource = R.mipmap.ic_tag_airport
            }
            "火车站" -> {
                resource = R.mipmap.ic_tag_train
            }
        }
        img.setBackgroundResource(resource)
        lp.setMargins(6, 0, 0, 0)
        img.layoutParams = lp
        return img
    }

}
