package com.jiaoyinbrother.monkeyking.activity

import android.app.Activity
import android.content.Context
import android.content.Intent
import android.text.TextUtils
import android.view.View
import com.baidu.mapapi.search.core.PoiInfo
import com.jiaoyinbrother.monkeyking.CarEntity
import com.jiaoyinbrother.monkeyking.Constants
import com.jiaoyinbrother.monkeyking.R
import com.jiaoyinbrother.monkeyking.bean.ChooseAddressBean
import com.jiaoyinbrother.monkeyking.bean.SitesResult
import com.jiaoyinbrother.monkeyking.fragment.SiteListFragment
import com.jiaoyinbrother.monkeyking.fragment.SiteMapFragment
import com.jiaoyinbrother.monkeyking.util.JsonConvertUtil
import com.jiaoyinbrother.monkeyking.util.LocationUtil
import com.jiaoyinbrother.monkeyking.util.SharedPreferencesUtil
import com.jiaoyinbrother.monkeyking.util.Util
import com.jybrother.sineo.library.adapter.MyFragmentAdapter
import com.jybrother.sineo.library.base.BaseActivity
import com.jybrother.sineo.library.bean.*
import com.jybrother.sineo.library.presenter.GetSitePresenterImpl
import com.jybrother.sineo.library.presenter.MainFragmentPresnterImpl
import com.jybrother.sineo.library.util.ConstantsUtil
import com.jybrother.sineo.library.util.LogUtil
import com.jybrother.sineo.library.util.SharePreferenceTools
import com.jybrother.sineo.library.util.StatisticsUtil
import com.jybrother.sineo.library.view.GeneralViewInterface
import kotlinx.android.synthetic.main.activity_site_list.*

/**
 * The Author : Soda
 * Created on 2018/01/05.
 */
class SiteListActivity : BaseActivity(), View.OnClickListener {

    //    /*  区分修改内容type  */
    private var MODIFY_TYPE = ChooseAddressBean.TYPE_NONE

    private var listFragment: SiteListFragment? = null
    private var mapFragment: SiteMapFragment? = null

    private var flagFrom: String = ""
    private var siteDetailType: Int = 0
    private var siteID: String? = null
    private var returnCity: String? = null
    private var tempCityName: String? = null
    //    private var addrOrSiteType: String? = null
    private var siteRequest: GetSitesBean? = null
    private var addressBean: ChooseAddressBean? = null
    private var spUtil = SharedPreferencesUtil.getInstance()
    private var showList = SharedPreferencesUtil.getInstance().isShowList


    override fun getLayoutId(): Int {
        getIntentData()
        return R.layout.activity_site_list
    }

    override fun initView() {
        listFragment = SiteListFragment()
        mapFragment = SiteMapFragment()
        siteViewPager.offscreenPageLimit = 2
        val mFragmentAdapter = MyFragmentAdapter(supportFragmentManager)
        mFragmentAdapter.addFragment(listFragment)
        mFragmentAdapter.addFragment(mapFragment)
        siteViewPager.adapter = mFragmentAdapter
    }

    override fun initToolBar() {
        when (flagFrom) {
            TYPE_SITE_LIST -> mainTitle.text = TITLE_LIST
            TYPE_SITE_SEARCH_MAIN, TYPE_SITE_SEARCH_CARS -> mainTitle.text = TITLE_SEARCH
            TYPE_SITE_SWITCH -> mainTitle.text = TITLE_SWITCH
        }
        if (flagFrom == TYPE_SITE_LIST)
            subTitle.text = if (showList) SUB_MAP else SUB_LIST
    }

    override fun initListeners() {
        if (flagFrom == TYPE_SITE_LIST) subTitle.setOnClickListener(this)

        listFragment?.setListener(object : SiteListFragment.SiteResultListener {
            override fun goSiteDetail(siteBean: SiteBean2) {
                val intent = Intent(this@SiteListActivity, SiteDetailActivity::class.java)
                MODIFY_TYPE = if (MODIFY_TYPE == ChooseAddressBean.TYPE_CITY_ONLY) ChooseAddressBean.TYPE_SITE_CITY else ChooseAddressBean.TYPE_SITE_ONLY
                intent.putExtra("SiteDetailFromType", siteDetailType)
                intent.putExtra("siteDetailId", siteBean.siteid)
                intent.putExtra("siteDetail", siteBean)
                intent.putExtra("changeType", MODIFY_TYPE)
                LogUtil.e("MODIFY_TYPE ------$MODIFY_TYPE")
                startActivity(intent)
            }

            override fun poiResult(poiInfo: PoiInfo) {
                MODIFY_TYPE = if (MODIFY_TYPE == ChooseAddressBean.TYPE_CITY_ONLY) ChooseAddressBean.TYPE_ADDR_CITY else ChooseAddressBean.TYPE_ADDR_ONLY
                saveBean(MODIFY_TYPE, spUtil?.userCityName, poiInfo.name, LocationBean(poiInfo.location?.longitude ?: 0.0, poiInfo.location?.latitude ?: 0.0), null)
                setResultData(addressBean)
            }

            override fun siteResult(siteBean: SiteBean2) {
                when (flagFrom) {
                    TYPE_SITE_LIST -> {
                        StatisticsUtil.onEvent(this@SiteListActivity, ConstantsUtil.SEARCH_ADDRESS_SITE, siteBean.address + "_" + siteBean.area_id)
                        val json = spUtil?.homePageScreen
                        val carSearchBean = Util.jsonToEntity(json, CarSearchBean::class.java) as CarSearchBean
                        carSearchBean.type = ChooseAddressBean.TYPE_SITE_ONLY
                        carSearchBean.site = siteBean
                        SharedPreferencesUtil.getInstance().saveHomePageScreen(Util.entityToJson(carSearchBean))
                        var intent: Intent = getCarListIntent(this@SiteListActivity)
                        intent.putExtra("TYPE", ChooseAddressBean.TYPE_SITE_ONLY)
                        intent.putExtra(Constants.RESULT_VALUE, siteBean)
                        startActivity(intent)
                    }
                    else -> {
                        MODIFY_TYPE = if (MODIFY_TYPE == ChooseAddressBean.TYPE_CITY_ONLY) ChooseAddressBean.TYPE_SITE_CITY else ChooseAddressBean.TYPE_SITE_ONLY
                        saveBean(MODIFY_TYPE, spUtil?.userCityName, "", null, siteBean)
                        setResultData(addressBean)
                    }
                }
            }
        })

    }

    override fun initData() {
        val spTool = SharePreferenceTools(this@SiteListActivity)
        addressBean = JsonConvertUtil.getChooseAddressBean(spTool.getString(SharePreferenceTools.JSON_FOR_CHOOSE_ADDR)) ?: ChooseAddressBean()
        tempCityName = spUtil.userCityName
        createLayout(flagFrom)// 初始化页面显示
        getSitesList(siteRequest)
    }

    override fun onClick(v: View?) {
        when (v?.id) {
        // 切换列表 or 地图
            R.id.subTitle -> {
                subTitle.text = if (showList) SUB_LIST else SUB_MAP
                showList = !showList
                siteViewPager.currentItem = if (showList) INDEX_LIST else INDEX_MAP
                spUtil?.saveIsShowList(showList)
            }
        }
    }

    private fun getIntentData() {
        flagFrom = intent?.getStringExtra(Constants.ENTRY_TYPE).toString()
        siteID = intent?.getStringExtra("take_site_id")
        returnCity = intent?.getStringExtra("return_city")
        siteDetailType = intent?.getIntExtra("SiteDetailFromType", 0) ?: 0
    }

    /**
     * 初始化布局
     * */
    private fun createLayout(flag: String) {
        // viewPager 初始显示
        siteViewPager.currentItem = if (flag == TYPE_SITE_LIST) {
            if (showList) INDEX_LIST else INDEX_MAP
        } else {
            INDEX_LIST
        }
        // getSite request
        siteRequest = when (flag) {
            SiteListActivity.TYPE_SITE_SWITCH -> getSwitchSiteRequest()
            else -> getSiteRequest()
        }
        // site list init data
        listFragment?.setInitData(flagFrom, siteID, returnCity, siteDetailType)
    }

    private fun getSiteRequest(): GetSitesBean {
        // 获取列表request
        val sitesBean = GetSitesBean()
        if (!TextUtils.isEmpty(spUtil?.uid))
            sitesBean.uid = spUtil?.uid
        sitesBean.city = spUtil?.userCityName
        sitesBean.location = LocationBean(spUtil?.userusePointLng?.toDouble() ?: 0.0,
                spUtil?.userusePointLat?.toDouble() ?: 0.0)
        return sitesBean
    }

    private fun getSwitchSiteRequest(): GetSitesBean {
        // 获取网点切换列表request
        val sitesBean = GetSitesBean()
        if (!TextUtils.isEmpty(siteID))
            sitesBean.take_siteid = siteID
        if (!TextUtils.isEmpty(returnCity))
            sitesBean.return_city = returnCity
        return sitesBean
    }

    /**
     * 获取网点列表
     * */
    private fun getSitesList(request: GetSitesBean?) {
        showLoadingDialog()
        val getSitePresenter = GetSitePresenterImpl(this@SiteListActivity, SitesResult::class.java)
        getSitePresenter.addListener(sitesModel)
        getSitePresenter.getSites(request)
    }

    private val sitesModel = object : GeneralViewInterface {
        override fun getCodeBeanFail(errorCode: Int) {
            dismissLoadingDialog()
            showErrorToast(errorCode)
        }

        override fun getCodeObjectSuccess(bean: Any) {
            val result = bean as SitesResult
            try {
                when (result.code) {
                    CarEntity.SUCC -> {
                        LogUtil.e("before mapFragment.setOverlayData")
                        // site map used
                        mapFragment?.setOverlayData(result.sites)

                        LogUtil.e("after mapFragment.setOverlayData")
                        // site list used
                        listFragment?.setListData(result.sites)
                        LogUtil.e("After listFragment.setListData")
                    }
                    else -> showToast(result.msg)
                }
            } catch (e: Exception) {
            }
            dismissLoadingDialog()
        }
    }

    private fun saveBean(type: Int, city: String?, address: String?, location: LocationBean?, site: SiteBean2?) {
        addressBean?.type = type
        if (!TextUtils.isEmpty(city)) addressBean?.city = city
        if (!TextUtils.isEmpty(address)) addressBean?.address = address
        if (location != null) addressBean?.location = location
        if (site != null) addressBean?.site = site
    }

    private fun setResultData(bean: ChooseAddressBean?) {
        val spTool = SharePreferenceTools(this@SiteListActivity)
        JsonConvertUtil.saveChooseAddrJson(spTool, Util.entityToJson(bean))
        if (flagFrom == TYPE_SITE_SEARCH_CARS){
            updateCarSearchBean(spTool)
            var intent: Intent = getCarListIntent(this@SiteListActivity)
            startActivity(intent)
            finish()
        }else{
            val intent = Intent()
            setResult(Constants.ADDRESS_RESULT, intent)
            finish()
        }
    }


    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        if (data == null) {
            LogUtil.e("onActivityResult : data == null")
            return
        }
        when (resultCode) {
            CarEntity.RESULT_CHANGE_CITY -> handleChangeCity(data)
        }
    }

    private var resultCity:String =""
    private fun handleChangeCity(data: Intent) {
        resultCity = data.getStringExtra(ChangeCityActivity.RESULT_CITY)
        if (!TextUtils.equals(resultCity, spUtil?.userCityName)) {
            val cityCfg = LocationUtil.getMatchedCitysResult(resultCity, LocationUtil.getCfgCitis())
            if (cityCfg == null) {
                showToast("切换城市失败")
                return
            }

            callGetCityActivityAPI(LocationUtil.getCityIntID(cityCfg.id))
        }
    }



    private fun callGetCityActivityAPI(cityId:Int) {
        showLoadingDialog()
        val request = MainFragmentRequest()
        request.city_id = cityId
        request.publish_channel = "APP"
        val mainPresenterImpl = MainFragmentPresnterImpl(this@SiteListActivity, City::class.java)
        mainPresenterImpl.getMainFragmentData(request)
        mainPresenterImpl.addListener(object : GeneralViewInterface {
            override fun getCodeBeanFail(errorCode: Int) {
                dismissLoadingDialog()
                showToast("切换城市失败")
            }

            override fun getCodeObjectSuccess(bean: Any) {
                dismissLoadingDialog()
                var city = bean as City
                updateUI(resultCity, city)
            }
        })
    }

    private fun updateUI(resultCity: String?, city: City?) {
        val lat = city?.gps?.lat
        val lng = city?.gps?.lng
        LocationUtil.setUserSelectLocationAddress(resultCity, lat ?: 0.0, lng ?: 0.0, "")
        MODIFY_TYPE = ChooseAddressBean.TYPE_CITY_ONLY
        val location = LocationBean(lng ?: 0.0, lat ?: 0.0)
        saveBean(MODIFY_TYPE, resultCity, "", location, null)
        listFragment?.changeCity(resultCity)
        siteRequest = getSiteRequest()
        getSitesList(siteRequest)
    }

    override fun onBackPressed() {
        if ((flagFrom == TYPE_SITE_SEARCH_MAIN || flagFrom == TYPE_SITE_SEARCH_CARS) && spUtil.userCityName != tempCityName) {
            setResultData(addressBean)
        }
        super.onBackPressed()
    }

    companion object {
        val TYPE_SITE_LIST = "TYPE_SITE_LIST"// 网点地图
        val TYPE_SITE_SEARCH_MAIN = "TYPE_SITE_SEARCH_MAIN"// 首页 取车网点选择
        val TYPE_SITE_SEARCH_CARS = "TYPE_SITE_SEARCH_CARS"// 选车列表 取车网点选择
        val TYPE_SITE_SWITCH = "TYPE_SITE_SWITCH"// 预订取还车网点，还车网点选择
        // title
        private val TITLE_SEARCH = "搜索地址"
        private val TITLE_SWITCH = "更换网点"
        private val TITLE_LIST = "网点列表"
        // area
        val AIRPORT_AREA = "机场/火车站"
        val NEARBY_AREA = "附近网点"
        // subTitle
        private val SUB_MAP = "地图"
        private val SUB_LIST = "列表"
        // viewPager index
        private val INDEX_LIST = 0
        private val INDEX_MAP = 1

        fun getCarListIntent(context: Context): Intent {
            var intent: Intent? = null
            if (LocationUtil.isParityCity()) {
                intent = Intent(context, CarTypeListParityActivity::class.java)
                if (CarTypeListActivity.mWeakReference != null && CarTypeListActivity.mWeakReference?.get() != null){
                    val carListAct = CarTypeListActivity.mWeakReference?.get() as Activity
                    carListAct.finish()
                }
            } else {
                intent = Intent(context, CarTypeListActivity::class.java)
                if (CarTypeListParityActivity.mWeakReference != null && CarTypeListParityActivity.mWeakReference?.get() != null){
                    val carListAct = CarTypeListParityActivity.mWeakReference?.get() as Activity
                    carListAct.finish()
                }
            }
            intent.flags = Intent.FLAG_ACTIVITY_CLEAR_TOP
            return intent
        }

        fun updateCarSearchBean(spTool: SharePreferenceTools) {
            val addrBean = JsonConvertUtil.getChooseAddressBean(spTool?.getString(SharePreferenceTools.JSON_FOR_CHOOSE_ADDR))
            val carSearchBean = Util.jsonToEntity(SharedPreferencesUtil.getInstance().homePageScreen, CarSearchBean::class.java) as CarSearchBean
            LogUtil.e("bean.getType() = " + addrBean.type)
            LocationUtil.updateCarSearchBeanFromAddressBean(carSearchBean, addrBean)
            val json = Util.entityToJson(carSearchBean)
            SharedPreferencesUtil.getInstance().saveHomePageScreen(json)
        }
    }
}


