package com.jiaoyinbrother.monkeyking.adapter

import android.content.Context
import android.graphics.Color
import android.graphics.drawable.ColorDrawable
import android.support.v4.content.ContextCompat
import android.text.SpannableString
import android.text.style.AbsoluteSizeSpan
import android.view.View
import android.widget.*
import com.camnter.easyrecyclerview.adapter.EasyRecyclerViewAdapter
import com.camnter.easyrecyclerview.holder.EasyRecyclerViewHolder
import com.jiaoyinbrother.monkeyking.R
import com.jiaoyinbrother.monkeyking.R.id.item_activities_discount_type_name
import com.jybrother.sineo.library.bean.ActivitiesDiscountBean
import com.jybrother.sineo.library.bean.PromotionActivityBean
import com.jybrother.sineo.library.util.TextUtil

/**
 * Created by zhangbo on 2018/3/6.
 */
class ActivitiesDiscountAdapter(private val context: Context): EasyRecyclerViewAdapter() {

    private var checkedPosition: Int = 0

    fun setCheckedPosition(checkedPosition: Int) {
        this.checkedPosition = checkedPosition
        notifyDataSetChanged()
    }
    override fun getRecycleViewItemType(position: Int): Int {
        return if (position == 0){
            1
        }else{
            0
        }
    }

    override fun onBindRecycleViewHolder(viewHolder: EasyRecyclerViewHolder?, position: Int) {

        if (viewHolder != null){
            if (position == 0){
                onFirstNullViewHolder(viewHolder)
            }else{
                onOtherViewHolder(viewHolder,position)
            }
        }
//        if (position == checkedPosition) {
//
//        } else {
//
//        }
    }

    override fun getItemLayouts(): IntArray {
        return intArrayOf(R.layout.item_activities_discount,R.layout.item_activities_discount_null)
    }
    private fun onFirstNullViewHolder(viewHolder: EasyRecyclerViewHolder){
        val layout = viewHolder.findViewById<RelativeLayout>(R.id.item_activities_discount)
        val icon = viewHolder.findViewById<ImageView>(R.id.item_activities_discount_icon)
        if (checkedPosition == 0){
            layout.setBackgroundResource(R.drawable.bg_item_activities_discount_null)
            icon.visibility = View.VISIBLE
        }else{
//            layout.setBackgroundColor(Color.WHITE)
            layout.setBackgroundResource(R.drawable.bg_item_activities_discount_content_normal)
            icon.visibility = View.GONE
        }
    }
    private fun onOtherViewHolder(viewHolder: EasyRecyclerViewHolder, position: Int){
        val item = list[position] as ActivitiesDiscountBean
        val layout = viewHolder.findViewById<LinearLayout>(R.id.item_activities_discount_content_layout)
        val textType = viewHolder.findViewById<TextView>(R.id.item_activities_discount_type_name)
        val textContent = viewHolder.findViewById<TextView>(R.id.item_activities_discount_content)
//        val sStr = SpannableString(item.name+item.discount_desc)
//        val v = AbsoluteSizeSpan(15,true)
//        sStr.setSpan(v,0,item.name!!.length,)
        if (item.discount_desc == null || item.discount_desc!!.isEmpty()){
            textContent.text = item.name
            textContent.setTextColor(ContextCompat.getColor(context, R.color.color_gray_28))
            textContent.textSize = 15f
        }else{
            textContent.text = TextUtil.setForegroundColorAndSize("${item.name}  (${item.discount_desc})",0,item.name!!.length,ContextCompat.getColor(context, R.color.color_gray_28),0,item.name!!.length,1.15f)
        }
//        val textDiscount = viewHolder.findViewById<TextView>(R.id.item_activities_discount_money)
        textType.text = item.tag
//        textContent.text = item.name
//        textDiscount.text = item.discount_desc
        val icon = viewHolder.findViewById<ImageView>(R.id.item_activities_discount_icon)
        if (position == checkedPosition) {
            layout.setBackgroundResource(R.drawable.bg_item_activities_discount_content)
            icon.visibility = View.VISIBLE
        } else {
//            layout.setBackgroundColor(Color.WHITE)
            layout.setBackgroundResource(R.drawable.bg_item_activities_discount_normal)
            icon.visibility = View.GONE
        }
    }

}