package com.jiaoyinbrother.monkeyking.adapter

import android.content.Context
import android.support.v4.content.ContextCompat
import android.widget.LinearLayout
import android.widget.TextView
import com.camnter.easyrecyclerview.adapter.EasyRecyclerViewAdapter
import com.camnter.easyrecyclerview.holder.EasyRecyclerViewHolder
import com.jiaoyinbrother.monkeyking.R
import com.jybrother.sineo.library.util.LogUtil

/**
 * The Author : Soda
 * Created on 2018/01/05.
 */
class AreaAdapter(private val context: Context) : EasyRecyclerViewAdapter() {
    private var checkedPosition: Int = 0

    fun setCheckedPosition(checkedPosition: Int) {
        this.checkedPosition = checkedPosition
        notifyDataSetChanged()
    }

    override fun getItemLayouts(): IntArray {
        return intArrayOf(R.layout.item_site_area)
    }

    override fun getRecycleViewItemType(position: Int): Int {
        return 0
    }

    override fun onBindRecycleViewHolder(viewHolder: EasyRecyclerViewHolder?, position: Int) {
        LogUtil.e("area adapter--------------------------------------------------$position")
        val name = list[position] as String

        val mView = viewHolder?.findViewById<LinearLayout>(R.id.areaLayout)

        val tvName = viewHolder?.findViewById<TextView>(R.id.areaName)
        tvName?.text = name

        if (position == checkedPosition) {
            mView?.setBackgroundColor(ContextCompat.getColor(context, R.color.color_0))
            tvName?.setTextColor(ContextCompat.getColor(context, R.color.color_4))
        } else {
            mView?.setBackgroundColor(ContextCompat.getColor(context, R.color.color_16))
            tvName?.setTextColor(ContextCompat.getColor(context, R.color.color_12))
        }
    }


}