package com.jiaoyinbrother.monkeyking.adapter

import android.content.Context
import android.text.TextUtils
import android.view.View
import android.widget.ImageView
import android.widget.LinearLayout
import android.widget.TextView
import com.camnter.easyrecyclerview.adapter.EasyRecyclerViewAdapter
import com.camnter.easyrecyclerview.holder.EasyRecyclerViewHolder
import com.camnter.easyrecyclerview.widget.EasyRecyclerView
import com.facebook.drawee.view.SimpleDraweeView
import com.jiaoyinbrother.monkeyking.R
import com.jybrother.sineo.library.bean.CarBasicsBean
import com.jybrother.sineo.library.bean.CarBean

/**
 * Created by admin on 2018/3/27.
 */
class CarsContentAdapter constructor(context: Context?): EasyRecyclerViewAdapter() {

    private var mContext: Context? = null
    init {
        mContext = context
    }
    override fun getRecycleViewItemType(position: Int): Int {
        return if(position == listSize -1) 1 else 0
    }
    override fun getItemLayouts(): IntArray {
        return intArrayOf(R.layout.cars_content_item,R.layout.cars_content_footer)
    }
    override fun onBindRecycleViewHolder(viewHolder: EasyRecyclerViewHolder?, position: Int) {
        val car_img_iv = viewHolder?.findViewById<SimpleDraweeView>(R.id.car_img_iv)
        val car_type_tv = viewHolder?.findViewById<TextView>(R.id.car_type_tv)
        val tag_recommend_iv = viewHolder?.findViewById<ImageView>(R.id.tag_recommend_iv)
        val car_info_tv = viewHolder?.findViewById<TextView>(R.id.car_info_tv)
        val space_v = viewHolder?.findViewById<View>(R.id.space_v)
        space_v?.visibility = if (position == 0) View.GONE else View.VISIBLE
        val more_ll = viewHolder?.findViewById<LinearLayout>(R.id.more_ll)
        val more_tv = viewHolder?.findViewById<TextView>(R.id.more_tv)

        val cartypesList = list as List<CarBean>
        val carBean = cartypesList[position]

        car_img_iv?.setImageURI(carBean?.pics?.pic1)
        car_type_tv?.text = carBean?.car_type_name?:""
        car_info_tv?.text = getCarInfo(carBean?.basics)
        tag_recommend_iv?.visibility = if (carBean?.isRecommend()) View.VISIBLE else View.GONE
        more_ll?.visibility = if (carBean?.last_site_num > 0) View.VISIBLE else View.GONE
        more_tv?.text = "查看剩余"+carBean?.last_site_num+"个价格"

        val sites_rv = viewHolder?.findViewById<EasyRecyclerView>(R.id.sites_rv)
        val sitesAdapter = CarsSitesAdapter(mContext)
        sitesAdapter.setOnSiteListener(OnMyListener(carBean?.car_type_id))

        if (carBean?.sites != null && carBean?.sites.size > 0){
            sitesAdapter.list = carBean?.sites
        }
        sites_rv?.adapter = sitesAdapter

        more_ll?.setOnClickListener(OnMyListener(position,carBean?.car_type_id,carBean?.next_page))
    }

    private fun getCarInfo(basics: CarBasicsBean): String {
        if (basics != null) {
            val builder = StringBuilder()
            if (!TextUtils.isEmpty(basics.getCarriage())) {
                builder.append(basics.getCarriage())
            }
            if (!TextUtils.isEmpty(basics.getDisplacement())) {
                if (builder.length > 0) {
                    builder.append(" | ")
                }
                builder.append(basics.getDisplacement())
            }
            if (!TextUtils.isEmpty(basics.getTransmission_name())) {
                builder.append(basics.getTransmission_name())
            }
            if (builder.length > 0) {
                builder.append(" | ")
            }
            builder.append(basics.getCapacity().toString() + "座")

            return builder.toString()
        }
        return ""
    }

    inner class OnMyListener : View.OnClickListener,CarsSitesAdapter.OnSiteListener{
        private var mPosition = 0
        private var mCarTypeId: String? = null
        private var mNextPage = 0
        constructor(carTypeId: String){
            this.mCarTypeId = carTypeId
        }
        constructor(position: Int,carTypeId: String,nextPage: Int){
            this.mPosition = position
            this.mCarTypeId = carTypeId
            this.mNextPage = nextPage
        }
        override fun onClick(v: View?) {
            when(v?.id){
                R.id.more_ll -> {
                    mOnMyItemListener?.onMoreSites(mPosition,mCarTypeId,mNextPage)
                }
            }
        }
        override fun onSiteMap(siteId: String?) {
            mOnMyItemListener?.onSiteMap(siteId)
        }

        override fun onBook( siteId: String?) {
            mOnMyItemListener?.onBook(mCarTypeId,siteId)
        }

    }

    private var mOnMyItemListener: OnMyItemListener? = null

    interface OnMyItemListener{
        fun onMoreSites(position: Int,carTypeId: String?,nextPage: Int)
        fun onSiteMap(siteId: String?)
        fun onBook(carTypeId: String?,siteId: String?)
    }

    fun setOnMyItemListener(onMyItemListener: OnMyItemListener?){
        this.mOnMyItemListener = onMyItemListener
    }
}