package com.jiaoyinbrother.monkeyking.adapter

import android.content.Context
import android.graphics.Color
import android.text.TextUtils
import android.view.View
import android.widget.ImageView
import android.widget.LinearLayout
import android.widget.RelativeLayout
import android.widget.TextView
import com.camnter.easyrecyclerview.adapter.EasyRecyclerViewAdapter
import com.camnter.easyrecyclerview.holder.EasyRecyclerViewHolder
import com.jiaoyinbrother.monkeyking.R
import com.jiaoyinbrother.monkeyking.view.RoundTextView
import com.jybrother.sineo.library.bean.ActivityBean
import com.jybrother.sineo.library.bean.SitesBean
import com.jybrother.sineo.library.util.LogUtil
import java.util.ArrayList

/**
 * Created by admin on 2018/3/27.
 */
class CarsSitesAdapter constructor(context: Context?): EasyRecyclerViewAdapter() {
    private var mContext: Context? = null
    init {
        mContext = context
    }
    override fun getRecycleViewItemType(position: Int): Int {
        return 0
    }
    override fun getItemLayouts(): IntArray {
        return intArrayOf(R.layout.cars_sites_item)
    }
    override fun onBindRecycleViewHolder(viewHolder: EasyRecyclerViewHolder?, position: Int) {
        val content_ll = viewHolder?.findViewById<LinearLayout>(R.id.content_ll)
        val site_name_tv = viewHolder?.findViewById<TextView>(R.id.site_name_tv)
        val car_price_tv = viewHolder?.findViewById<TextView>(R.id.car_price_tv)
        val site_tag_ll = viewHolder?.findViewById<LinearLayout>(R.id.site_tag_ll)
        val space_iv = viewHolder?.findViewById<ImageView>(R.id.space_iv)
        space_iv?.visibility = if(position == listSize-1) View.GONE else View.VISIBLE
        val activity_all_rl = viewHolder?.findViewById<RelativeLayout>(R.id.activity_all_rl)
        val activity_content_ll = viewHolder?.findViewById<LinearLayout>(R.id.activity_content_ll)
        val activity_btn_ll = viewHolder?.findViewById<LinearLayout>(R.id.activity_btn_ll)
        val activity_btn_tv = viewHolder?.findViewById<TextView>(R.id.activity_btn_tv)
        val activity_iv = viewHolder?.findViewById<ImageView>(R.id.activity_iv)

        val siteList = list as List<SitesBean>
        val sitesBean = siteList[position]

        site_name_tv?.text = sitesBean?.site_name?:""
        car_price_tv?.text = sitesBean?.prices?.avg.toString()
        setTags(sitesBean, site_tag_ll)
        setActivities(position,sitesBean, activity_all_rl, activity_btn_ll, activity_btn_tv, activity_content_ll,activity_iv)
        content_ll?.setOnClickListener(OnMyClickListener(sitesBean?.site_id))
        site_name_tv?.setOnClickListener(OnMyClickListener(sitesBean?.site_id))
    }

    private fun setActivities(position: Int,sitesBean: SitesBean, activity_all_rl: RelativeLayout?, activity_btn_ll: LinearLayout?, activity_btn_tv: TextView?, activity_content_ll: LinearLayout?,activity_iv: ImageView?) {
        val activities = sitesBean?.activities
        if (activities != null && activities.size > 0) {
            activity_all_rl?.visibility = View.VISIBLE
            if (activities.size > 1) {
                activity_btn_ll?.visibility = View.VISIBLE
                activity_btn_tv?.text = activities.size.toString() + "个活动"
            } else {
                activity_btn_ll?.visibility = View.GONE
            }
            activity_content_ll?.removeAllViews()
            for (i in activities.indices) {
                val activityBean = activities[i]
                if (activityBean != null) {
                    val activityChild = View.inflate(mContext, R.layout.item_activity, null)
                    val car_activity_icon = activityChild.findViewById(R.id.activityIcon) as RoundTextView
                    val car_activity_content = activityChild.findViewById(R.id.activityDesc) as TextView

                    car_activity_icon.setText(activityBean?.getTag())
                    if (!TextUtils.isEmpty(activityBean?.getTag_color())) {
                        try {
                            car_activity_icon.setTextColor(Color.parseColor(activityBean?.getTag_color()))
                            car_activity_icon.setBackColor(Color.parseColor(activityBean?.getTag_color()))
                        } catch (e: Exception) {
                            LogUtil.e(e.toString())
                        }

                    }
                    car_activity_content.setText(activityBean?.getDescription())
                    activity_content_ll?.addView(activityChild)
                }
            }
        } else {
            activity_all_rl?.visibility = View.GONE
        }
        if (activityPositions != null && activityPositions.contains(position)) {
            //展开
            for (i in 0 until activity_content_ll?.getChildCount()!!) {
                activity_content_ll?.getChildAt(i)?.setVisibility(View.VISIBLE)
            }
            sitesBean.isActivitiesExpanded = true
            activity_iv?.setImageDrawable(mContext?.getResources()?.getDrawable(R.mipmap.arrow_up_small))
        } else {
            //收起
            for (i in 0 until activity_content_ll?.getChildCount()!!) {
                if (i >= 1) {
                    activity_content_ll?.getChildAt(i).setVisibility(View.GONE)
                } else {
                    activity_content_ll?.getChildAt(i).setVisibility(View.VISIBLE)
                }
            }
            sitesBean.isActivitiesExpanded = false
            activity_iv?.setImageDrawable(mContext?.getResources()?.getDrawable(R.mipmap.arrow_down_small))
        }
        activity_btn_ll?.setOnClickListener(OnMyClickListener(position,sitesBean.isActivitiesExpanded))
    }


    private fun setTags(sitesBean: SitesBean, site_tag_ll: LinearLayout?) {
        val icon_tags = sitesBean.icon_tags
        if (icon_tags != null && icon_tags?.size > 0) {
            site_tag_ll?.setVisibility(View.VISIBLE)
            site_tag_ll?.removeAllViews()
            for (i in icon_tags?.indices) {
                val tag = icon_tags?.get(i)
                site_tag_ll?.addView(SiteAdapter.addViews(tag, mContext!!))
            }
        } else {
            site_tag_ll?.setVisibility(View.GONE)
        }
    }

    private val activityPositions = ArrayList<Int>()

    inner class OnMyClickListener : View.OnClickListener{
        private var mPosition = 0
        private var mIsExpanded = false
        private var mSiteId: String? = null
        constructor(position: Int,isExpanded: Boolean){
            this.mPosition = position
            this.mIsExpanded = isExpanded
        }
        constructor(siteId: String?){
            this.mSiteId = siteId
        }
        override fun onClick(v: View?) {
            when(v?.id){
                R.id.activity_btn_ll -> {
                    if (mIsExpanded){
                        if (activityPositions != null && activityPositions.contains(mPosition)) {
                            activityPositions.remove(Integer.valueOf(mPosition))
                        }
                    }else{
                        if (activityPositions != null && !activityPositions.contains(mPosition)) {
                            activityPositions.add(Integer.valueOf(mPosition))
                        }
                    }
                    notifyItemChanged(mPosition)
                }
                R.id.site_name_tv -> {
                    mOnSiteListener?.onSiteMap(mSiteId)
                }
                R.id.content_ll -> {
                    mOnSiteListener?.onBook(mSiteId)
                }
            }
        }

    }

    interface OnSiteListener {
        fun onSiteMap(siteId: String?)
        fun onBook(siteId: String?)
    }

    private var mOnSiteListener: OnSiteListener? = null

    fun setOnSiteListener(onSiteListener: OnSiteListener){
        this.mOnSiteListener = onSiteListener
    }
}