package com.jiaoyinbrother.monkeyking.adapter

import android.content.Context
import android.support.constraint.ConstraintLayout
import android.util.Log
import android.util.TypedValue
import android.view.View
import android.widget.ImageView
import android.widget.LinearLayout
import android.widget.TextView
import com.camnter.easyrecyclerview.adapter.EasyRecyclerViewAdapter
import com.camnter.easyrecyclerview.holder.EasyRecyclerViewHolder
import com.jiaoyinbrother.monkeyking.R
import com.jybrother.sineo.library.bean.CategoriesBean
import com.jybrother.sineo.library.bean.ConditionsBean

/**
 * Created by admin on 2018/3/27.
 */
class CarsSubtitleAdapter constructor(context: Context?) : EasyRecyclerViewAdapter() {

    private var mContext: Context? = null
    init {
        mContext = context
    }

    override fun getRecycleViewItemType(position: Int): Int {
        return 0;
    }
    override fun getItemLayouts(): IntArray {
        return intArrayOf(R.layout.cars_subtitle_item)
    }
    override fun onBindRecycleViewHolder(viewHolder: EasyRecyclerViewHolder?, position: Int) {
        val root_ll = viewHolder?.findViewById<LinearLayout>(R.id.root_ll)
        val icon_iv = viewHolder?.findViewById<ImageView>(R.id.icon_iv)
        val indicator_iv = viewHolder?.findViewById<ImageView>(R.id.indicator_iv)
        val name_tv = viewHolder?.findViewById<TextView>(R.id.name_tv)
        val price_tv = viewHolder?.findViewById<TextView>(R.id.price_tv)

        val categoriesList = list as List<CategoriesBean>
        val categoriesBean = categoriesList[position]
        name_tv?.text = categoriesBean?.name?:""
        price_tv?.text = categoriesBean?.price?:""

        if(categoriesBean?.hot == 1){
            icon_iv?.visibility = View.VISIBLE
            price_tv?.visibility = View.GONE
        }else{
            icon_iv?.visibility = View.GONE
            price_tv?.visibility = View.VISIBLE
        }
        if (position == mPosition){
            root_ll?.setBackgroundColor(mContext?.resources?.getColor(R.color.color_0)?:0)
            indicator_iv?.visibility = View.VISIBLE
            name_tv?.setTextSize(TypedValue.COMPLEX_UNIT_DIP,13f)
            icon_iv?.setImageResource(R.mipmap.hot_check)
        }else{
            root_ll?.setBackgroundColor(mContext?.resources?.getColor(R.color.color_1)?:0)
            indicator_iv?.visibility = View.GONE
            name_tv?.setTextSize(TypedValue.COMPLEX_UNIT_DIP,12f)
            icon_iv?.setImageResource(R.mipmap.hot_uncheck)
        }

        root_ll?.setOnClickListener(OnClickListener(position,categoriesBean))
    }

    private var mPosition = 0

    fun selectItem(position: Int?){
        mPosition = position?:0
        notifyDataSetChanged()
    }

    inner class OnClickListener: View.OnClickListener{

        private var categoriesBean: CategoriesBean? = null
        private var position = 0
        constructor(position: Int,categoriesBean: CategoriesBean){
            this.position = position
            this.categoriesBean = categoriesBean
        }
        override fun onClick(v: View?) {
            if (mPosition != position)
                onMyItemListener?.onItem(position,categoriesBean)
        }

    }

    private var onMyItemListener: OnMyItemListener? = null

    interface OnMyItemListener{
        fun onItem(position: Int,categoriesBean: CategoriesBean?)
    }

    fun setOnMyItemListener(onMyItemListener: OnMyItemListener){
        this.onMyItemListener = onMyItemListener
    }

}