package com.jiaoyinbrother.monkeyking.adapter

import android.app.Activity
import android.content.Context
import android.view.View
import android.widget.*
import com.camnter.easyrecyclerview.adapter.EasyRecyclerViewAdapter
import com.camnter.easyrecyclerview.holder.EasyRecyclerViewHolder
import com.facebook.drawee.view.SimpleDraweeView
import com.jiaoyinbrother.monkeyking.R
import com.jybrother.sineo.library.util.DensityUtil
import com.facebook.drawee.backends.pipeline.Fresco
import com.jybrother.sineo.library.bean.PicBean
import com.jybrother.sineo.library.bean.TakingPicBean
import com.jybrother.sineo.library.util.LogUtil
import kotlin.collections.ArrayList


/**
 * by Soda on 2018/1/22.
 */
class TakingPicAdapter(val context: Context) : EasyRecyclerViewAdapter() {

    private var selectPos: Int? = null
    private var viewWidth = 0
    private var viewHeight = 0
//    private var picList = ArrayList<PicBean>()


    override fun getItemLayouts(): IntArray {
        viewWidth = ((context as Activity).windowManager.defaultDisplay.width - DensityUtil.dip2px(context, 40f)) / 2
        viewHeight = viewWidth / 3 * 2
        return intArrayOf(R.layout.item_taking_pictures)
    }

    override fun getRecycleViewItemType(position: Int): Int {
        return 0
    }

    override fun onBindRecycleViewHolder(holder: EasyRecyclerViewHolder?, position: Int) {
        // 父布局宽高
        val mainLayout = holder?.findViewById<RelativeLayout>(R.id.relativeLayout)
        mainLayout?.layoutParams = LinearLayout.LayoutParams(viewWidth, viewHeight)
        // pic View
        val picView = holder?.findViewById<SimpleDraweeView>(R.id.img)
        picView?.layoutParams = RelativeLayout.LayoutParams(viewWidth, viewHeight)

        val loadingLayout = holder?.findViewById<LinearLayout>(R.id.loading_Layout)
        val loadingStatus = holder?.findViewById<TextView>(R.id.loading_status)
        val loadingProgress = holder?.findViewById<ProgressBar>(R.id.loading_progress)
        val loadingFail = holder?.findViewById<ImageView>(R.id.loading_fail)
        // item 展示
        val picBean = list[position] as PicBean

        LogUtil.e("onBindRecycleViewHolder")
        LogUtil.e("position=" + position)
        LogUtil.e("picBean=" + picBean.toString())

        if (picBean.picUri != null) {
            if (selectPos == position) {
                // 清除Fresco对这条验证码的缓存
                val imagePipeline = Fresco.getImagePipeline()
                imagePipeline.evictFromMemoryCache(picBean.picUri)
                imagePipeline.evictFromDiskCache(picBean.picUri)
                // combines above two lines
                imagePipeline.evictFromCache(picBean.picUri)
                picView?.setImageURI(picBean.picUri)
            }
            LogUtil.e("loading finish -------------------------------------")
            // post loading
            when (picBean.status) {
                TakingPicBean.PIC_DEF -> {
                    loadingLayout?.visibility = View.GONE
                }
                TakingPicBean.PIC_SUCC -> {
                    loadingLayout?.visibility = View.GONE
                }
                TakingPicBean.PIC_WAIT -> {
                    loadingLayout?.visibility = View.VISIBLE
                    loadingStatus?.text = "上传中…"
                    loadingProgress?.visibility = View.VISIBLE
                    loadingFail?.visibility = View.GONE
                }
                TakingPicBean.PIC_FAIL -> {
                    loadingLayout?.visibility = View.VISIBLE
                    loadingStatus?.text = "上传失败,重新上传"
                    loadingProgress?.visibility = View.GONE
                    loadingFail?.visibility = View.VISIBLE
                }
            }
            LogUtil.e("loading finish -------------------------------------")
        } else {
            LogUtil.e("url start -------------------------------------")
            if (picBean.url != null) {
                picView?.setImageURI(picBean.url)
            } else {
                val resource = when (position) {
                    0 -> R.mipmap.bg_pic_0
                    1 -> R.mipmap.bg_pic_1
                    2 -> R.mipmap.bg_pic_2
                    else -> R.mipmap.bg_pic_3
                }
                picView?.setImageResource(resource)
            }
            LogUtil.e("url finish -------------------------------------")
        }
        LogUtil.e("onBindRecycleViewHolder finish -------------------------------------")
    }

    fun upLoadPicUri(position: Int, list: ArrayList<PicBean>) {
        this.list = list
        selectPos = position
        notifyDataSetChanged()
    }
}