package com.jiaoyinbrother.monkeyking.fragment

import android.os.Bundle
import android.support.v4.content.ContextCompat
import android.view.View
import com.jiaoyinbrother.monkeyking.R
import com.jybrother.sineo.library.base.BaseFragment
import com.jybrother.sineo.library.bean.DepositBean
import com.jybrother.sineo.library.bean.OrderDetailResult
import com.jybrother.sineo.library.util.ConstantsUtil
import com.jybrother.sineo.library.util.LogUtil
import com.jybrother.sineo.library.util.TextUtil
import com.jybrother.sineo.library.util.Util
import kotlinx.android.synthetic.main.fragment_deposit.*

/**
 * by Soda on 2018/1/25.
 */
class DepositFragment : BaseFragment() {

    private var listener: DepositListener? = null
    private var flag: String? = null
    private var mOrderResult: OrderDetailResult? = null

    override fun getLayoutId(): Int {
        val bundle = arguments
        flag = bundle.getString("fromFlag") ?: ""
        mOrderResult = bundle.getSerializable(ConstantsUtil.ORDER_RESULT) as OrderDetailResult
        LogUtil.e("flag -- $flag ; OrderDetail -- $mOrderResult")
        return R.layout.fragment_deposit
    }

    override fun initViews(view: View?, savedInstanceState: Bundle?) {

    }

    override fun initToolbar(savedInstanceState: Bundle?) {
    }

    override fun initListeners() {
    }

    override fun initData() {
        showDeposit(mOrderResult)
    }

    private fun showDeposit(result: OrderDetailResult?) {
        if (result == null)
            return
        try {
            carImg.setImageURI(result.pic)
            val depositBean = Util.getDepositBean(result, ConstantsUtil.PAY_PROJECT_ILLEGAL)
            val sp = depositBean.type_name + "¥" + depositBean.amount.toInt()
            val sIndex = sp.length - (depositBean.amount.toInt().toString().length + 1)
            depositAmount.text = TextUtil.setForegroundColor(sp, ContextCompat.getColor(activity, R.color.color_6), sIndex, sp.length)
            depositDesc.text = depositBean.type_description
            depositPrompt.text = depositBean.description
            if (depositBean.enabled == 1 && depositBean.status_code != DepositBean.DEPOSIT_PAYED) {
                // 可以支付
                listener?.onPay()
            }
        } catch (e: Exception) {

        }
    }


    fun setData(result: OrderDetailResult?) {
        this.mOrderResult = result
        showDeposit(result)
    }

    fun setListener(listener: DepositListener) {
        this.listener = listener
    }

    interface DepositListener {
        fun onPay()
    }
}