package com.jiaoyinbrother.monkeyking.fragment

import android.content.Intent
import android.os.Bundle
import android.text.TextUtils
import android.view.View
import com.jiaoyinbrother.monkeyking.CarEntity
import com.jiaoyinbrother.monkeyking.Constants

import com.jiaoyinbrother.monkeyking.R
import com.jiaoyinbrother.monkeyking.activity.*
import com.jiaoyinbrother.monkeyking.util.SharedPreferencesUtil
import com.jybrother.sineo.library.adapter.MyFragmentAdapter
import com.jybrother.sineo.library.base.BaseFragment
import com.jybrother.sineo.library.bean.OrderDetailRequest
import com.jybrother.sineo.library.bean.OrderDetailResult
import com.jybrother.sineo.library.bean.OrdersBean
import com.jybrother.sineo.library.presenter.OrderPresenterImpl
import com.jybrother.sineo.library.util.ConstantsUtil
import com.jybrother.sineo.library.util.LogUtil
import com.jybrother.sineo.library.util.StatisticsUtil
import com.jybrother.sineo.library.view.GeneralViewInterface
import com.jybrother.sineo.library.widget.OrderListSortView
import kotlinx.android.synthetic.main.fragment_orders.*

/**
 * by Soda on 2018/3/27.
 */
class OrderManageFragment : BaseFragment(), View.OnClickListener {

    private var userRoles = -1// 0：用户、 1:车管
    private var mAdapter: MyFragmentAdapter? = null
    private var isRenewalFlag = false
    // user
    private var userGoingFm: OrderListFragment? = null
    private var userHistoryFm: OrderListFragment? = null
    // manager
    private var mgrHandoverFm: OrderListFragment? = null
    private var mgrGoingFm: OrderListFragment? = null
    private var mgrSettledFm: OrderListFragment? = null
    private var mgrCompletedFm: OrderListFragment? = null
    private var mgrCancelFm: OrderListFragment? = null


    override fun getLayoutId(): Int {
        return R.layout.fragment_orders
    }

    override fun initViews(view: View?, savedInstanceState: Bundle?) {}

    override fun initToolbar(savedInstanceState: Bundle?) {}

    override fun initListeners() {
        // 订单搜索
        searchOrder.setOnClickListener(this)
        // 车管
        mgrHandoverRb.setOnClickListener(this)
        mgrGoingRb.setOnClickListener(this)
        mgrSettledRb.setOnClickListener(this)
        mgrCompletedRb.setOnClickListener(this)
        mgrCancelRb.setOnClickListener(this)
        // 用户
        userGoingRb.setOnClickListener(this)
        userHistoryRb.setOnClickListener(this)
        // 排序
        orderSortView.setListener(object : OrderListSortView.OrderSortListener {
            override fun onDefault(sort: Int) {
                onSortOrder(sort, false)
            }

            override fun onTakeCar(sort: Int, isASC: Boolean) {
                onSortOrder(sort, isASC)
            }

            override fun onReturnCar(sort: Int, isASC: Boolean) {
                onSortOrder(sort, isASC)
            }
        })
        // item click listener
        mgrHandoverFm?.onItemViewClick(onItemViewListener)
        mgrGoingFm?.onItemViewClick(onItemViewListener)
        mgrSettledFm?.onItemViewClick(onItemViewListener)
        mgrCompletedFm?.onItemViewClick(onItemViewListener)
        mgrCancelFm?.onItemViewClick(onItemViewListener)
        userGoingFm?.onItemViewClick(onItemViewListener)
        userHistoryFm?.onItemViewClick(onItemViewListener)
    }

    override fun initData() {
        orderViewPage.offscreenPageLimit = 7
        mAdapter = MyFragmentAdapter(childFragmentManager)
        // 车管端：待交车
        mgrHandoverFm = OrderListFragment()
        val mgrHandover = Bundle()
        mgrHandover.putInt("ORDER_STATUS", OrderListFragment.STATUS_MANAGER_HANDOVER)
        mgrHandoverFm?.arguments = mgrHandover
        // 车管端：进行中
        mgrGoingFm = OrderListFragment()
        val mgrGoing = Bundle()
        mgrGoing.putInt("ORDER_STATUS", OrderListFragment.STATUS_MANAGER_GOING)
        mgrGoingFm?.arguments = mgrGoing
        // 车管端：待结算
        mgrSettledFm = OrderListFragment()
        val mgrSettled = Bundle()
        mgrSettled.putInt("ORDER_STATUS", OrderListFragment.STATUS_MANAGER_SETTLED)
        mgrSettledFm?.arguments = mgrSettled
        // 车管端：已完成
        mgrCompletedFm = OrderListFragment()
        val mgrCompleted = Bundle()
        mgrCompleted.putInt("ORDER_STATUS", OrderListFragment.STATUS_MANAGER_COMPLETE)
        mgrCompletedFm?.arguments = mgrCompleted
        // 车管端：已取消
        mgrCancelFm = OrderListFragment()
        val mgrCancel = Bundle()
        mgrCancel.putInt("ORDER_STATUS", OrderListFragment.STATUS_MANAGER_CANCEL)
        mgrCancelFm?.arguments = mgrCancel
        // 用户端：进行中
        userGoingFm = OrderListFragment()
        val userGoing = Bundle()
        userGoing.putInt("ORDER_STATUS", OrderListFragment.STATUS_USER_GOING)
        userGoingFm?.arguments = userGoing
        // 用户端：历史订单
        userHistoryFm = OrderListFragment()
        val userHistory = Bundle()
        userHistory.putInt("ORDER_STATUS", OrderListFragment.STATUS_USER_HISTORY)
        userHistoryFm?.arguments = userHistory

        mAdapter?.addFragment(mgrHandoverFm)
        mAdapter?.addFragment(mgrGoingFm)
        mAdapter?.addFragment(mgrSettledFm)
        mAdapter?.addFragment(mgrCompletedFm)
        mAdapter?.addFragment(mgrCancelFm)
        mAdapter?.addFragment(userGoingFm)
        mAdapter?.addFragment(userHistoryFm)
        orderViewPage.adapter = mAdapter
//        initFragmentUI()
    }

    override fun onResume() {
        super.onResume()
        if (userRoles == SharedPreferencesUtil.getInstance().role)
            return
        userRoles = SharedPreferencesUtil.getInstance().role
        LogUtil.e("init ---------------------------------------------------------------------")
        if (userRoles == 0) {
            userBar.visibility = View.VISIBLE
            managerBar.visibility = View.GONE
            searchOrder.visibility = View.GONE
            userGoingRb.isChecked = true
            orderViewPage.currentItem = 5
        } else {
            userBar.visibility = View.GONE
            managerBar.visibility = View.VISIBLE
            searchOrder.visibility = View.VISIBLE
            mgrHandoverRb.isChecked = true
            orderViewPage.currentItem = 0
        }
    }
//
//    fun initFragmentUI() {
//
//    }

    override fun onClick(v: View?) {
        when (v?.id) {
        // 车管
            R.id.mgrHandoverRb -> orderViewPage.currentItem = 0
            R.id.mgrGoingRb -> orderViewPage.currentItem = 1
            R.id.mgrSettledRb -> orderViewPage.currentItem = 2
            R.id.mgrCompletedRb -> orderViewPage.currentItem = 3
            R.id.mgrCancelRb -> orderViewPage.currentItem = 4
        // 用户
            R.id.userGoingRb -> orderViewPage.currentItem = 5
            R.id.userHistoryRb -> orderViewPage.currentItem = 6
        // 订单查询
            R.id.searchOrder -> startActivity(OrderSearchActivity::class.java)
        }
    }

    fun onPostOrder() {
        //TODO 第一次点击的时候刷新接口，之后不再刷新
        if (userRoles == 0) {
            userGoingFm?.onPostOrders()
            userHistoryFm?.onPostOrders()
        } else {
            mgrHandoverFm?.onPostOrders()
            mgrGoingFm?.onPostOrders()
            mgrSettledFm?.onPostOrders()
            mgrCompletedFm?.onPostOrders()
            mgrCancelFm?.onPostOrders()
        }
    }

    fun onSortOrder(sortType: Int, isASC: Boolean) {
        mgrHandoverFm?.onSort(sortType, isASC)
        mgrGoingFm?.onSort(sortType, isASC)
        mgrSettledFm?.onSort(sortType, isASC)
        mgrCompletedFm?.onSort(sortType, isASC)
        mgrCancelFm?.onSort(sortType, isASC)
        onPostOrder()
    }

    private val onItemViewListener = object : OrderListFragment.OrderItemViewListener {
        override fun onItemClick(order: OrdersBean?) {
            if (!TextUtils.isEmpty(order?.orderid)) {
                val intent = Intent(activity, OrderDetailActivity::class.java)
                intent.putExtra(ConstantsUtil.ORDER_ID, order?.orderid)
                startActivityForResult(intent, Constants.ORDER_DETAIL_CODE)
            }
        }

        override fun onSmallOne(order: OrdersBean?, position: Int) {
            isRenewalFlag = true
            getOrderDetail(order)
        }

        override fun onSmallTwo(order: OrdersBean?, position: Int) {
            isRenewalFlag = false
            getOrderDetail(order)
        }

        override fun onBigThree(order: OrdersBean?, position: Int) {
            bigThreeEvent(order)
        }
    }

    private fun getOrderDetail(order: OrdersBean?) {
        val presenter = OrderPresenterImpl(activity, OrderDetailResult::class.java)
        presenter.addListener(orderDetailModel)
        val request = OrderDetailRequest()
        request.uid = SharedPreferencesUtil.getInstance().uid
        request.orderid = order?.orderid
        presenter.getOrderDetail(request)
    }

    private val orderDetailModel = object : GeneralViewInterface {
        override fun getCodeBeanFail(errorCode: Int) {
        }

        override fun getCodeObjectSuccess(bean: Any) {
            val result = bean as OrderDetailResult
            when (result.code) {
                CarEntity.SUCC -> {
                    handingOrderDetailEvent(result)
                }
                else -> showToast(result.msg)
            }
        }
    }

    private fun handingOrderDetailEvent(result: OrderDetailResult) {
        if (TextUtils.isEmpty(result.orderid)) {
            showToast("订单异常，请咨询客服处理")
            return
        }
        when (result.status) {
            OrdersBean.ORDER_STATUS_1 -> {// 已接受
                // 预付租金
                StatisticsUtil.onEvent(activity, ConstantsUtil.ORDER_LIST_PREPAY, ConstantsUtil.ORDER_LIST_PREPAY)
                onPayDeposit(result, ConstantsUtil.PAY_PROJECT_RENT)
            }
            OrdersBean.ORDER_STATUS_3 -> {// 已支付车辆押金
                onPayDeposit(result, ConstantsUtil.PAY_PROJECT_ILLEGAL)
            }
            OrdersBean.ORDER_STATUS_5 -> {// 用车中
                if (result.bill == null) {
                    showToast("订单异常，请咨询客服处理")
                    return
                }
                if (isRenewalFlag) {
                    // 续租
                    StatisticsUtil.onEvent(activity, ConstantsUtil.ORDER_LIST_RENEW, ConstantsUtil.ORDER_LIST_RENEW)
                    val intent = Intent(activity, ReletActivity::class.java)
                    intent.putExtra(ConstantsUtil.ORDER_RESULT, result)
                    startActivityForResult(intent, Constants.RELET_CODE)
                } else {
                    // 提前还车
                    StatisticsUtil.onEvent(activity, ConstantsUtil.ORDER_LIST_RETURN_CAR, ConstantsUtil.ORDER_LIST_RETURN_CAR)
                    val intent = Intent(activity, AdvanceBackActivity::class.java)
                    intent.putExtra(ConstantsUtil.ORDER_RESULT, result)
                    startActivityForResult(intent, Constants.ADVANCE_CODE)
                }
            }
            OrdersBean.ORDER_STATUS_6 -> {
                val intent = Intent(activity, SettlementForRenterActivity::class.java)
                intent.putExtra("Flag", "确认结算")
                intent.putExtra("order_detail", result)
                startActivityForResult(intent, Constants.CLOSE_ACCT_CODE)
            }
        }
    }

    private fun onPayDeposit(result: OrderDetailResult, mType: String) {
        val intent = Intent(activity, CashierDeskActivity::class.java)
        intent.putExtra(ConstantsUtil.BUNDLE_EXTRA_KEY, mType)
        intent.putExtra(ConstantsUtil.ORDER_RESULT, result)
        startActivityForResult(intent, ConstantsUtil.PAYMENT_RESULT)
    }

    private fun bigThreeEvent(order: OrdersBean?) {
        if (order?.status ?: 0 in 7..10) run {
            val intent = Intent(activity, EvaluateActivity::class.java)
            intent.putExtra(CarEntity.ORDER_OWNER_KEY, CarEntity.ORDER_RENTER)
            intent.putExtra(ConstantsUtil.ORDER_ID, order?.orderid)
            intent.putExtra(CarEntity.CMMT_SINGLE_ID, order?.ownerid)
            intent.putExtra("CAR_ID", order?.carid)
            startActivityForResult(intent, Constants.COMMENT_SINGLE_CODE)
        }
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        onPostOrder()
    }
}
