package com.jiaoyinbrother.monkeyking.fragment

import android.content.Context
import android.content.Intent
import android.graphics.drawable.Drawable
import android.os.Bundle
import android.support.v7.widget.LinearLayoutManager
import android.text.TextUtils
import android.view.Gravity
import android.view.View
import android.view.ViewGroup
import android.view.WindowManager
import android.widget.LinearLayout
import android.widget.ScrollView
import android.widget.TextView
import com.camnter.easyrecyclerview.adapter.EasyRecyclerViewAdapter
import com.camnter.easyrecyclerview.holder.EasyRecyclerViewHolder
import com.jiaoyinbrother.monkeyking.CarEntity
import com.jiaoyinbrother.monkeyking.Constants
import com.jiaoyinbrother.monkeyking.R
import com.jiaoyinbrother.monkeyking.activity.*
import com.jiaoyinbrother.monkeyking.activity.CouponsManageActivity
import com.jiaoyinbrother.monkeyking.bean.UnreadMessages
import com.jiaoyinbrother.monkeyking.bean.UserDetailResult
import com.jiaoyinbrother.monkeyking.jpush.MKPushUtil
import com.jiaoyinbrother.monkeyking.util.AuthUtil
import com.jiaoyinbrother.monkeyking.util.SharedPreferencesUtil
import com.jiaoyinbrother.monkeyking.util.Util
import com.jiaoyinbrother.monkeyking.view.NotifyingScrollView
import com.jybrother.sineo.library.base.BaseFragment
import com.jybrother.sineo.library.bean.AccountResult
import com.jybrother.sineo.library.bean.UserDetailRequestBean
import com.jybrother.sineo.library.presenter.UserDetailPresenterImpl
import com.jybrother.sineo.library.util.*
import com.jybrother.sineo.library.view.GeneralViewInterface
import kotlinx.android.synthetic.main.fragment_rental_my.*
import kotlinx.android.synthetic.main.fragment_rental_my_refreshview.*
import java.util.*

/**
 * Created by Administrator on 2018/3/26.
 */


class RentalMyFragment : BaseFragment(), View.OnClickListener, EasyRecyclerViewHolder.OnItemClickListener {

//    private val LOGIN_REQUEST_CODE = 100
    private var mMonkeyMainTitleDrawable: Drawable? = null

    private val ITEM_BALANCE = 0
    private val ITEM_WUKONG_COIN = 1
    private val ITEM_COUPON = 2
    private val ITEM_POINT = 3  //积分

    private lateinit var mWalletAdapter: WalletAdapter
    private var mUserDetailPresenter: UserDetailPresenterImpl? = null
    private var userDetailResult: UserDetailResult? = null

    override fun getLayoutId(): Int {
        return R.layout.fragment_rental_my_refreshview
    }

    override fun initViews(view: View?, savedInstanceState: Bundle?) {


    }

    override fun initToolbar(savedInstanceState: Bundle?) {

    }


    override fun initData() {
//顶部渐变
        notify_scrollview.smoothScrollTo(0, 0);
        ivTitleContent.alpha = 0.0f
//        msg_indicator_imageview.alpha = 0.0f
        mMonkeyMainTitleDrawable = resources.getDrawable(R.color.color_rental_my_title_background)
        mMonkeyMainTitleDrawable?.alpha = 0
        title.setBackgroundDrawable(mMonkeyMainTitleDrawable)


        val manager = object : LinearLayoutManager(mActivity) {
            override fun canScrollHorizontally(): Boolean {
                return false
            }
        }
        manager.orientation = LinearLayoutManager.HORIZONTAL
        recyclerview_wallet.layoutManager = manager
        mWalletAdapter = WalletAdapter(mActivity)
//
        val list = Arrays.asList("账户余额", "悟空币", "优惠券", "可用积分")
        mWalletAdapter.list = list;
        recyclerview_wallet.adapter = mWalletAdapter;

//        无消息
        refreshMsgImg(false)

        mUserDetailPresenter = UserDetailPresenterImpl(this.context, UserDetailResult::class.java)
        mUserDetailPresenter?.addListener(object : GeneralViewInterface {
            override fun getCodeBeanFail(errorCode: Int) {
                dismissLoadingDialog()
                showErrorToast(errorCode)
//                不刷新，则为null
                updateView()
            }

            override fun getCodeObjectSuccess(bean: Any) {
                dismissLoadingDialog()
                getUserDetailSuccess(bean as UserDetailResult)
            }
        })
        refreshUserDetail()
    }

    private fun updateView() {
        val spUtil = SharedPreferencesUtil.getInstance()
        if (spUtil.isLogin && userDetailResult != null) {
            updateLoginView(userDetailResult)
        } else {
            updateLogoutView()
        }
    }


    override fun initListeners() {
        mWalletAdapter.setOnItemClickListener(this);

        imageview_head.setOnClickListener(this)
        textview_level_update.setOnClickListener(this)
        textview_user_status.setOnClickListener(this)
        relativelayout_invite.setOnClickListener(this)
        relativelayout_setting.setOnClickListener(this)
        relativelayout_feedback.setOnClickListener(this)
        msg_indicator_imageview.setOnClickListener(this)
        textview_user_id.setOnClickListener(this)

        notify_scrollview.setOnScrollChangedListener(MyScrollListener())

    }


    override fun onClick(v: View?) {
        val bundle = Bundle()
        when (v?.id) {
            R.id.textview_user_id -> {
                StatisticsUtil.onEvent(this.context, ConstantsUtil.MINE_SETTINGS_OPEN_LOGIN,"")
                handlePersonInfo(bundle)
            }
            R.id.imageview_head -> {
                StatisticsUtil.onEvent(this.context, ConstantsUtil.MINE_SETTINGS_OPEN_LOGIN,"")
                handlePersonInfo(bundle)
            }
            R.id.textview_level_update -> {
                LogUtil.e("级别升级")
                bundle.putSerializable("mUdr", userDetailResult)
                onStartActivity(bundle, LevelUpgradeActivity::class.java)
            }
            R.id.textview_user_status -> {
                StatisticsUtil.onEvent(this.context, ConstantsUtil.MINE_SETTINGS_OPEN_AUTH,"")
                LogUtil.e("实名认证")
                val spUtil = SharedPreferencesUtil.getInstance()

                if (spUtil.userAuth == AuthUtil.USER_NOAUTH) {
                    onStartActivity(bundle, IdentificationActivity::class.java)
                } else {
                    bundle.putInt("userStatus", spUtil.userAuth)
                    bundle.putString(CarEntity.EXTRA_BUNDLE_KEY, CertificationResultActivity.TENANT)
                    bundle.putString(CertificationResultActivity.TENANT, "实名认证")
                    onStartActivity(bundle, CertificationResultActivity::class.java)
                }
            }
            R.id.relativelayout_invite -> {
                LogUtil.e("邀请朋友")
                onStartActivity(bundle, InviteFriendActivity::class.java)
            }
            R.id.relativelayout_feedback -> {
                LogUtil.e("反馈")
                StatisticsUtil.onEvent(this.context, ConstantsUtil.MINE_SETTINGS_FEEDBACK,"")
                onStartActivity(bundle, FeedbackActivity::class.java)
            }
            R.id.relativelayout_setting -> {
                onStartActivityForResult(bundle, SettingsActivity::class.java)
            }
            R.id.msg_indicator_imageview -> {
                if (userDetailResult == null)
                    bundle.putSerializable("Unread_Message", ArrayList<UnreadMessages>())
                else
                    bundle.putSerializable("Unread_Message", userDetailResult?.unread_messages)
                onStartActivity(bundle, MessageManageActivity::class.java)
            }

        }

    }

    private fun handlePersonInfo(bundle: Bundle) {
        LogUtil.e("个人信息")
        bundle.putSerializable("PersonInfo", userDetailResult)
        onStartActivity(bundle, PersonalInfoActivity::class.java)
    }

    override fun onItemClick(convertView: View?, position: Int) {
        val bundle = Bundle()
        when (position) {
            ITEM_BALANCE -> {
                /* 账户详情 */
                LogUtil.e("余额")
                onStartActivity(bundle, AccountDetailActivity::class.java)
            }
            ITEM_WUKONG_COIN -> {
                /* 悟空币 */
                LogUtil.e("悟空币")
                if(userDetailResult!=null){
                    bundle.putString("wkcoin", userDetailResult?.account?.wkcoin.toString())
                    if(userDetailResult?.account?.wkcoin_transfer !=null)
                        bundle.putInt("wkcoin_transfer", userDetailResult?.account?.wkcoin_transfer!!)
                }
                onStartActivity(bundle, MyWookongCoinActivity::class.java)
            }
            ITEM_COUPON -> {
                /* 优惠券 */
                LogUtil.e("优惠券")
                onStartActivity(bundle, CouponsManageActivity::class.java)
            }
            ITEM_POINT -> {
                /* 积分 */
                onStartActivity(bundle, MyIntergralActivity::class.java)
            }
        }
    }

    override fun onResume() {
        super.onResume()
//        val sharePreferenceTools = SharePreferenceTools(this.context)
//        if(sharePreferenceTools.getBoolean(SharePreferenceTools.NEED_REFRESH_USER_DETAIL)){
//            refreshUserDetail()
//            sharePreferenceTools.putBoolean(SharePreferenceTools.NEED_REFRESH_USER_DETAIL,false)
//        }

//        后台直接修改数据，只能在onresume刷新
        refreshUserDetail()

    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        LogUtil.e("RentalMyFragment onActivityResult");
        if (requestCode == Constants.LOGIN_RESULT
                ||resultCode == SettingsActivity.LOGOUT_OK) {
//            TODO
//            refreshUserDetail()
        }
    }


    private inner class MyScrollListener : NotifyingScrollView.OnScrollChangedListener {

        override fun onScrollChanged(who: ScrollView, l: Int, t: Int, oldl: Int, oldt: Int) {

            var headerHeight = (rental_my_banner.height - title.height)/3
            val ratio = Math.min(Math.max(t, 0), headerHeight).toFloat() / headerHeight
            val newAlpha = ratio * 255
            mMonkeyMainTitleDrawable?.alpha = newAlpha.toInt()

            ivTitleContent.visibility = View.VISIBLE
            msg_indicator_imageview.alpha = 1 - ratio
            ivTitleContent.alpha = ratio
        }
    }


    private fun getUserDetailSuccess(result: UserDetailResult) {
        if (result.errCode == -1) {
            if (result.code == CarEntity.SUCC) {
                userDetailResult = result
                updateSharePrefAndJPush(result)
                updateLoginView(result)
            } else {
                OldToastUtil.show(this.context, result.msg)
            }
        } else {
            OldToastUtil.showerror(this.context, result.errCode)
        }
    }

    private fun updateSharePrefAndJPush(result: UserDetailResult) {
        val spu = SharedPreferencesUtil.getInstance()
        val spTools = SharePreferenceTools(this.context)

        spTools.putString(SharePreferenceTools.USER_DETAIL, SharePreferenceTools.entityToJson(result))
        Util.saveUserInfo(result.name, result.uid, result.id_no)
        if (!TextUtils.isEmpty(result.name)) {
            if (!TextUtils.isEmpty(spu.name)) {// 姓名
                spu.name = result.name
            }
        }
        if (!TextUtils.isEmpty(result.birthday)) {
            spu.setString(SharedPreferencesUtil.BIRTH_KEY, result.birthday)
        }
        if (!TextUtils.isEmpty(result.gender)) {
            spu.setString(SharedPreferencesUtil.GENDER_KEY, result.gender)
        }
        if (!TextUtils.isEmpty(result.uid)) {
            if (!TextUtils.isEmpty(spu.uid)) {// 手机号
                spu.uid = result.uid
            }
        }
        if (!TextUtils.isEmpty(result.rolename)) {
            if (!TextUtils.isEmpty(spu.roleName)) {
                spu.roleName = result.rolename
            }
        }
        if (result.role >= 0) {
            spu.saveRole(result.role)
        }
        AuthUtil.setAuthStatus(result.auth)// 用户认证状态
        if (!TextUtils.isEmpty(result.headimg_url)) {
            Util.saveHeadImage(result.headimg_url)
        } else {
        }
        MKPushUtil.updateJPush(this.context)// Jpush
    }


    private fun updateLoginView(result: UserDetailResult?) {
        if (result == null)
            return

        val spUtil = SharedPreferencesUtil.getInstance()
        val head_img_url = SharedPreferencesUtil.getInstance()
                .getString("head_img" + SharedPreferencesUtil.getInstance().uid)

        imageview_head.setImageURI(head_img_url)
        textview_level_name.text = spUtil.roleName
        textview_level_name.visibility = View.VISIBLE
        textview_level_update.visibility = View.VISIBLE
        if (!TextUtils.isEmpty(spUtil.name))
            textview_user_id.text = spUtil.name
        else
            textview_user_id.text = spUtil.uid

        AuthUtil.resetUserStatus(textview_user_status, spUtil.userAuth, this.context)
        when (spUtil.role) {
            1 -> {
                relativelayout_invite.visibility = View.VISIBLE
            }
            else -> {
                relativelayout_invite.visibility = View.GONE
            }
        }

        if(result?.account!=null)
            mWalletAdapter.setAccount(result?.account)

        checkMsg(result)
    }


    private fun updateLogoutView() {
        userDetailResult = null

        imageview_head.setImageResource(R.mipmap.icon_default_head)
        textview_level_name.visibility = View.INVISIBLE

        textview_level_update.visibility = View.INVISIBLE

        textview_user_id.text = "登录 | 注册"
        textview_user_status.text = ""


        relativelayout_invite.visibility = View.GONE
        refreshMsgImg(false)

        var account = AccountResult()
        account.total_amount = 0f
        account.wkcoin = 0
        account.coupon = 0
        account.jf = 0
        mWalletAdapter.setAccount(account)
    }


    private fun checkMsg(result: UserDetailResult?) {
        if (result != null) {
            val isHasNew = result.unread_messages != null && result.unread_messages.size > 0
            refreshMsgImg(isHasNew)
        }
    }

    /**
     * 消息按钮变换状态
     */
    private fun refreshMsgImg(isHasNewMessage: Boolean) {
        if (isHasNewMessage) {
            msg_indicator_imageview.setBackgroundResource(R.mipmap.icon_have_msg)
        } else {
            msg_indicator_imageview.setBackgroundResource(R.mipmap.icon_no_msg)
        }
    }

    private fun onStartActivity(data: Bundle?, cls: Class<*>) {
        var intent: Intent?
        val spUtil = SharedPreferencesUtil.getInstance()
        if (spUtil.isLogin) {
            intent = Intent(this.context, cls)
            if (data != null)
                intent.putExtras(data)
            startActivity(intent)
        } else {
            intent = Intent(this.context, LoginActivity::class.java)
            startActivityForResult(intent, Constants.LOGIN_RESULT)
        }
    }

    private fun onStartActivityForResult(data: Bundle?, cls: Class<*>) {
        var intent: Intent?
        val spUtil = SharedPreferencesUtil.getInstance()
        if (spUtil.isLogin) {
            intent = Intent(this.context, cls)
            if (data != null)
                intent.putExtras(data)
            startActivityForResult(intent, Constants.LOGOUT_REQUEST)
        } else {
            intent = Intent(this.context, LoginActivity::class.java)
            startActivityForResult(intent, Constants.LOGIN_RESULT)
        }
    }


    private fun refreshUserDetail() {
        val spUtil = SharedPreferencesUtil.getInstance()

        if (spUtil.isLogin) {
            val token = spUtil.getString(SharedPreferencesUtil.UID_KEY, "")
            LogUtil.e(token)
            val tokenBean = UserDetailRequestBean()
            tokenBean.uid = token
            showLoadingDialog()
            mUserDetailPresenter?.getUserDetail(tokenBean)
        } else {
            updateView()
        }

    }

    //钱包adapter
    inner class WalletAdapter(val context: Context) : EasyRecyclerViewAdapter() {
        private var mScreenWidth = 0
        private var account: AccountResult? = null

        override fun getItemLayouts(): IntArray {
            val wm = context.getSystemService(Context.WINDOW_SERVICE) as WindowManager
            mScreenWidth = wm.defaultDisplay.width

            return intArrayOf(R.layout.item_wallet)
        }

        override fun getRecycleViewItemType(position: Int): Int {
            return 0
        }

        override fun onBindRecycleViewHolder(viewHolder: EasyRecyclerViewHolder?, position: Int) {
            val wallet_linear = viewHolder?.findViewById<LinearLayout>(R.id.wallet_linear)

            val width = (mScreenWidth - 2 * DensityUtil.dip2px(this.context, 10f)) / 4
            val layoutParams = LinearLayout.LayoutParams(width, ViewGroup.LayoutParams.WRAP_CONTENT)
            wallet_linear?.gravity = Gravity.CENTER
            wallet_linear?.layoutParams = layoutParams

            val mTitle = list[position] as String
            val tv_title = viewHolder?.findViewById<TextView>(R.id.tv_title)
            tv_title?.text = mTitle

            val tv_count = viewHolder?.findViewById<TextView>(R.id.tv_count)
            when (position) {
                ITEM_BALANCE -> tv_count?.text = account?.total_amount?.toInt().toString() + "元"
                ITEM_WUKONG_COIN -> tv_count?.text = account?.wkcoin.toString() + "个"
                ITEM_COUPON -> tv_count?.text = account?.coupon.toString() + "张"
                ITEM_POINT -> tv_count?.text = account?.jf.toString()
            }
        }

        fun setAccount(account: AccountResult) {
            this.account = account
            notifyDataSetChanged()
        }

    }
}
