package com.jiaoyinbrother.monkeyking.fragment

import android.content.Context
import android.content.Intent
import android.os.Bundle
import android.support.v7.widget.GridLayoutManager
import android.support.v7.widget.LinearLayoutManager
import android.support.v7.widget.RecyclerView
import android.text.Editable
import android.text.TextWatcher
import android.view.View
import android.view.inputmethod.InputMethodManager
import android.widget.LinearLayout
import com.baidu.mapapi.model.LatLng
import com.baidu.mapapi.search.core.PoiInfo
import com.baidu.mapapi.search.core.SearchResult
import com.baidu.mapapi.search.poi.*
import com.baidu.mapapi.utils.DistanceUtil
import com.baidu.mobstat.StatService
import com.camnter.easyrecyclerview.holder.EasyRecyclerViewHolder
import com.jiaoyinbrother.monkeyking.CarEntity
import com.jiaoyinbrother.monkeyking.R
import com.jiaoyinbrother.monkeyking.activity.ChangeCityActivity
import com.jiaoyinbrother.monkeyking.activity.SiteListActivity
import com.jiaoyinbrother.monkeyking.adapter.AreaAdapter
import com.jiaoyinbrother.monkeyking.adapter.SearchAddressAdapter
import com.jiaoyinbrother.monkeyking.adapter.SiteAdapter
import com.jiaoyinbrother.monkeyking.util.BaiDuUtil
import com.jiaoyinbrother.monkeyking.util.LocationUtil
import com.jiaoyinbrother.monkeyking.util.SharedPreferencesUtil
import com.jiaoyinbrother.monkeyking.util.Util
import com.jiaoyinbrother.monkeyking.view.ItemDecoration
import com.jybrother.sineo.library.base.BaseFragment
import com.jybrother.sineo.library.bean.SiteBean2
import com.jybrother.sineo.library.listeners.SiteCheckListener
import com.jybrother.sineo.library.util.ConstantsUtil
import com.jybrother.sineo.library.util.LogUtil
import com.jybrother.sineo.library.util.StatisticsUtil
import com.jybrother.sineo.library.widget.SimpleItemDecoration
import kotlinx.android.synthetic.main.fragment_site_list.*
import java.util.*
import kotlin.collections.ArrayList

/**
 * The Author : Soda
 * Created on 2018/01/05.
 */
class SiteListFragment : BaseFragment(), View.OnClickListener, EasyRecyclerViewHolder.OnItemClickListener, SiteCheckListener {

    private var spUtil = SharedPreferencesUtil.getInstance()
    private var isMoved: Boolean = false
    private var isEditEmpty = true
    private var move = false
    private var mPoiSearch: PoiSearch? = null

    private var flagFrom: String = ""
    private var siteID: String? = null
    private var returnCity: String? = null
//    private var addrOrSiteType: String? = null
    private var siteDetailType: Int = 0
    private var mIndex = 0
    private var targetPos: Int = 0//点击左边某一个具体的item的位置
    private val allAreaList = ArrayList<String>()// 区域
    private val allSitesMap = HashMap<String, ArrayList<SiteBean2>>()// all sites map
    private val allDisplaySite = ArrayList<SiteBean2>()// child used all sites
    // area
    private var aAdapter: AreaAdapter? = null
    private var aManager: LinearLayoutManager? = null
    // site
    private var mDecoration: ItemDecoration? = null
    private var sAdapter: SiteAdapter? = null
    private var sManager: GridLayoutManager? = null
    // search result
    private var rAdapter: SearchAddressAdapter? = null

    private var resultListener: SiteResultListener? = null

    override fun getLayoutId(): Int {
        return R.layout.fragment_site_list
    }

    override fun initViews(view: View?, savedInstanceState: Bundle?) {
        LogUtil.e("SiteListFragment ---- initViews")
    }

    override fun initToolbar(savedInstanceState: Bundle?) {
        LogUtil.e("SiteListFragment ---- initToolbar")
    }

    override fun initListeners() {
        cityName.setOnClickListener(this)
        cancel.setOnClickListener(this)
        aAdapter?.setOnItemClickListener(this)
        sAdapter?.setOnItemClickListener(this)
        rAdapter?.setOnItemClickListener(this)
        siteRv?.addOnScrollListener(RecyclerViewListener())
        sAdapter?.setListener(object : SiteAdapter.ItemClick {
            override fun itemClick(siteBean: SiteBean2) {
                resultListener?.goSiteDetail(siteBean)
            }
        })
        searchBox?.setOnFocusChangeListener { _, hasFocus ->
            if (hasFocus) {
                hideList()
            } else {
                displayList()
            }
        }
        searchBox?.addTextChangedListener(object : TextWatcher {

            override fun onTextChanged(s: CharSequence, start: Int, before: Int, count: Int) {
                StatisticsUtil.onEvent(activity, ConstantsUtil.SEARCH_ADDRESS_INPUT, spUtil?.userCityName)
                if (s.isEmpty()) {
                    setBlankView()
                    return
                }
                mPoiSearch?.searchInCity(BaiDuUtil.setPoiOption(spUtil, s))
            }

            override fun beforeTextChanged(s: CharSequence, start: Int, count: Int, after: Int) {
            }

            override fun afterTextChanged(s: Editable) {
                isEditEmpty = s.isEmpty()
            }
        })
    }

    override fun initData() {
        // 搜索框是否显示
        searchLayout.visibility = if (flagFrom == SiteListActivity.TYPE_SITE_SEARCH_MAIN || flagFrom == SiteListActivity.TYPE_SITE_SEARCH_CARS) View.VISIBLE else View.GONE

        mPoiSearch = BaiDuUtil.initPoiOption(mPoiSearchResultListener)
        // Area
        aAdapter = AreaAdapter(activity)
        aManager = LinearLayoutManager(activity, LinearLayout.VERTICAL, false)
        areaRv.layoutManager = aManager
        val decoration = SimpleItemDecoration(activity, R.color.color_0)
        areaRv.addItemDecoration(decoration)
        // Site
        mDecoration = ItemDecoration(activity, allDisplaySite)
        sAdapter = SiteAdapter(activity)
        sManager = GridLayoutManager(activity, 1)
        siteRv.layoutManager = sManager
        // search
        rAdapter = SearchAddressAdapter(activity)

        cityName.text = spUtil?.userCityName
    }

    override fun onClick(v: View?) {
        when (v?.id) {
        // 切换城市
            R.id.cityName -> {
                StatisticsUtil.onEvent(activity, ConstantsUtil.SEARCK_ADDRESS_CITY, ConstantsUtil.SEARCK_ADDRESS_CITY)
                val intent = Intent(activity, ChangeCityActivity::class.java)
                intent.putExtra("flag", ChangeCityActivity.CITY_FOR_NAME_CONFIG)
                startActivityForResult(intent, CarEntity.REQUEST_CHANGE_CITY)
            }
            R.id.cancel -> {
                cancelSearch()
            }
        }
    }

    private fun cancelSearch() {
        searchLayout.isFocusable = true
        searchLayout.isFocusableInTouchMode = true
        searchLayout.requestFocus()
        searchLayout.findFocus()
        searchBox?.text = null
        val v = activity.currentFocus
        v?.clearFocus()
        val imm = activity.getSystemService(Context.INPUT_METHOD_SERVICE) as InputMethodManager
        if (v != null && imm.isActive) {
            imm.hideSoftInputFromWindow(v.windowToken, 0)
        }
    }

    override fun onItemClick(v: View?, position: Int) {
        when (v?.id) {
            R.id.areaLayout -> {
                LogUtil.e("area list onItemClick ----- " + position)
                isMoved = true
                targetPos = position
                setChecked(position, true)
            }
            R.id.siteLayout -> {
                val siteBean = sAdapter?.getItem<SiteBean2>(position)
                if (siteBean != null) {
                    resultListener?.siteResult(siteBean)
                }
            }
            R.id.search_address_main_view -> {
                val poiInfo = rAdapter?.getItem<PoiInfo>(position)
                if (poiInfo != null) {
                    resultListener?.poiResult(poiInfo)
                }
            }
        }
    }

    override fun check(position: Int, isScroll: Boolean) {
        setChecked(position, isScroll)
    }

    /**
     * 初始化页面参数
     * */
    fun setInitData(flag: String?, siteId: String?, city: String?,  siteDetailType: Int) {
        this.flagFrom = flag.toString()
        this.siteID = siteId
        this.returnCity = city
        this.siteDetailType = siteDetailType
    }

    fun setListData(result: ArrayList<SiteBean2>?) {
        allAreaList.clear()
        allSitesMap.clear()
        allDisplaySite.clear()
        cancelSearch()

//把“很抱歉。。。”页面隐藏掉
        displayList()
        if (result != null) {
            val nearbySiteList = ArrayList<SiteBean2>()// nearby
            val airportSiteList = ArrayList<SiteBean2>()// 机场
            for (i in 0 until result.size) {
                val site = result[i]
                val siteArea = site.area
                val siteCategory = site.category
                val siteGPS = LatLng(site.location?.lat ?: 0.0, site.location?.lng ?: 0.0)
                val distance = (DistanceUtil.getDistance(siteGPS, LatLng(spUtil?.initLocationPointLat?.toDouble() ?: 0.0,
                        spUtil?.initLocationPointLng?.toDouble() ?: 0.0))).toInt()
//                LogUtil.e("distance -----> " + distance)
                // 计算距离
                site.distance = distance
                // 添加附近
                if (distance <= 5 * 1000) {
                    val newSiteBean = site.deepCopy() as SiteBean2
                    newSiteBean.area = SiteListActivity.NEARBY_AREA
                    nearbySiteList.add(newSiteBean)
                }
                // 机场/火车站
                if (!siteCategory.equals("OTHER", ignoreCase = true)) {
                    val newSiteBean = site.deepCopy() as SiteBean2
                    newSiteBean.area = SiteListActivity.AIRPORT_AREA
                    airportSiteList.add(newSiteBean)
                }
                // 区域
                if (!allAreaList.contains(siteArea))
                    allAreaList.add(siteArea.toString())
                // 整合网点到sites
                addAllSitesToMap(allSitesMap, siteArea.toString(), site)
            }
            // 附近排序
            LocationUtil.sortAllSiteList(nearbySiteList)
            LogUtil.e("nearbySiteList" + nearbySiteList.toString())
            // 加入火车站网点
            if (airportSiteList.size > 0) {
                allSitesMap.put(SiteListActivity.AIRPORT_AREA, airportSiteList)
                allAreaList.add(0, SiteListActivity.AIRPORT_AREA)
            }
            // 加入附近网点
            if (nearbySiteList.size > 0) {
                allSitesMap.put(SiteListActivity.NEARBY_AREA, nearbySiteList)
                allAreaList.add(0, SiteListActivity.NEARBY_AREA)
            }
            // 为每个site，添加index, 是否title
            // 生成一个大的list; List<SiteBean2>, 包含所有显示数据
            for (i in allAreaList.indices) {
                val areaName = allAreaList[i]
                val siteOfArea = allSitesMap[areaName]
                val siteBean = SiteBean2()
                siteBean.key_index = i
                siteBean.itemType = SiteBean2.TYPE_TITLE
                siteBean.name = areaName
                siteBean.area = areaName
                allDisplaySite.add(siteBean)
                if (siteOfArea != null) {
                    for (j in siteOfArea.indices) {
                        val siteBean2 = siteOfArea[j]
                        siteBean2.key_index = i
                        if (areaName == SiteListActivity.NEARBY_AREA)
                            siteBean2.itemType = SiteBean2.TYPE_DISTANCE
                        else
                            siteBean2.itemType = SiteBean2.TYPE_NO_DISTANCE
                        allDisplaySite.add(siteBean2)
                    }
                }
            }
        }
        aAdapter?.list = allAreaList
        areaRv.adapter = aAdapter
        mDecoration?.setData(allDisplaySite)
        mDecoration?.setCheckListener(this)
        siteRv?.addItemDecoration(mDecoration)
        sAdapter?.list = allDisplaySite
        siteRv?.adapter = sAdapter
        LogUtil.e("siteRv" + siteRv.width)
    }

    private fun addAllSitesToMap(sites: HashMap<String, ArrayList<SiteBean2>>, siteArea: String, site: SiteBean2) {
        if (!sites.containsKey(siteArea)) {
            val siteList = ArrayList<SiteBean2>()
            siteList.add(site)
            sites.put(siteArea, siteList)
        } else {
            val siteList = sites[siteArea]
            if (siteList != null) {
                siteList.add(site)
                sites.put(siteArea, siteList)
            }
        }
    }

    private fun setChecked(position: Int, isLeft: Boolean) {
        LogUtil.e("setChecked position ----- $position")
        if (isLeft) {
            aAdapter?.setCheckedPosition(position)
            //此处的位置需要根据每个分类的集合来进行计算
            val count = getChildIndex(allSitesMap, allAreaList, position)
            selectedIndex(count)
            ItemDecoration.setCurrentTag(targetPos)//凡是点击左边，将左边点击的位置作为当前的tag
        } else {
            if (isMoved) {
                isMoved = false
            } else
                aAdapter?.setCheckedPosition(position)
            ItemDecoration.setCurrentTag(position)//如果是滑动右边联动左边，则按照右边传过来的位置作为tag
        }
        moveToCenter(position)
    }

    private fun moveToCenter(position: Int) {
        //将点击的position转换为当前屏幕上可见的item的位置以便于计算距离顶部的高度，从而进行移动居中
        val first = aManager?.findFirstVisibleItemPosition() ?: 0
        val childAt = areaRv.getChildAt(position - first)
        if (childAt != null) {
            val y = childAt.top - areaRv.height / 2
            areaRv.scrollBy(0, y)//moothS
        }
    }

    /**
     * 点击定位
     * */
    private fun selectedIndex(n: Int) {
        mIndex = n
        siteRv?.stopScroll()
        smoothMoveToPosition(n)
    }

    /**
     * recyclerView 滚动定位
     * */
    private fun smoothMoveToPosition(n: Int) {
        LogUtil.e("smoothMoveToPosition --- $n")
        val firstItem = sManager?.findFirstVisibleItemPosition() ?: 0
        val lastItem = sManager?.findLastVisibleItemPosition() ?: 0
        LogUtil.e("first --- $firstItem ----- lastItem --- $lastItem")
        when {
            n <= firstItem -> {
                LogUtil.e("n <= firstItem")
                siteRv?.scrollToPosition(n)//scrollToPosition(n)
            }
            n <= lastItem -> {
                LogUtil.e("n <= lastItem")
                val top = siteRv?.getChildAt(n - firstItem)?.top
                siteRv?.scrollBy(0, top ?: 0)
            }
            else -> {
                LogUtil.e("else")
                siteRv?.scrollToPosition(n)
                move = true
            }
        }
    }

    /**
     * recyclerView 滑动监听
     * */
    private inner class RecyclerViewListener : RecyclerView.OnScrollListener() {
        override fun onScrollStateChanged(recyclerView: RecyclerView?, newState: Int) {
            super.onScrollStateChanged(recyclerView, newState)
            if (move && newState == RecyclerView.SCROLL_STATE_IDLE) {
                move = false
                val n = mIndex - (sManager?.findFirstVisibleItemPosition() ?: 0)
                LogUtil.e("onScrollStateChanged n ----- " + n)
                if (0 <= n && n < siteRv?.childCount ?: 0) {
                    val top = siteRv?.getChildAt(n)?.top
                    LogUtil.e("onScrollStateChanged top ----- " + top)
                    siteRv?.scrollBy(0, top ?: 0)//moothS
                }
            }
        }

        override fun onScrolled(recyclerView: RecyclerView?, dx: Int, dy: Int) {
            super.onScrolled(recyclerView, dx, dy)
            if (move) {
                move = false
                val n = mIndex - (sManager?.findFirstVisibleItemPosition() ?: 0)
                LogUtil.e("onScrolled n ----- " + n)
                if (0 <= n && n < siteRv?.childCount ?: 0) {
                    val top = siteRv?.getChildAt(n)?.top
                    LogUtil.e("onScrolled top ----- " + top)
                    siteRv?.scrollBy(0, top ?: 0)
                }
            }
        }
    }

    /**
     * 计算右侧RecyclerView index
     * */
    private fun getChildIndex(sites: HashMap<String, ArrayList<SiteBean2>>, areaList: List<String>, areaNameIndex: Int): Int {
        var count = 0
        for (i in 0 until areaNameIndex) {
            // 每个区域的网点个数+1
            count += (sites[areaList[i]]?.size ?: 0) + 1
        }
        return count
    }

    private val mPoiSearchResultListener = object : OnGetPoiSearchResultListener {
        override fun onGetPoiDetailResult(arg0: PoiDetailResult) {}

        override fun onGetPoiIndoorResult(arg0: PoiIndoorResult) {}

        override fun onGetPoiResult(result: PoiResult?) {
            if (result == null || result.error == SearchResult.ERRORNO.RESULT_NOT_FOUND) {
                setEmptyDataVisibility(true)
                return
            }
            // 没有输入内容，不要显示POI结果
            if (isEditEmpty)
                return
            if (result.error == SearchResult.ERRORNO.NO_ERROR) {
                val poiInfoList = result.allPoi
                if (poiInfoList == null) {
                    LogUtil.e("poiInfoList == null")
                    return
                }
                val filterPoiInfoList = ArrayList<PoiInfo>()
                for (poiInfo in poiInfoList) {
                    LogUtil.e("poiInfo.address = " + poiInfo.address + " ; poiInfo.city = " + poiInfo.city + "; poiInfo.name = " + poiInfo.name)
                    if (poiInfo.city.startsWith(spUtil?.userCityName.toString()))
                        filterPoiInfoList.add(poiInfo)
                }
                setEmptyDataVisibility(Util.isListEmpty(filterPoiInfoList))
                rAdapter?.list = filterPoiInfoList
                resultRv.adapter = rAdapter
            }
        }
    }

    private fun setEmptyDataVisibility(emptyDataVisibility: Boolean) {
        resultRv.visibility = if (emptyDataVisibility) View.GONE else View.VISIBLE
        emptyData.visibility = if (emptyDataVisibility) View.VISIBLE else View.GONE
    }

    private fun setBlankView() {
        resultRv.visibility =  View.GONE
        emptyData.visibility = View.GONE
    }



    fun changeCity(city: String?){
        searchBox.text = null
        cityName.text = city
    }

    private fun hideList() {
        resultLayout.visibility = View.VISIBLE
        cancel.visibility = View.VISIBLE
        areaRv.visibility = View.GONE
        siteRv.visibility = View.GONE
    }

    private fun displayList() {
        areaRv.visibility = View.VISIBLE
        siteRv.visibility = View.VISIBLE
        resultLayout.visibility = View.GONE
        cancel.visibility = View.GONE
    }

    fun setListener(listener: SiteResultListener?) {
        this.resultListener = listener
    }

    interface SiteResultListener {
        fun siteResult(siteBean: SiteBean2)
        fun poiResult(poiInfo: PoiInfo)
        fun goSiteDetail(siteBean: SiteBean2)
    }
}