package com.jiaoyinbrother.monkeyking.fragment

import android.os.Bundle
import android.view.View
import com.baidu.mapapi.map.*
import com.baidu.mapapi.model.LatLng
import com.jiaoyinbrother.monkeyking.CarEntity
import com.jiaoyinbrother.monkeyking.R
import com.jiaoyinbrother.monkeyking.util.BaiDuUtil
import com.jiaoyinbrother.monkeyking.util.SharedPreferencesUtil
import com.jiaoyinbrother.monkeyking.view.SiteView
import com.jybrother.sineo.library.base.BaseFragment
import com.jybrother.sineo.library.bean.SiteBean2
import com.jybrother.sineo.library.util.LogUtil
import kotlinx.android.synthetic.main.fragment_site_map.*

/**
 * The Author : Soda
 * Created on 2018/01/05.
 */
class SiteMapFragment : BaseFragment() {

    private var bdMap: BaiduMap? = null
    private val mItems = ArrayList<Marker>()
    private val spUtil = SharedPreferencesUtil.getInstance()
    private var mData: ArrayList<SiteBean2>? = null

    override fun getLayoutId(): Int {
        return R.layout.fragment_site_map
    }

    override fun initViews(view: View?, savedInstanceState: Bundle?) {
    }

    override fun initToolbar(savedInstanceState: Bundle?) {
        LogUtil.e("SiteMapFragment ---- initViews")
    }

    override fun initListeners() {
        // 返回值 boolean 类型, 点击地图 marker 事件
        bdMap?.setOnMarkerClickListener({ marker ->
            bdMap?.hideInfoWindow()
            val index = mItems.indexOf(marker)
            LogUtil.e("index = " + index)
            val builder = MapStatus.Builder()
            builder.target(marker.position).zoom(CarEntity.MAP_ZOOM.toFloat())
            bdMap?.setMapStatus(MapStatusUpdateFactory.newMapStatus(builder.build()))
            // 启动网点详细信息界面
            val siteView = SiteView(activity, mData?.get(index), SiteView.SITEVIEW_TYPE_SITE)
            val mInfoWindow = InfoWindow(siteView, marker.position, SiteView.SITEVIEW_POS)
            bdMap?.showInfoWindow(mInfoWindow)
            true
        })
    }

    override fun initData() {
        bdMap = BaiDuUtil.initBDMapOption(mapView, spUtil)
    }

    /**
     * 初始化地图网点overlay
     */
    fun setOverlayData(result: ArrayList<SiteBean2>?) {
        if ((null == mapView) || result?.size == 0)
            return
        bdMap?.clear()
        mItems.clear()
        // 准备overlay 数据
        val tmpMap = HashMap<LatLng, LatLng>()
        var repeatCount = 0
        var latLng: LatLng
        var markIcon = BitmapDescriptorFactory.fromResource(R.mipmap.icon_mark_site)
        if (result != null) {
            mData = result
            for (site in result) {
                val loc = site.location
                latLng = LatLng(loc?.lat ?: 0.0, loc?.lng ?: 0.0)
                if (tmpMap.containsKey(latLng)) {
                    ++repeatCount
                    latLng = LatLng(loc?.lat ?: 0.0, loc?.lng ?: 0.0 + 3000 * repeatCount)
                }
                val ooA = MarkerOptions().position(latLng).icon(markIcon)
                        .zIndex(9).draggable(true).animateType(MarkerOptions.MarkerAnimateType.grow)
                tmpMap.put(latLng, latLng)
                mItems.add(bdMap?.addOverlay(ooA) as Marker)
            }
        }
    }

    override fun onDestroy() {
        super.onDestroy()
        if (bdMap != null) {
            bdMap?.clear()
            bdMap = null
        }
    }
}