package com.jiaoyinbrother.monkeyking.fragment

import android.app.Activity
import android.content.Intent
import android.net.Uri
import android.os.Bundle
import android.os.Environment
import android.provider.MediaStore
import android.support.v4.content.ContextCompat
import android.support.v7.widget.GridLayoutManager
import android.view.View
import com.camnter.easyrecyclerview.holder.EasyRecyclerViewHolder
import com.jiaoyinbrother.monkeyking.CarEntity
import com.jiaoyinbrother.monkeyking.R
import com.jiaoyinbrother.monkeyking.activity.GeneralWebViewActivity
import com.jiaoyinbrother.monkeyking.activity.ShowBigImageActivity
import com.jiaoyinbrother.monkeyking.activity.TakingPicturesActivity
import com.jiaoyinbrother.monkeyking.adapter.TakingPicAdapter
import com.jiaoyinbrother.monkeyking.network.AppSetting
import com.jybrother.sineo.library.base.BaseFragment
import com.jybrother.sineo.library.bean.*
import com.jybrother.sineo.library.impl.UploadListener
import com.jybrother.sineo.library.util.*
import kotlinx.android.synthetic.main.fragment_taking_pick.*
import kotlinx.android.synthetic.main.layout_taking_status.*
import java.io.File
import kotlin.collections.ArrayList

/**
 * by Soda on 2018/1/25.
 */
//@SuppressLint("ValidFragment")
class TakingPicFragment : BaseFragment(),
        View.OnClickListener, EasyRecyclerViewHolder.OnItemClickListener {

    private val path = Environment.getExternalStorageDirectory().toString() + File.separator + Environment.DIRECTORY_DCIM + File.separator
    private var picUtil: AliYunPictureUtil? = null
    private var mAdapter: TakingPicAdapter? = null
    private var listener: TakingPicListener? = null

    // local request
    private var photoUri0: Uri? = null
    private var photoUri1: Uri? = null
    private var photoUri2: Uri? = null
    private var photoUri3: Uri? = null

    private var flag: String? = null
    private var mOrderResult: OrderDetailResult? = null
    private var mTakingPciBean = TakingPicBean()
    private var picUrlArray = arrayOf("", "", "", "")


    override fun getLayoutId(): Int {
        val bundle = arguments
        flag = bundle.getString("fromFlag") ?: ""
        mOrderResult = bundle.getSerializable(ConstantsUtil.ORDER_RESULT) as OrderDetailResult
        LogUtil.e("flag -- $flag ; OrderDetail -- $mOrderResult")
        return R.layout.fragment_taking_pick
    }

    override fun initViews(view: View?, savedInstanceState: Bundle?) {
        LogUtil.e("TakingPicFragment ----- initViews")
    }

    override fun initToolbar(savedInstanceState: Bundle?) {
        LogUtil.e("TakingPicFragment ----- initToolbar")
    }

    override fun initListeners() {
        theSample.setOnClickListener(this)
        mAdapter?.setOnItemClickListener(this)
    }

    @Suppress("DEPRECATION")
    override fun initData() {
        picUtil = AliYunPictureUtil.getInstance(activity)

        val mManager = GridLayoutManager(activity, 2)
        takingPicRv.layoutManager = mManager
        takingPicRv.isNestedScrollingEnabled = false
        mAdapter = TakingPicAdapter(activity)

        reminding.text = if (flag == TakingPicturesActivity.FLAG_TAKE_PIC)
            resources.getString(R.string.take_pic_reminding)
        else
            resources.getString(R.string.return_pic_reminding)

        prompt.text = TextUtil.setForegroundColor(getString(R.string.take_pic_prompt),
                ContextCompat.getColor(activity, R.color.color_5), 8, 22)

        val drawable = resources.getDrawable(R.mipmap.ic_b_q)
        drawable.setBounds(0, 0, drawable.minimumWidth / 2, drawable.minimumHeight / 2)
        theSample.setCompoundDrawables(null, null, drawable, null)

        mAdapter?.list = defaultList(mOrderResult)
        mTakingPciBean.picBean = defaultList(mOrderResult)// 4张图片的状态
        takingPicRv.adapter = mAdapter

        initShowLayout(flag, mOrderResult)
    }

    private fun defaultList(result: OrderDetailResult?): ArrayList<PicBean> {
        return when (flag) {
            TakingPicturesActivity.FLAG_TAKE_PIC -> getCarImgList(result?.take_car_image)
            else -> getCarImgList(result?.return_car_image)
        }
    }

    private fun getCarImgList(carImgAuth: CarImgAuthBean?): ArrayList<PicBean> {
        val carImgList = ArrayList<PicBean>()
        if (carImgAuth == null || carImgAuth.status_code == 0) {// init data
            for (i in 0..3) {
                val bean = PicBean()
                carImgList.add(bean)
            }
        } else {// order detail result data
            for (url in carImgAuth.pics ?: ArrayList()) {
                val picBean = PicBean()
                picBean.url = url
                picBean.status = TakingPicBean.PIC_SUCC
                carImgList.add(picBean)
            }
        }
        return carImgList
    }

    /**
     * init layout
     * */
    private fun initShowLayout(fromFlag: String?, result: OrderDetailResult?) {
        try {
            when (fromFlag) {
                TakingPicturesActivity.FLAG_TAKE_PIC -> {// 取车
                    statusLayout.visibility = View.GONE
                    if (result?.take_car_image != null) {
                        remindingLayout.visibility = View.GONE
                        promptLayout.visibility = View.GONE
                    }

                }
                TakingPicturesActivity.FLAG_RETURN_PIC -> {// 还车
                    status1.setBackgroundResource(R.mipmap.h_f)
                    status2.setBackgroundResource(R.mipmap.h_2)
                    tvDeposit.setTextColor(ContextCompat.getColor(activity, R.color.color_6))
                    tvTakingPic.setTextColor(ContextCompat.getColor(activity, R.color.color_6))
                    statusLayout.visibility = View.VISIBLE
                    remindingLayout.visibility = View.VISIBLE
                    promptLayout.visibility = View.VISIBLE
                }
                TakingPicturesActivity.FLAG_RETURN_FINISH -> {
                    status1.setBackgroundResource(R.mipmap.h_f)
                    status2.setBackgroundResource(R.mipmap.h_2)
                    tvDeposit.setTextColor(ContextCompat.getColor(activity, R.color.color_6))
                    tvTakingPic.setTextColor(ContextCompat.getColor(activity, R.color.color_6))
                    if (result?.return_car_image != null) {// 已经提交认证
                        when (result.return_car_image?.status_code) {
                            0 -> {// 认证失败
                                //TODO 认证失败后 应该展示什么页面
                            }
                            1 -> {// 认证通过
                                statusLayout.visibility = View.GONE
                                remindingLayout.visibility = View.GONE
                                promptLayout.visibility = View.GONE
                            }
                            2 -> {// 认证中
                                statusLayout.visibility = View.VISIBLE
                                remindingLayout.visibility = View.VISIBLE
                                promptLayout.visibility = View.VISIBLE
                            }
                        }
                    }
                }
            }
        } catch (e: Exception) {
        }
    }


    private fun isActivate(fromFlag: String?): Boolean {
        when (fromFlag) {
            TakingPicturesActivity.FLAG_TAKE_PIC -> return mOrderResult?.take_car_image == null

            else -> {
                if (mOrderResult?.return_car_image == null)
                    return true
                else {
                    var carImgAuthBean: CarImgAuthBean? = mOrderResult?.return_car_image
                    return if (carImgAuthBean == null)
                        false
                    else
                        carImgAuthBean?.status == "NOAUTH"

                }
            }
        }
    }

    private fun chooseUri(requestCode: Int): Uri? {

        return when (requestCode) {
            0 -> photoUri0
            1 -> photoUri1
            2 -> photoUri2
            else -> photoUri3
        }
    }


    override fun onClick(v: View?) {
        when (v?.id) {
            R.id.theSample -> startTakePicH5()
        }
    }

    /**
     * H5 拍照示例
     */
    private fun startTakePicH5() {
        val webViewConfigEntity = WebViewConfigEntity()
        webViewConfigEntity.title = "拍照示例"
        webViewConfigEntity.isNeedProgressBar = true
        webViewConfigEntity.url = AppSetting.getText_url() + "/app/photoExample/index.html"
        webViewConfigEntity.isNeedShareButton = false
        val intent = Intent(this.activity, GeneralWebViewActivity::class.java)
        intent.putExtra(CarEntity.FEATURE_ITEM, webViewConfigEntity)
        this.activity.startActivity(intent)
    }

    override fun onItemClick(viewHolder: View?, position: Int) {
        if (isActivate(flag)) {
            when (mTakingPciBean.picBean?.get(position)?.status) {
                TakingPicBean.PIC_DEF -> {
                    takingPhoto(position)
                }
                TakingPicBean.PIC_SUCC -> {
                    val intent = Intent(activity, ShowBigImageActivity::class.java)
                    intent.putExtra("IMG_URL", picUrlArray[position])
                    startActivityForResult(intent, position)

                }
                TakingPicBean.PIC_FAIL -> {
                    picUtil?.setData(chooseUri(position)?.path, picListener)
                }
            }
        }
    }

    private fun takingPhoto(position: Int) {
        LogUtil.e("takingPhoto")
        val state = Environment.getExternalStorageState()
        if (state == Environment.MEDIA_MOUNTED) {
            val file = File(path)
            if (!file.exists())
                file.mkdir()
            val intent = Intent(MediaStore.ACTION_IMAGE_CAPTURE)
            LogUtil.e("position" + position)
            LogUtil.e("getPhotoUri(position) =" + getPhotoUri(position))
            intent.putExtra(MediaStore.EXTRA_OUTPUT, getPhotoUri(position))
            startActivityForResult(intent, position)
        }
    }

    private fun getPhotoUri(position: Int): Uri? {
        LogUtil.e("getPhotoUri,position=" + position)
        val file = File(path + "IMG_$position.jpg")
        val uri = Uri.fromFile(file)
        when (position) {
            0 -> photoUri0 = uri
            1 -> photoUri1 = uri
            2 -> photoUri2 = uri
            3 -> photoUri3 = uri
        }
        LogUtil.e("getPhotoUri,uri=" + uri.toString())
        return uri
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        if (data == null) {
            if (resultCode == Activity.RESULT_OK) {
                LogUtil.e("data == null")
                setImageView(requestCode)
            }
        } else {
            if (resultCode == 3) {
                takingPhoto(requestCode)
            }
        }
    }

    private fun setImageView(requestCode: Int) {
        LogUtil.e("setImageView, requestCode = " + requestCode)
        mTakingPciBean.selected = requestCode
        mTakingPciBean.picBean?.get(requestCode)?.status = TakingPicBean.PIC_WAIT
        LogUtil.e("chooseUri(requestCode)?.path = " + chooseUri(requestCode)?.path)
        var bitmap = BitmapUtil.compressDefaultBitmap(chooseUri(requestCode)?.path)
        val degree = BitmapUtil.getBitmapDegree(chooseUri(requestCode)?.path)
        bitmap = BitmapUtil.rotateBitmapByDegree(bitmap, degree)
        BitmapUtil.saveBitmap(bitmap, chooseUri(requestCode)?.path)
        mTakingPciBean.picBean?.get(requestCode)?.picUri = chooseUri(requestCode)
        mTakingPciBean.picBean?.let { mAdapter?.upLoadPicUri(requestCode, it) }
        picUtil?.setData(chooseUri(requestCode)?.path, picListener)
    }

    private val picListener = UploadListener { net, local ->

        LogUtil.e("UploadListener")
        val position = when (local) {
            photoUri0?.path -> 0
            photoUri1?.path -> 1
            photoUri2?.path -> 2
            else -> 3
        }
        if (net.isNotEmpty()) {
            LogUtil.e("isNotEmpty")
            // success
            mTakingPciBean.picBean?.get(position)?.status = TakingPicBean.PIC_SUCC
            mTakingPciBean.picBean?.get(position)?.url = net
            activity.runOnUiThread { mTakingPciBean.picBean?.let { mAdapter?.upLoadPicUri(position, it) } }
            //通知Activity 按钮可用
            when (local) {
                photoUri0?.path -> picUrlArray[0] = net.toString()//.add(0, net.toString())
                photoUri1?.path -> picUrlArray[1] = net.toString()
                photoUri2?.path -> picUrlArray[2] = net.toString()
                else -> picUrlArray[3] = net.toString()
            }

        } else {
            LogUtil.e("isNotEmpty else")
            // failed
            //TODO 如果上传完四张照片后查看大图重拍，上传失败后时候要通知主页面按钮禁用
            mTakingPciBean.picBean?.get(position)?.status = TakingPicBean.PIC_FAIL
            mTakingPciBean.picBean?.get(position)?.url = null
            activity.runOnUiThread { mTakingPciBean.picBean?.let { mAdapter?.upLoadPicUri(position, it) } }

        }
        listener?.activeSubmit(picUrlArray)

        LogUtil.e("UploadListener end")
    }

    fun setData(orderResult: OrderDetailResult?, fromFlag: String?) {
        this.mOrderResult = orderResult
        initShowLayout(fromFlag, orderResult)
    }

    fun setListener(listener: TakingPicListener) {
        this.listener = listener
    }

    interface TakingPicListener {
        fun activeSubmit(array: Array<String>)
    }
}