package com.jiaoyinbrother.monkeyking.view

import android.content.Context
import android.text.format.DateUtils
import android.util.AttributeSet
import android.view.View
import android.widget.LinearLayout
import android.widget.ListView
import android.widget.Toast
import com.jiaoyinbrother.monkeyking.R
import com.jybrother.sineo.library.adapter.SiteInfoCommentListAdapter
import com.jybrother.sineo.library.bean.MarkBean
import com.jybrother.sineo.library.bean.SiteInfoCommentRequest
import com.jybrother.sineo.library.view.GeneralViewInterface
import com.jybrother.sineo.library.presenter.SiteInfoCommentPresenterImpl
import com.jybrother.sineo.library.util.LogUtil
import kotlinx.android.synthetic.main.layout_comment_list.view.*

/**
 * Created by zhangbo on 2018/1/4.
 */
class CommentListLayout @JvmOverloads constructor(
        context: Context, attrs: AttributeSet? = null, defStyleAttr: Int = 0
) : LinearLayout(context, attrs, defStyleAttr), View.OnClickListener, GeneralViewInterface {


    var adapter: SiteInfoCommentListAdapter? = null
    var type = ""
    private var mListView: ListView? = null
    private var mCommentType = ""
    private var mPageNum: Int = 1
    private var mSelectPage: Int = 1
    var siteid = ""
    var siteManagerid = ""
    private var presenter = SiteInfoCommentPresenterImpl(context, MarkBean::class.java)
    override fun onClick(v: View?) {
        mPageNum = 1
        when (v) {
            comment_layout_1 -> {
                check(1)
            }
            comment_layout_2 -> {
                check(2)
            }
            comment_layout_3 -> {
                check(3)
            }
            comment_layout_4 -> {
                check(4)
            }
        }
    }

    init {
        inflate(context, R.layout.layout_comment_list, this)
        comment_layout_1.setOnClickListener(this)
        comment_layout_2.setOnClickListener(this)
        comment_layout_3.setOnClickListener(this)
        comment_layout_4.setOnClickListener(this)
        adapter = SiteInfoCommentListAdapter(context)
        presenter.addListener(this)
        mListView = comment_layout_list.refreshableView
        mListView?.adapter = adapter


        comment_layout_list.setOnRefreshListener({ refreshView ->
            val label = DateUtils.formatDateTime(context, System.currentTimeMillis(),
                    DateUtils.FORMAT_SHOW_TIME or DateUtils.FORMAT_SHOW_DATE or DateUtils.FORMAT_ABBREV_ALL)
            refreshView.loadingLayoutProxy.setLastUpdatedLabel(label)
            mPageNum = 1
            check(mSelectPage)

        })


        comment_layout_list.setOnLastItemVisibleListener({
            mPageNum += 1
            check(mSelectPage)
        })

    }

    fun check(index: Int) {
        comment_layout_1_title.setTextColor(resources.getColor(R.color.color_4))
        comment_layout_2_title.setTextColor(resources.getColor(R.color.color_4))
        comment_layout_3_title.setTextColor(resources.getColor(R.color.color_4))
        comment_layout_4_title.setTextColor(resources.getColor(R.color.color_4))
        var request = SiteInfoCommentRequest()
        when (index) {
            1 -> {
                comment_layout_1_title.setTextColor(resources.getColor(R.color.color_6))
                mCommentType = ""
                mSelectPage = 1
            }
            2 -> {
                comment_layout_2_title.setTextColor(resources.getColor(R.color.color_6))
                mCommentType = "GOOD"
                mSelectPage = 2
            }
            3 -> {
                comment_layout_3_title.setTextColor(resources.getColor(R.color.color_6))
                mCommentType = "NEUTRAL"
                mSelectPage = 3
            }
            4 -> {
                comment_layout_4_title.setTextColor(resources.getColor(R.color.color_6))
                mCommentType = "BAD"
                mSelectPage = 4
            }
        }
        request.page_size = 10
        request.page = mPageNum
        if (mCommentType.isNotEmpty()) {
            request.type = mCommentType
        }
        if (type == TYPE_SITE)
            request.siteid = siteid
        else
            request.uid = siteManagerid
        presenter.requestSiteInfoComment(request)
    }

    fun initData(id: String, type: String) {

        if (type == TYPE_SITE) {
            personal_layout.visibility = View.GONE
            faint_line1.visibility = View.GONE
            think_line.visibility = View.GONE
            faint_line2.visibility = View.GONE
            this.siteid = id
        } else {
            personal_layout.visibility = View.VISIBLE
            faint_line1.visibility = View.VISIBLE
            think_line.visibility = View.VISIBLE
            faint_line2.visibility = View.VISIBLE
            this.siteManagerid = id
        }
        this.type = type
        check(1)
    }

    override fun getCodeBeanFail(errorCode: Int) {

    }

    override fun getCodeObjectSuccess(bean: Any?) {
        var markBean = bean as MarkBean
//        更新header
        name.text = "运营专员"
        phone.text = siteManagerid
        img_head.setImageURI(markBean.headimg_url)
        tv_commission_count.text = ((markBean.rate0)?.toFloat() ?: 5.0f).toString()
        rb_commission.rating = (markBean.rate0)?.toFloat() ?: 5.0f

        comment_layout_1_num.text = "(" + markBean.total + ")" //全部
        comment_layout_2_num.text = "(" + markBean.good + ")" //好评
        comment_layout_3_num.text = "(" + markBean.neutral + ")" //中评
        comment_layout_4_num.text = "(" + markBean.bad + ")" //差评

//        adapter?.list =  markBean.marks

        if (mPageNum == 1) {
            adapter?.initList(markBean.marks)
            LogUtil.e("mPageNum1->" + mPageNum)
            mListView?.smoothScrollToPosition(0)
        } else {
            adapter?.addList(markBean.marks)
            LogUtil.e("mPageNum2->" + mPageNum)
        }
            if (markBean.marks != null && markBean.marks!!.size > 0) {

            } else {
                if (mPageNum > 1){
                    Toast.makeText(context, "已经全部加载完毕", Toast.LENGTH_SHORT).show()
                }
            }
        comment_layout_list.onRefreshComplete()
    }


    companion object {
        val TYPE_SITE = "1"
        val TYPE_PERSON = "2"
    }
}